/*  Projekt CDMA
	 Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        akfchild.cpp
	 AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Quelltextdatei fuer die Implementation von AKFChild (TMDIChild).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "akfchild.h"

#include "pnapp.h"

#include <stdio.h>


//{{AKFChild Implementation}}


//
// Antworttabelle fuer alle von AKFChild behandelten Botschaften /
// Befehle generieren
//
DEFINE_RESPONSE_TABLE1(AKFChild, TMDIChild)
//{{AKFChildRSP_TBL_BEGIN}}
	 EV_WM_GETMINMAXINFO,
	 EV_WM_MOUSEMOVE,
//{{AKFChildRSP_TBL_END}}
END_RESPONSE_TABLE;


//////////////////////////////////////////////////////////
// AKFChild
// ==========
// Konstruktor/Destruktor
AKFChild::AKFChild (TMDIClient &parent, const char far *title, TWindow *clientWnd, BOOL shrinkToClient, TModule *module)
	 : TMDIChild (parent, title, clientWnd == 0 ? new TWindow(0, "") : clientWnd, shrinkToClient, module)
{
	 // EINFUEGEN>> Ihren Konstruktor-Code fuegen Sie hier ein
		 Attr.Style |= WS_BORDER | WS_CAPTION | WS_CHILD | WS_CLIPCHILDREN  | WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_SYSMENU | WS_THICKFRAME | WS_VISIBLE;
//		 Attr.W = 628;
//		 Attr.H = 300;
}


AKFChild::~AKFChild ()
{
    Destroy();


}


//
// Paint-Routine fuer Fenster, Drucker und Druckvorschau fuer ein TEdit-Client.
//
void AKFChild::Paint (TDC&, BOOL, TRect& rect)
{
    pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
    if (theApp) {
        // Paint nur beim Ausdruck und wenn etwas Druckbares vorhanden ist
        if (theApp->Printing && theApp->Printer && !rect.IsEmpty()) {
            // pageSize fuer die Groessenberechnung verwenden. Fuer Fenster: Client-Bereich
            // fuer Drucker: DC-Dimensionen, fuer Druckvorschau: Layout-Fenster
            TSize   pageSize(rect.right - rect.left, rect.bottom - rect.top);

        }
    }
}


void AKFChild::EvGetMinMaxInfo (MINMAXINFO far& minmaxinfo)
{
    pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
    if (theApp) {
        if (theApp->Printing) {
            minmaxinfo.ptMaxSize = TPoint(32000, 32000);
            minmaxinfo.ptMaxTrackSize = TPoint(32000, 32000);
            return;
        }
    }
    TMDIChild::EvGetMinMaxInfo(minmaxinfo);
}

void AKFChild::EvMouseMove (UINT modKeys, TPoint& point)
{
    TMDIChild::EvMouseMove(modKeys, point);

    // EINFUEGEN>> Ihren Code fuegen Sie hier ein
    MessageBox("Maus","Move",MB_OK);
}










































