/*  Projekt CDMA
	 Copyright  1995

    SYSTEM:       CDMA.EXE  (Application)
    DATEI:        akfdialg.cpp
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Quelltextdatei fuer die Implementation von AKFDialog (TDialog).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "akfdialg.h"
#include <string.h>


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(AKFDialog, TDialog)
//{{AKFDialogRSP_TBL_BEGIN}}
	 EV_EN_CHANGE(IDC_EDITLAENGE, lenENChange),
	 EV_BN_CLICKED(IDC_CHECK1PER, check1perBNClicked),
	 EV_BN_CLICKED(IDC_CHECK2PER, check2perBNClicked),
	 EV_BN_CLICKED(IDC_CHECKVAR, checkvarBNClicked),
    EV_BN_CLICKED(IDC_CHECKBIPOLAR, checkbipolarBNClicked),
	 EV_BN_CLICKED(IDC_CHECKPAKF, checkpakfBNClicked),
    EV_BN_CLICKED(IDC_CHECKINVAKF, checkinvakfBNClicked),
    EV_EN_UPDATE(IDC_EDITLAENGE, lenENUpdate),
    EV_BN_CLICKED(IDC_CHECKPAR1, checkpar1BNClicked),
    EV_BN_CLICKED(IDC_CHECKPAR2, checkpar2BNClicked),
    EV_BN_CLICKED(IDC_B, check_B_BNClicked),
    EV_BN_CLICKED(IDC_D, check_D_BNClicked),
    EV_BN_CLICKED(IDC_E, check_E_BNClicked),
    EV_BN_CLICKED(IDC_E1, check_E1_BNClicked),
    EV_BN_CLICKED(IDC_E2, check_E2_BNClicked),
    EV_BN_CLICKED(IDC_N, check_N_BNClicked),
    EV_BN_CLICKED(IDC_Q, check_Q_BNClicked),
    EV_BN_CLICKED(IDC_R, check_R_BNClicked),
    EV_BN_CLICKED(IDC_S, check_S_BNClicked),
    EV_BN_CLICKED(IDC_V, check_V_BNClicked),
	 EV_BN_CLICKED(IDC_X1, check_X1_BNClicked),
    EV_BN_CLICKED(IDC_X2, check_X2_BNClicked),
    EV_BN_CLICKED(IDC_XTKR, check_XTKR_BNClicked),
//{{AKFDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{AKFDialog Implementation}}



AKFDialog::AKFDialog (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
//{{AKFDialogXFER_USE}}
	 check1per = new TCheckBox(this, IDC_CHECK1PER, 0);
	 check2per = new TCheckBox(this, IDC_CHECK2PER, 0);
	 checkvar = new TCheckBox(this, IDC_CHECKVAR, 0);
	 editlen = new TEdit(this, IDC_EDITLAENGE, 255);
	 checkpar1 = new TCheckBox(this, IDC_CHECKPAR1, 0);
	 checkpakf = new TCheckBox(this, IDC_CHECKPAKF, 0);
	 checkbipolar = new TCheckBox(this, IDC_CHECKBIPOLAR, 0);
	 checkinvakf = new TCheckBox(this, IDC_CHECKINVAKF, 0);
	 checkpar2 = new TCheckBox(this, IDC_CHECKPAR2, 0);
    staticsignal = new TStatic(this, ID_STATICSIGNAL, 255);
	 AKFold=AKF;
	 SetTransferBuffer(&AKF);
//{{AKFDialogXFER_USE_END}}

	 // EINFUEGEN>> Ihren Konstruktor-Code fuegen Sie hier ein
//	 AKF.checkpar1 = TRUE;
}
AKFDialog::~AKFDialog ()
{
    Destroy();

	 // EINFUEGEN>> Ihren Destruktor-Code fuegen Sie hier ein

}


void AKFDialog::lenENChange ()
{




}





void AKFDialog::check1perBNClicked ()
{
	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein

	if (check1per->GetCheck())
	  {
		  wsprintf(AKF.editlen,"%d",folglen);
		  editlen->Transfer(AKF.editlen,tdSetData);
		  check2per->Uncheck();
		  checkvar->Uncheck();
	  }
	else
	  {
		  wsprintf(AKF.editlen,"%d",2*folglen);
		  editlen->Transfer(AKF.editlen,tdSetData);
		  check2per->Check();
		  checkvar->Uncheck();
	  }



}


void AKFDialog::check2perBNClicked ()
{

	if (check2per->GetCheck())
	  {
		  wsprintf(AKF.editlen,"%d",2*folglen);
		  editlen->Transfer(AKF.editlen,tdSetData);
		  check1per->Uncheck();
		  checkvar->Uncheck();
	  }
	else
	  {
		  wsprintf(AKF.editlen,"%d",folglen);
		  editlen->Transfer(AKF.editlen,tdSetData);
		  check1per->Check();
		  checkvar->Uncheck();
	  }




}


void AKFDialog::checkvarBNClicked ()
{

	if (checkvar->GetCheck())
	  {
		  check1per->Uncheck();
		  check2per->Uncheck();
	  }
	else
	  {
		  wsprintf(AKF.editlen,"%d",folglen);
		  editlen->Transfer(AKF.editlen,tdSetData);
		  check1per->Check();
		  check2per->Uncheck();
	  }




}


BOOL AKFDialog::CanClose ()
{
	 BOOL result;

	 result = TDialog::CanClose();

	 TransferData(tdGetData);
	 AKFneu.checkbipolar = checkbipolar->GetCheck();
	 AKFneu.checkinvakf = checkinvakf->GetCheck();
	 AKFneu.checkpakf = checkpakf->GetCheck();
	 AKFneu.checkpar1 = checkpar1->GetCheck();
	 AKFneu.checkpar2 = checkpar2->GetCheck();


	 bildlen = atoi(AKF.editlen);
	 if (bildlen < 1) bildlen=folglen;

	 return result;
}


void AKFDialog::checkbipolarBNClicked ()
{
	if (checkbipolar->GetCheck() == BF_UNCHECKED) BIPOLAR=FALSE;
	  else
		  BIPOLAR = TRUE;

}


void AKFDialog::checkpakfBNClicked ()
{
	if (checkpakf->GetCheck() == BF_UNCHECKED)
		{
			INVAKF=FALSE;
			PAKF=FALSE;
			checkinvakf->Uncheck();
		}
	  else
		PAKF = TRUE;

}


void AKFDialog::checkinvakfBNClicked ()
{
	if (checkinvakf->GetCheck() == BF_UNCHECKED) INVAKF=FALSE;
	  else
		{
			INVAKF=TRUE;
			PAKF=TRUE;
			checkpakf->Check();
		}
}


void AKFDialog::SetupWindow ()
{
	 TDialog::SetupWindow();

//editlen->Transfer(AKF.editlen,tdSetData);
	 staticsignal->SetText(s);
	 
}


void AKFDialog::Initialisierung()
{
AKF.check1per = BF_CHECKED;
AKF.check2per = BF_UNCHECKED;
AKF.checkvar = BF_UNCHECKED;
wsprintf(AKF.editlen,"%d",folglen);
AKF.checkpar1 = BF_CHECKED;
AKF.checkpar2 = BF_UNCHECKED;

AKF.checkpakf = BF_CHECKED;
AKF.checkinvakf = BF_UNCHECKED;
AKF.checkbipolar = BF_CHECKED;
BIPOLAR=TRUE;
INVAKF=FALSE;
PAKF=TRUE;


len = folglen;
lenold = 0;
AKFold=AKF;


}

void AKFDialog::lenENUpdate ()
{
/*
 char s[255];
 strcpy(s,AKF.editlen);

 if ((AKF.checkpar1==FALSE)&(AKF.checkpar2==FALSE)) {
																		 AKF=AKFold;
																	 }

  static BOOL lenchange;

  lenold=len;
*/

char s[255];
	editlen->Transfer(s,tdGetData);

	len = atoi(s);



	 if (len == folglen) { check1per->Check();
								  check2per->Uncheck();
								  checkvar->Uncheck();
								}
	 if (len == 2*folglen) { check1per->Uncheck();
									 check2per->Check();
									 checkvar->Uncheck();
								  }


	 if ((len!=folglen) & (len!=2*folglen))  { 	check1per->Uncheck();
																check2per->Uncheck();
																checkvar->Check();
														  }





}


void AKFDialog::checkpar1BNClicked ()
{
	if (checkpar1->GetCheck())
		{
		  PAR1 = TRUE;
		}
	  else
		{
		  PAR1 = FALSE;
		  checkpar2->Check();
		  PAR2 = TRUE;

		}

}


void AKFDialog::checkpar2BNClicked ()
{
	if (checkpar2->GetCheck())
		{
		  PAR2 = TRUE;
		}
	  else
		{
		  PAR2 = FALSE;
		  checkpar1->Check();
		  PAR1 = TRUE;

		}


}


void AKFDialog::check_B_BNClicked ()
{
	signal = SIG_B;
	strcpy(s,"b(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_D_BNClicked ()
{
	signal = SIG_D;
	strcpy(s,"d(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_E_BNClicked ()
{
	signal = SIG_E;
	strcpy(s,"e(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_E1_BNClicked ()
{
	signal = SIG_E1;
	strcpy(s,"k(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_E2_BNClicked ()
{
	signal = SIG_E2;
	strcpy(s,"i(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_N_BNClicked ()
{
	signal = SIG_N;
	strcpy(s,"n(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_Q_BNClicked ()
{
	signal = SIG_Q;
	strcpy(s,"q(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_R_BNClicked ()
{
	signal = SIG_R;
	strcpy(s,"r(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_S_BNClicked ()
{
	signal = SIG_S;
	strcpy(s,"s(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_V_BNClicked ()
{
	signal = SIG_V;
	strcpy(s,"v(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_X1_BNClicked ()
{
	signal = SIG_X1;
	strcpy(s,"x1(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_X2_BNClicked ()
{
	signal = SIG_X2;
	strcpy(s,"x2(t)");
	staticsignal->SetText(s);

}


void AKFDialog::check_XTKR_BNClicked ()
{
	signal = SIG_XTKR;
	strcpy(s,"x(t)");
	staticsignal->SetText(s);

}

