#if !defined(__akfdialg_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __akfdialg_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        akfdialg.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer AKFDialog (TDialog).
*/

#include <owl\static.h>
#include <owl\edit.h>
#include <owl\checkbox.h>
#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\dialog.h>

#include "pnapp.rh"            // Definition aller Ressourcen
#include "sigdia1.h"

//{{TDialog = AKFDialog}}
struct AKFDialogXfer {
//{{AKFDialogXFER_DATA}}
    BOOL    check1per;
    BOOL    check2per;
    BOOL    checkvar;
    char    editlen[ 255 ];
    BOOL    checkpar1;
    BOOL    checkpakf;
    BOOL    checkbipolar;
    BOOL    checkinvakf;
    BOOL    checkpar2;
    char    staticsignal[ 255 ];
//{{AKFDialogXFER_DATA_END}}
};


class AKFDialog : public TDialog {
public:
    AKFDialog (TWindow* parent, TResId resId = IDD_AKFDIALOG, TModule* module = 0);
    virtual ~AKFDialog ();

//{{AKFDialogVIRTUAL_BEGIN}}
public:
    virtual BOOL CanClose ();
    virtual void SetupWindow ();
    void Initialisierung();
//{{AKFDialogVIRTUAL_END}}

//{{AKFDialogRSP_TBL_BEGIN}}

public:

int bildlen;
int folglen;
BOOL PAKF;
BOOL BIPOLAR;
BOOL INVAKF;
BOOL PAR1;
BOOL PAR2;
AKFDialogXfer AKF;
AKFDialogXfer AKFold;
AKFDialogXfer AKFneu;
char s[255];
int signal;

protected:
    void lenENChange ();
    void check1perBNClicked ();
    void check2perBNClicked ();
    void checkvarBNClicked ();
    void checkbipolarBNClicked ();
    void checkpakfBNClicked ();
    void checkinvakfBNClicked ();
    void lenENUpdate ();
    int  len;
    int  lenold;


    void checkpar1BNClicked ();
    void checkpar2BNClicked ();
    void check_B_BNClicked ();
    void check_D_BNClicked ();
    void check_E_BNClicked ();
    void check_E1_BNClicked ();
    void check_E2_BNClicked ();
    void check_N_BNClicked ();
    void check_Q_BNClicked ();
    void check_R_BNClicked ();
    void check_S_BNClicked ();
    void check_V_BNClicked ();
    void check_X1_BNClicked ();
    void check_X2_BNClicked ();
    void check_XTKR_BNClicked ();
//{{AKFDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(AKFDialog);

//{{AKFDialogXFER_DEF}}
protected:
    TCheckBox *check1per;
    TCheckBox *check2per;
    TCheckBox *checkvar;
    TEdit *editlen;
    TCheckBox *checkpar1;
    TCheckBox *checkpakf;
    TCheckBox *checkbipolar;
    TCheckBox *checkinvakf;
    TCheckBox *checkpar2;
    TStatic *staticsignal;

//{{AKFDialogXFER_DEF_END}}
};    //{{AKFDialog}}


#endif                                      // __akfdialg_h

