/*  Projekt CDMA
Copyright  1995

    SYSTEM:       CDMA.EXE  (Application)
    DATEI:        akfhptdl.cpp
	 AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
	 Quelltextdatei fuer die Implementation von AKFHauptDialog (TDialog).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "akfhptdl.h"
#include "sigdia1.h"


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(AKFHauptDialog, TDialog)
//{{AKFHauptDialogRSP_TBL_BEGIN}}
	 EV_WM_MOUSEMOVE,
	 EV_BN_CLICKED(IDC_CHECK1PER, check1perBNClicked),
	 EV_BN_CLICKED(IDC_CHECK2PER, check2perBNClicked),
	 EV_BN_CLICKED(IDC_CHECKAKF, checkakfBNClicked),
    EV_BN_CLICKED(IDC_CHECKBIPOLAR, checkbipolarBNClicked),
    EV_BN_CLICKED(IDC_CHECKINVERS, checkinversBNClicked),
	 EV_BN_CLICKED(IDC_CHECKKKF, checkkkfBNClicked),
    EV_BN_CLICKED(IDC_CHECKPERIODISCH, checkperiodischBNClicked),
	 EV_EN_CHANGE(IDC_EDITBEREICH1ANF, editbereich1anfENChange),
	 EV_EN_CHANGE(IDC_EDITBEREICH1END, editbereich1endENChange),
	 EV_EN_CHANGE(IDC_EDITBEREICH2ANF, editbereich2anfENChange),
	 EV_EN_CHANGE(IDC_EDITBEREICH2END, editbereich2endENChange),
	 EV_EN_CHANGE(IDC_EDITPLOTANF, editplotanfENChange),
	 EV_EN_CHANGE(IDC_EDITPLOTEND, editplotendENChange),
    EV_BN_CLICKED(IDC_PUSHPAR1, pushpar1BNClicked),
	 EV_BN_CLICKED(IDC_PUSHPAR2, pushpar2BNClicked),
    EV_BN_CLICKED(IDC_CHECKSYMMETRISCH, checksymmetrischBNClicked),
    EV_CBN_SELCHANGE(IDC_COMBOSIGNAL1, combosignal1CBNSelchange),
    EV_CBN_SELCHANGE(IDC_COMBOSIGNAL2, combosignal2CBNSelchange),
//{{AKFHauptDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{AKFHauptDialog Implementation}}


static AKFHauptDialogXfer AKFHauptDialogData;

AKFHauptDialog::AKFHauptDialog (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
//{{AKFHauptDialogXFER_USE}}
    check1per = new TCheckBox(this, IDC_CHECK1PER, 0);
    check2per = new TCheckBox(this, IDC_CHECK2PER, 0);
	 checkakf = new TCheckBox(this, IDC_CHECKAKF, 0);
	 checkbipolar = new TCheckBox(this, IDC_CHECKBIPOLAR, 0);
	 checkinvers = new TCheckBox(this, IDC_CHECKINVERS, 0);
    checkkkf = new TCheckBox(this, IDC_CHECKKKF, 0);
	 checkperiodisch = new TCheckBox(this, IDC_CHECKPERIODISCH, 0);
	 combosignal1 = new TComboBox(this, IDC_COMBOSIGNAL1, 1);
	 combosignal2 = new TComboBox(this, IDC_COMBOSIGNAL2, 1);
	 editbereich1anf = new Spinedit(this, IDC_EDITBEREICH1ANF, 255);
	 editbereich1end = new Spinedit(this, IDC_EDITBEREICH1END, 255);
	 editbereich2anf = new Spinedit(this, IDC_EDITBEREICH2ANF, 255);
	 editbereich2end = new Spinedit(this, IDC_EDITBEREICH2END, 255);
	 editplotanf = new Spinedit(this, IDC_EDITPLOTANF, 255);
	 editplotend = new Spinedit(this, IDC_EDITPLOTEND, 255);
	 pushpar1 = new TButton(this, IDC_PUSHPAR1);
	 pushpar2 = new TButton(this, IDC_PUSHPAR2);
	 staticpakf1 = new TStatic(this, IDT_PAKF1, 255);
	 staticpakferg = new TStatic(this, IDT_PAKF_ERG, 255);
	 checksymmetrisch = new TCheckBox(this, IDC_CHECKSYMMETRISCH, 0);

//    SetTransferBuffer(&AKFHauptDialogData);
//{{AKFHauptDialogXFER_USE_END}}

    updatezaehler = 0;

}


AKFHauptDialog::~AKFHauptDialog ()
{
	 Destroy();


}


void AKFHauptDialog::SetupWindow ()
{
	 TDialog::SetupWindow();

	 akf = TRUE;
	 bipolar = TRUE;
	 invers = FALSE;
	 periodisch = TRUE;

	 plotoriginal = 1;
	 symmetrisch = TRUE;

	 signal1 = SIG_X1;
	 signal2 = SIG_X2;

	 sig1satz = 1;
	 sig1holen = TRUE;
	 sig2satz = 1;
	 sig2holen = TRUE;

	 editbereich1anf->SetRange(sig1anf,0,9999,51,SPIN_EINS,0);
	 editbereich1end->SetRange(sig1end,0,9999,51,SPIN_EINS,0);
	 editbereich2anf->SetRange(sig2anf,0,9999,51,SPIN_EINS,0);
	 editbereich2end->SetRange(sig2end,0,9999,51,SPIN_EINS,0);

	 editplotanf->SetRange(plotanf,-9999,9999,51,SPIN_EINS,0);
	 editplotend->SetRange(plotend,-9999,9999,51,SPIN_EINS,0);

	 combosignal1->ClearList();
	 combosignal1->AddString("c1(t)");
	 combosignal1->AddString("c2(t)");
	 combosignal1->AddString("c1(t)*c2(t)");
	 combosignal1->AddString("s(t)");
	 combosignal1->AddString("k(t)");
	 combosignal1->AddString("r(t)");
	 combosignal1->AddString("m(t)");
	 combosignal1->SetSelIndex(0);

	 combosignal2->ClearList();
	 combosignal2->AddString("c1(t)");
	 combosignal2->AddString("c2(t)");
	 combosignal2->AddString("c1(t)*c2(t)");
	 combosignal2->AddString("s(t)");
	 combosignal2->AddString("k(t)");
	 combosignal2->AddString("r(t)");
	 combosignal2->AddString("m(t)");
	 combosignal2->SetSelIndex(0);


	 combosignal1CBNSelchange();
	 combosignal2CBNSelchange();

}


void AKFHauptDialog::EvMouseMove (UINT modKeys, TPoint& point)
{
	 TDialog::EvMouseMove(modKeys, point);

		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();
		  char s[255];
		  strcpy(s,"  ");

		  if (par1->folgegueltig == FALSE) client->Transfer(s,5);
		  if (par2->folgegueltig == FALSE) client->Transfer(s,6);

	 if (akfgueltig == FALSE)
		{
		  char s[255];
		  strcpy(s,"  ");
		  Parent->Transfer(s,45);
		}
    akfgueltig = TRUE;
}


void AKFHauptDialog::check1perBNClicked ()
{
int mitte = (plotend + plotanf) / 2;
plotanf = mitte;
plotend = mitte + perlaenge;
Update_All();
}


void AKFHauptDialog::check2perBNClicked ()
{
int mitte = (plotend - plotanf) / 2;
plotanf = mitte - perlaenge;
plotend = mitte + perlaenge;

Update_All();
}


void AKFHauptDialog::checkakfBNClicked ()
{
if (akf == FALSE)
  {
	  int index;
	  sig2satz = sig1satz;
	  index = combosignal1->GetSelIndex();
	  combosignal2->SetSelIndex(index);
	  sig2anf = sig1anf;
	  sig2end = sig1end;
	  sig2original = sig1original;
	  if (sig2satz == 1) pushpar2->SetWindowText("Parametersatz 1");
		 else  pushpar2->SetWindowText("Parametersatz 2");
  }

Update_All();
}


void AKFHauptDialog::checkbipolarBNClicked ()
{
  if (bipolar == TRUE) bipolar = FALSE; else bipolar = TRUE;
  Update_All();
}


void AKFHauptDialog::checkinversBNClicked ()
{
  if (invers == TRUE) invers = FALSE; else invers = TRUE;
  if (invers == TRUE) periodisch = TRUE;
  Update_All();
}


void AKFHauptDialog::checkkkfBNClicked ()
{
  checkakfBNClicked();
}


void AKFHauptDialog::checkperiodischBNClicked ()
{
  if (periodisch == TRUE) periodisch = FALSE; else periodisch = TRUE;
  if (periodisch == FALSE) invers = FALSE;
  Update_All();
}



void AKFHauptDialog::editbereich1anfENChange ()
{
  if (sig1anf > sig1end) sig1end = sig1anf;
  if (akf == TRUE) editbereich2anf->SetPosition(sig1anf);
  Update_All();
}


void AKFHauptDialog::editbereich1endENChange ()
{
  if (akf == TRUE) editbereich2end->SetPosition(sig1end);

  Update_All();
}


void AKFHauptDialog::editbereich2anfENChange ()
{
  if (sig2anf > sig2end) sig2end = sig2anf;
  akf = FALSE;
  Update_All();
}


void AKFHauptDialog::editbereich2endENChange ()
{
  akf = FALSE;
  Update_All();
}


void AKFHauptDialog::editplotanfENChange ()
{

Update_All();
}


void AKFHauptDialog::editplotendENChange ()
{
  Update_All();

}

void AKFHauptDialog::checksymmetrischBNClicked ()
{
  if (symmetrisch == TRUE) symmetrisch = FALSE; else symmetrisch = TRUE;

  if (symmetrisch == TRUE) Update_All();
}


void AKFHauptDialog::pushpar1BNClicked ()
{
  if (sig1satz == 1) sig1satz = 2; else sig1satz = 1;
  if (akf == TRUE) sig2satz = sig1satz;

	if (sig1satz == 1) pushpar1->SetWindowText("Parametersatz 1");
	 else  pushpar1->SetWindowText("Parametersatz 2");

	if (sig2satz == 1) pushpar2->SetWindowText("Parametersatz 1");
	 else  pushpar2->SetWindowText("Parametersatz 2");

  Update_All();
}


void AKFHauptDialog::pushpar2BNClicked ()
{
  if (sig2satz == 1) sig2satz = 2; else sig2satz = 1;
  akf = FALSE;

	if (sig2satz == 1) pushpar2->SetWindowText("Parametersatz 1");
	 else  pushpar2->SetWindowText("Parametersatz 2");

  Update_All();
}


void AKFHauptDialog::Update_All()
{
	if (++updatezaehler < 20) return;
	int index;
	combosignal1->HideList();
	combosignal2->HideList();
	if (sig1satz == 1) sig1par = par1; else sig1par = par2;
	if (sig2satz == 1) sig2par = par1; else sig2par = par2;

	if ((signal1==SIG_S)||(signal1==SIG_E1)||(signal1==SIG_E)||(signal1==SIG_R)) bipolar = TRUE;
	if ((signal1==SIG_S)||(signal2==SIG_E1)||(signal2==SIG_E)||(signal2==SIG_R)) bipolar = TRUE;

	if (bipolar == TRUE) checkbipolar->Check(); else checkbipolar->Uncheck();
	if (periodisch == TRUE) checkperiodisch->Check(); else checkperiodisch->Uncheck();
	if (invers == TRUE) checkinvers->Check(); else checkinvers->Uncheck();


	index = combosignal1->GetSelIndex();
	if (index == 0) signal1 = SIG_X1;
	if (index == 1) signal1 = SIG_X2;
	if (index == 2) signal1 = SIG_X12;
	if (index == 3) signal1 = SIG_S;
	if (index == 4) signal1 = SIG_E1;
	if (index == 5) signal1 = SIG_E;
	if (index == 6) signal1 = SIG_R;

	index = combosignal2->GetSelIndex();
	if (index == 0) signal2 = SIG_X1;
	if (index == 1) signal2 = SIG_X2;
	if (index == 2) signal2 = SIG_X12;
	if (index == 3) signal2 = SIG_S;
	if (index == 4) signal2 = SIG_E1;
	if (index == 5) signal2 = SIG_E;
	if (index == 6) signal2 = SIG_R;

	perlaenge = sig1par->Signal[SIG_X1].laenge;
	if (signal1 == SIG_X2) perlaenge = sig1par->Signal[SIG_X2].laenge;

	if (plotend - plotanf == perlaenge-1) check1per->Check(); else check1per->Uncheck();
	if (plotend - plotanf == 2*perlaenge-1) check2per->Check(); else check2per->Uncheck();

	if (akf == TRUE) if (signal1 != signal2) {
															  signal2 = signal1;
															  sig2anf = sig1anf;
															  sig2end = sig1end;
															  sig2original = sig1original;
														  }


	perlaenge2 = sig1par->Signal[SIG_X1].laenge;
	if (signal2 == SIG_X2) perlaenge2 = sig2par->Signal[signal2].laenge;

	Grenzen(signal1,sig1satz);

	if (sig1anf == 0) if (sig1end == perlaenge) sig1original = TRUE; else sig1original = FALSE;
	if (sig2anf == 0) if (sig2end == perlaenge2) sig2original = TRUE; else sig2original = FALSE;


	if (sig1holen == TRUE)    {
										  sig1anf=0;
										  sig1end=perlaenge-1;
									  }
	Grenzen(signal2,sig2satz);
	if (sig2holen == TRUE)    {
										  sig2anf=0;
										  sig2end=perlaenge2-1;
									  }




	Grenzen(signal1,sig1satz);
	if (sig1anf > end) sig1anf = end;
	if (sig1end > end) sig1end = end;
	if (sig1anf > sig1end) sig1anf = sig1end;
	editbereich1anf->SetPosition(sig1anf);
	editbereich1end->SetPosition(sig1end);

	Grenzen(signal2,sig2satz);
	if (sig2anf > end) sig2anf = end;
	if (sig2end > end) sig2end = end;
	if (sig2anf > sig2end) sig2anf = sig2end;
	editbereich2anf->SetPosition(sig2anf);
	editbereich2end->SetPosition(sig2end);



if (signal1 == signal2)
  if (sig1satz == sig2satz)
	 if (sig1anf == sig2anf)
		if (sig1end == sig2end) akf = TRUE;

if (akf == TRUE) { checkakf->Check(); checkkkf->Uncheck(); }
  else
	 { checkakf->Uncheck(); checkkkf->Check(); }

int rest = perlaenge % 2;

if (sig1holen == TRUE)  {
								  symmetrisch = TRUE;
								  plotanf = 0;
								  plotend = perlaenge;
								}
plotoriginal = 0;
if (plotend - plotanf == perlaenge) plotoriginal = 1;
if (plotend - plotanf == 2 * perlaenge) plotoriginal = 2;

if (plotoriginal == 1) check1per->Check(); else check1per->Uncheck();
if (plotoriginal == 2) check2per->Check(); else check2per->Uncheck();

if (symmetrisch == TRUE) {
									checksymmetrisch->Check();
									int plotges = plotend - plotanf;
									rest = plotges % 2;
									plotanf = - plotges / 2;
									plotend = plotges / 2 + rest;
								 }
								else checksymmetrisch->Uncheck();


editplotanf->SetPosition(plotanf);
editplotend->SetPosition(plotend);


sig1holen=FALSE;
sig2holen=FALSE;

akfgueltig = FALSE;

}


void AKFHauptDialog::Grenzen(int sig,int satz)
{
	if (satz == 1) par = par1; else par = par2;
	anf = 0;
	end = par->Signal[sig].laenge-1;
}



void AKFHauptDialog::combosignal1CBNSelchange ()
{

  sig1holen = TRUE;
if (akf == TRUE) {
                   sig2holen = TRUE;
                   combosignal2->SetSelIndex(combosignal1->GetSelIndex());
                 }

  Update_All();

}


void AKFHauptDialog::combosignal2CBNSelchange ()
{
  akf = FALSE;
  sig2holen = TRUE;
  Update_All();

}

