#if !defined(__akfhptdl_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __akfhptdl_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        akfhptdl.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer AKFHauptDialog (TDialog).
*/

#include <owl\static.h>
#include <owl\button.h>
#include <owl\edit.h>
#include <owl\combobox.h>
#include <owl\checkbox.h>
#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\dialog.h>
#include "spinedit.h"
#include "parmtrwn.h"

#include "pnapp.rh"            // Definition aller Ressourcen


//{{TDialog = AKFHauptDialog}}
struct AKFHauptDialogXfer {
//{{AKFHauptDialogXFER_DATA}}
    BOOL    check1per;
    BOOL    check2per;
    BOOL    checkakf;
    BOOL    checkbipolar;
    BOOL    checkinvers;
    BOOL    checkkkf;
    BOOL    checkperiodisch;
    TComboBoxData  combosignal1;
    TComboBoxData  combosignal2;
    char    editbereich1anf[ 255 ];
    char    editbereich1end[ 255 ];
    char    editbereich2anf[ 255 ];
    char    editbereich2end[ 255 ];
    char    editplotanf[ 255 ];
    char    editplotend[ 255 ];
    char    staticpakf1[ 255 ];
    char    staticpakferg[ 255 ];
    BOOL    checksymmetrisch;
//{{AKFHauptDialogXFER_DATA_END}}
};


class AKFHauptDialog : public TDialog {
public:
    AKFHauptDialog (TWindow* parent, TResId resId = AKF_HAUPT_DIALOG, TModule* module = 0);
    virtual ~AKFHauptDialog ();

public:
    int signal1;
    int signal2;
    BOOL akfgueltig;
    BOOL akf;
    BOOL bipolar;
    BOOL periodisch;
    BOOL invers;
    BOOL symmetrisch;
    int perlaenge;
    int perlaenge2;
    
    ParameterDialog* par1;
    ParameterDialog* par2;
    ParameterDialog* par;
    ParameterDialog* sig1par;
    ParameterDialog* sig2par;

    int plotanf;
    int plotend;
    int plotoriginal;

    int sig1satz;
    int sig2satz;

    int sig1anf;
    int sig1end;
    BOOL sig1original;
    BOOL sig1holen;

    int sig2anf;
    int sig2end;
    BOOL sig2original;
    BOOL sig2holen;

    int anf;
    int end;

    int signal;

    int updatezaehler;

    void Grenzen(int,int);
    void Update_All();
    void Update_Grenzen1();
    void Update_Grenzen2();

    TStatic *staticpakf1;
    TStatic *staticpakferg;

    void EvMouseMove (UINT modKeys, TPoint& point);

//{{AKFHauptDialogXFER_DEF}}
protected:
    TCheckBox *check1per;
    TCheckBox *check2per;
    TCheckBox *checkakf;
    TCheckBox *checkbipolar;
    TCheckBox *checkinvers;
    TCheckBox *checkkkf;
    TCheckBox *checkperiodisch;
    TComboBox *combosignal1;
    TComboBox *combosignal2;
    Spinedit *editbereich1anf;
    Spinedit *editbereich1end;
    Spinedit *editbereich2anf;
    Spinedit *editbereich2end;
    Spinedit *editplotanf;
    Spinedit *editplotend;
    TButton *pushpar1;
    TButton *pushpar2;
    TCheckBox *checksymmetrisch;

//{{AKFHauptDialogXFER_DEF_END}}

//{{AKFHauptDialogVIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
//{{AKFHauptDialogVIRTUAL_END}}

//{{AKFHauptDialogRSP_TBL_BEGIN}}
protected:
    void check1perBNClicked ();
    void check2perBNClicked ();
    void checkakfBNClicked ();
    void checkbipolarBNClicked ();
    void checkinversBNClicked ();
    void checkkkfBNClicked ();
    void checkperiodischBNClicked ();
    void signal1CBNEditchange ();
    void signal2CBNEditchange ();
    void editbereich1anfENChange ();
    void editbereich1endENChange ();
    void editbereich2anfENChange ();
    void editbereich2endENChange ();
    void editplotanfENChange ();
    void editplotendENChange ();
    void pushpar1BNClicked ();
    void pushpar2BNClicked ();
    void checksymmetrischBNClicked ();
    void combosignal1CBNSelchange ();
    void combosignal2CBNSelchange ();
//{{AKFHauptDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(AKFHauptDialog);
};    //{{AKFHauptDialog}}


#endif                                      // __akfhptdl_h

