/*  Projekt CDMA
	 Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        akfwin.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von AKFWin (TWindow).
*/

#define W(x) (x)/32000][(x)%32000

#include <owl\owlpch.h>
#pragma hdrstop

#include "akfwin.h"
#include <owl\scroller.h>


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(AKFWin, TWindow)
//{{AKFWinRSP_TBL_BEGIN}}
	 EV_WM_LBUTTONDOWN,
	 EV_WM_SIZE,
//	 EV_COMMAND(CM_SIGNALFENSTER, Fenster),
	 EV_WM_MOUSEMOVE,
	 EV_WM_LBUTTONDBLCLK,
//{{AKFWinRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{AKFWin Implementation}}


AKFWin::AKFWin (TWindow* parent, const char far* title, TModule* module):
	 TWindow(parent, title, module)
{
	 Initialisierung = INIT_START;
	 // Hintergrundfarbe des Fensters aendern
	 SetBkgndColor(RGB(0xc0, 0xc0, 0xc0));
	 Attr.W = 600;
		 Attr.Style |=  WS_VISIBLE;


	 St_Parameter1 = new Staticgrau(this,ID_STATIC," ",1305,55,550,20);
	 akfdlg = new AKFHauptDialog(this);

	 for (int i=0;i<=29;i++) {
											listex[i]= new int[32100];
											listey[i]= new int[32100];
										 }

	 folge = new int[17000];
	 folge1 = new int[32000];
	 folge2 = new int[32000];
	 akfy = new LONG[1300];
	 akfx = new LONG[16000];
	 akfi = new LONG[16000];
	 akf  = new float[1300];
	 folgeakf=new int[17000];
for (i=0;i<10000;i++) {

							 }
}


AKFWin::~AKFWin ()
{
	 if (akfy) delete akfy;
		 for (int i=0;i<=29;i++) {
											if (listex[i]) delete listex[i];
											if (listey[i]) delete listey[i];
										 }

	 if (akf) delete akf;
	 if (folgeakf) delete folgeakf;
	 if (folge) delete folge;
	 if (folge1) delete folge1;
	 if (folge2) delete folge2;
	 if (akfx) delete akfx;
	 if (akfi) delete akfi;

	 Destroy();


}


void AKFWin::EvLButtonDown (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDown(modKeys, point);

}


void AKFWin::SetupWindow ()
{
	 TWindow::SetupWindow();
	 Initialisierung = INIT_OK;

	 string s;
	 bitexist = FALSE;
  PAKF = TRUE;
  BIPOLAR=TRUE;
  INVAKF=FALSE;
  signal = SIG_X1;
  par = par1;

	 bildlen = par->Signal[signal].laenge;
	 St_Parameter1->SetText((s = "Parametersatz 1").c_str());

	 TClientDC dc(*this);
	 TRect rcc = GetClientRect();
	 bitmap =  new TBitmap(dc,30,30,FALSE);
	 akfdia = new AKFDialog(this);
	 akfdia->folglen=par->Signal[signal].laenge;
	 akfdia->Initialisierung();
	 Titelsetzen();
	 xalt = -1;

	 akfdlg->par1=par1;
	 akfdlg->par2=par2;
	 akfdlg->Create();




}




void AKFWin::Paint (TDC& dc, BOOL erase, TRect& rc)
{
  if (Initialisierung != INIT_OK) return;

//x  SetCursor(0,IDC_WAIT);
				 Fenster();
             akfdlg->akfgueltig = TRUE;

				 TPoint point;
				 point.x=rectf.right/2;
				 point.y= 0;
				 xalt = -1;
				 EvMouseMove(0,point);

				 TWindow::Paint(dc, erase, rc);
  SetCursor(0,IDC_ARROW);

}


void AKFWin::EvSize (UINT sizeType, TSize& size)
{
  if (Initialisierung != INIT_OK) return;

	TWindow::EvSize(sizeType, size);
	Invalidate();
	bitexist = FALSE;
}

int AKFWin::Invers(int x)
{

  if (BIPOLAR)
	 {
		 return(-x);
	 }
  else
	 {
		 if (x==0) return(1); else return(0);
	 }
}



void AKFWin::Fenster ()
{
  if (Initialisierung != INIT_OK) return;

HCURSOR WaitCursor;
WaitCursor = ::LoadCursor(GetApplication()->GetMainWindow()->GetModule()->GetInstance(), MAKEINTRESOURCE(CURSOR_1));
::SetCursor(WaitCursor);
  folglen=par->Signal[signal].laenge;



  int korr = 1;
  if (bildlen%2 ==0) korr=0;

  int bildanf = bildlen / 2 + korr;
  int bildend = bildanf + bildlen-1;
  int bildmitte = bildlen;

  int folgminus = folglen / 2 ;
  int folgplus = folglen / 2 +1;
  int folgeanf = bildmitte - folgminus;
  int folgeend = bildmitte + folgplus;




	 string si;
	 //int i;

	 TClientDC dc(*this);
	 TRect rcc = GetClientRect();

	 if (rcc.Height() < 150) { SetCursor(0,IDC_ARROW);
										return;
									 }

	 int plotanf = akfdlg->plotanf;
	 int plotend = akfdlg->plotend;
	 int sig1anf = akfdlg->sig1anf;
	 int sig1end = akfdlg->sig1end;
	 int sig2anf = akfdlg->sig2anf;
	 int sig2end = akfdlg->sig2end;
	 int perlaenge1 = akfdlg->perlaenge;
	 int perlaenge2 = akfdlg->perlaenge2;
	 ParameterDialog* sig1par = akfdlg->sig1par;
	 ParameterDialog* sig2par = akfdlg->sig2par;
	 int signal1 = akfdlg->signal1;
	 int signal2 = akfdlg->signal2;

    Titelsetzen();

	 if (rcc.Width() %2 == 1) rcc.right++;
	 TRect rectmem = rcc;
	 rectmem.right *=2;
	 LONG rh = rcc.Height();
	 LONG pp;

	 rectf = rectk = rectm = recta = rcc;

	 rectf.top = 145; rectf.bottom = 145 + (rh - 145) / 5;

	 rectk.top = rectf.bottom +1; rectk.bottom = (rh-145)/5 + rectk.top;

	 rectm.top = rectk.bottom +1; rectm.bottom = (rh-145)/5 + rectm.top;

	 recta.top = rectm.bottom +1; recta.bottom = rcc.bottom;
	 TPen pn(RGB(0,0,0),1,PS_SOLID);
	 TBrush br(RGB(0,0,255));

	 TPen null(RGB(0,0,150),1,PS_DOT);

	 dc.FillRect(rectf,TBrush(TColor::LtGray));
	 dc.FillRect(rectm,TBrush(TColor::LtBlue));
	 dc.FillRect(recta,TBrush(TColor::LtGreen));

	 rectk.right = rectk.Width() *2 ;



	 if (bitmap) delete bitmap;
	 bitmap =  new TBitmap(dc,rectk.Width(),rectk.Height(),FALSE);
	 bitexist = TRUE;
	 TMemoryDC memdc(dc);
	 memdc.SelectObject(*bitmap);
	 TSize Grid(16,16);
	 memdc.FillRect(rectmem,TBrush(TColor::White));

	 struct sigstruct { int l,r,l0,r0;
							  float min,max;
							} sigpar;

	 sigpar.min=-0.5;
	 if(BIPOLAR) sigpar.min = -1.5;

	 sigpar.max=2.;
	 int i;
	 int folgmin=32000;
	 int folgmax=-32000;

	 for (i=0;i<32000;i++) folge1[i] = 0;
	 for (i=0;i<32000;i++) folge2[i] = 0;

	 int anf;
	 int laenge1;
	 int laenge2;
	 int laenge;

	 for (i=0;i<=sig1end-sig1anf;i++)
		{
			folge1[i+10000] = sig1par->Signal[signal1].folge[sig1anf+20+i];
		}


	 for (i=0;i<=sig2end-sig2anf;i++)
		{
			folge2[i+10000] = sig2par->Signal[signal2].folge[sig2anf+20+i];
		}


	 if (akfdlg->periodisch == TRUE)
		{
			if (signal2 <= SIG_X2)
			  {
				  anf = ((10000-sig2anf) % perlaenge2);
				  for (i = anf; i < 30000;i++)
					 {
						 folge2[i] = sig2par->Signal[signal2].folge[(i-anf)%perlaenge2 +20];
					 }
			  }

			if (signal2 == SIG_X12)
			  {
				  laenge = sig2par->Signal[SIG_X1].laenge;
				  anf = ((10000-sig2anf) % laenge);
				  for (i = anf; i < 30000;i++)
					 {
						 folge2[i] = sig2par->Signal[SIG_X1].folge[(i-anf)%laenge +20];
					 }
				  laenge = sig2par->Signal[SIG_X2].laenge;
				  anf = ((10000-sig2anf) % laenge);
				  for (i = anf; i < 30000;i++)
					 {
						 folge2[i] *= sig2par->Signal[SIG_X2].folge[(i-anf)%laenge +20];
					 }
			  }

			if ((signal2 == SIG_S) || (signal2 == SIG_E1) || (signal2 == SIG_E) || (signal2 == SIG_R))
			  {

				  laenge = sig2par->Signal[signal2].laenge;
				  anf = (10000 % perlaenge2);
				  for (i = anf; i < 10000;i++)
					 {
						 folge2[i] = sig2par->Signal[signal2].folge[(i-anf)%laenge +20];
					 }
				  anf =  10000+(sig2end-sig2anf);
				  for (i = 10000+(sig2end-sig2anf); i < 30000;i++)
					 {
						 folge2[i] = sig2par->Signal[signal2].folge[(i-anf)%laenge +20];
					 }
			  }

		}

	 if (akfdlg->bipolar == FALSE)
		{
			for (i=0;i<30000;i++) {
											 folge1[i] = (1 - folge1[i]) /2;
											 folge2[i] = (1 - folge2[i]) /2;
										 }
		}

	 if (akfdlg->invers == TRUE)
		{
			for (i=0;i<30000;i++) {
											 if ((i<10000)||(i>10000+sig1end-sig1anf)) folge2[i] = -folge2[i];
										 }
		}



LONG look[100];

	 if ((signal1==SIG_X1)||(signal1==SIG_X2)||(signal1==SIG_X12))
		{
		  for (i=0;i<30000;i++) folge1[i] *=1000;
		}
	 if ((signal2==SIG_X1)||(signal2==SIG_X2)||(signal2==SIG_X12))
		{
		  for (i=0;i<30000;i++) folge2[i] *=1000;
		}

	folgmin = 32000;
	folgmax = -32000;

	for (i=0;i<30000;i++) {
									if (folge2[i] < folgmin) folgmin = folge2[i];
									if (folge2[i] > folgmax) folgmax = folge2[i];
								 }

	 LONG folg2min = folgmin;
	 LONG folg2max = folgmax;

	 sigpar.min = folgmin - (folgmax-folgmin)*0.2;
	 sigpar.max = folgmax + (folgmax-folgmin)*0.25;
	 if (sigpar.max - sigpar.min == 0) { sigpar.max +=0.5; sigpar.min -=0.5; }



	 LONG x;

	 int plotverschiebung = 0;
	 if (plotend-plotanf > sig1end - sig1anf)
		{
			plotverschiebung = - ( (plotend-plotanf) - (sig1end - sig1anf) ) / 2;
		}

	 bildlen = plotend - plotanf;
	 int zeichanf = 10000 - bildlen - plotanf;
	 int zeichend = 10000 + bildlen - plotanf;

	 int zeichlen = zeichend - zeichanf;

	 LONG ymax = rectk.Height();
	 LONG xmax = rectk.Width() ;
	 float yp;
	 dc.SelectObject(pn);
	 LONG y,xf;
	 int folge1x[1300];
	 int folge2x[2600];

	 memdc.SelectObject(null);
	 memdc.MoveTo(0,ymax - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min)));
	 memdc.LineTo(xmax,ymax - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min)));
    memdc.SelectObject(pn);

	 for( x=0;x<xmax;x++)
		{
		  xf = plotverschiebung + zeichanf + x * zeichlen / xmax;
		  yp = ymax - ((folge2[xf]-sigpar.min) * ymax / (sigpar.max-sigpar.min));
		  folge2x[x] = folge2[xf];
		  if (x==0) memdc.MoveTo(x-1,yp);
		  memdc.LineTo(x-1,yp);
		  memdc.LineTo(x,yp);

		}
//v return;//1
	folgmin = 32000;
	folgmax = -32000;

	for (i=0;i<30000;i++) {
									if (folge1[i] < folgmin) folgmin = folge1[i];
									if (folge1[i] > folgmax) folgmax = folge1[i];
								 }

	 sigpar.min = folgmin - (folgmax-folgmin)*0.2;
	 sigpar.max = folgmax + (folgmax-folgmin)*0.25;
	 if (sigpar.max - sigpar.min == 0) { sigpar.max +=0.5; sigpar.min -=0.5; }

	 LONG folg1min = folgmin;
	 LONG folg1max = folgmax;

	 bildlen = plotend - plotanf;
	 zeichanf = 10000;
	 zeichend = 10000 + bildlen;


	 ymax = rectf.Height();
	 xmax = rectf.Width() ;
	 dc.SelectObject(pn);

	 dc.SelectObject(null);
	 dc.MoveTo(0,rectf.bottom - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min)));
	 dc.LineTo(xmax,rectf.bottom - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min)));
	 dc.SelectObject(pn);


	 for( x=0;x<=xmax;x++)
		{
		  xf = plotverschiebung + zeichanf + x * bildlen / xmax;
		  yp = rectf.bottom - ((folge1[xf]-sigpar.min) * ymax / (sigpar.max-sigpar.min));
		  folge1x[x] = folge1[xf];
		  if (x==0)dc.MoveTo(x-1,yp);
		  dc.LineTo(x-1,yp);
		  dc.LineTo(x,yp);

		}





LONG akf;
LONG akfmin,akfmax;
	  akfmax = -2000000000;
	  akfmin = 2000000000;
int lookf1[300];
int lookf2[300];
int w;
for (i=0;i<299;i++){
							lookf1[i]=folge1[i+9900];
							lookf2[i]=folge2[i+9900];
						 }

if (sig1end-sig1anf > 1000) {
										 for (i=0;i<30000;i++) {
																		 folge1[i] /=10;
																		 folge2[i] /=10;
																	  }
									 }

		  for (i=plotanf;i<=plotend;i++)
			 {  akf = 0;
				 for (w=0;w<=sig1end-sig1anf;w++)
					{
					  akf += (LONG)folge1[w+10000] * (LONG)folge2[w+10000-i];
					}

				 akfi[i-plotanf] = akf;
if (i-plotanf<100) look[i-plotanf]=akf;
				 if (akf < akfmin) akfmin = akf;
				 if (akf > akfmax) akfmax = akf;
			 }

//return;//2 v
	 sigpar.min = akfmin - (akfmax-akfmin)*0.1;
	 sigpar.max = akfmax + (akfmax-akfmin)*0.1;
	 if (sigpar.max - sigpar.min == 0) { sigpar.max +=0.5; sigpar.min -=0.5; }


	 bildlen = plotend - plotanf;
	 zeichanf = 0;
	 zeichend = plotend - plotanf;


	 ymax = recta.Height();
	 xmax = recta.Width() ;

	 dc.SelectObject(null);
	 dc.MoveTo(0,recta.bottom - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min)));
	 dc.LineTo(xmax,recta.bottom - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min)));

if (xmax == 0) return;
	 dc.SelectObject(pn);
float x1,x1d,yf;
int x1i;
	 for( x=0;x<=xmax;x++)
		{
		  x1 = zeichanf + (float)x * bildlen / xmax;
		  x1i = x1;

		  x1d = x1 - x1i;
		  yf = akfi[x1i] + x1d * (akfi[x1i+1]-akfi[x1i]);

		  akfx[x] = yf;

		  yp = recta.bottom - (( yf - sigpar.min) * ymax / (sigpar.max-sigpar.min));

		  if (x==0) dc.MoveTo(x,yp);
		  dc.LineTo(x,yp);

		}
// return;//4 n
	 LONG minmax[4];
	 LONG prodmin,prodmax;
	 prodmin = 2000000000;
	 prodmax = -200000000;
	 minmax[0] = folg1min * folg2min;
	 minmax[1] = folg1min * folg2max;
	 minmax[2] = folg1max * folg2min;
	 minmax[3] = folg1max * folg2max;

	for (i=0;i<=3;i++) {
									if (minmax[i] < prodmin) prodmin = minmax[i];
									if (minmax[i] > prodmax) prodmax = minmax[i];
								 }

	 sigpar.min = prodmin - (prodmax-prodmin)*0.2;
	 sigpar.max = prodmax + (prodmax-prodmin)*0.25;
	 if (sigpar.max - sigpar.min == 0) { sigpar.max +=0.5; sigpar.min -=0.5; }

//n return;//3

	 int listeyq[3000];
	 ymax = rectm.Height();
	 LONG refz = 0;
	 int refanz = 0;
	 refanf[0]=0;
	 LONG prod;
	 LONG prodalt = -555;
	 int xf1,xf2,dx;
	 static int xalt;
	 int dx2;
	 for (dx = 0; dx < rcc.right; dx++)
		{
		  prodalt = -555;
		  dx2 = rcc.right - dx;     // Verschiebung von Folge 2 bei Cursor auf dx
		  for (x=0;x<=rcc.right;x++)
			  {
				  prod = (LONG)folge1x[x] * folge2x[x+dx2];
				  if (prod != prodalt)
					  {  listex[W(refz)] = x;
						  xalt = x;
						  prodalt = prod;
						  listey[W(refz)] = rectm.bottom - ((prod-sigpar.min) * ymax / (sigpar.max-sigpar.min));
						  refz++;
					  }

			  }
		  listex[W(refz)] = x;
		  listey[W(refz)] = rectm.bottom - ((prod-sigpar.min) * ymax / (sigpar.max-sigpar.min));
		  refz++;
		  refanf[++refanz] = refz;

		}


	 char s[255];
	 sprintf(s,"%4d,%4d:%3d,%3d",refz);

//	 St_Parameter1->SetText(s);

	 memdc.RestoreBitmap();
    SetCursor(0,IDC_ARROW);



}

void AKFWin::EvMouseMove (UINT modKeys, TPoint& point)
{
	 TWindow::EvMouseMove(modKeys, point);

  if (Initialisierung != INIT_OK) return;


	 char s[255];
	 strcpy(s,"  ");
		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();

		  if (par1->folgegueltig == FALSE) {client->Transfer(s,5); akfdlg->akfgueltig = FALSE; }
		  if (par2->folgegueltig == FALSE) {client->Transfer(s,6); akfdlg->akfgueltig = FALSE; }


	 if (akfdlg->akfgueltig == FALSE) { akfdlg->Update_All();
													akfdlg->EvMouseMove(0,point);
												 }


	 char st[255];
	 char c = ' ';
	 int v = 1;

	 int x=point.x;
	 if (akfx[x]<0) { c='-';
							v = -1;
						 }
	 wsprintf(s,"%d,%d;x: %4d, AKF: %c%ld.%2.2ld ",point.x,point.y,x-rectf.Width()/2,c,v*(akfx[x]/100),v*(akfx[x]%100));

	 if (akfdlg->akf == TRUE)
		{
		  if (akfdlg->periodisch == TRUE) strcpy(st,"PAKF("); else strcpy(st," AKF(");
		}
	 else
		{
		  if (akfdlg->periodisch == TRUE) strcpy(st,"PKKF("); else strcpy(st," KKF(");
		}

	 sprintf(s,"%3.2f) =",(float)x / rectm.Width()*(akfdlg->plotend-akfdlg->plotanf) + akfdlg->plotanf);

	 strcat(st,s);
	 akfdlg->staticpakf1->SetText(st);

	 sprintf(s,"%3.2f / %3d",(float)akfx[x]/1000000,akfdlg->sig1end-akfdlg->sig1anf+1);
	 if (akfx[x]>9990000)
		 sprintf(s,"%3.0f / %3d",(float)akfx[x]/1000000,akfdlg->sig1end-akfdlg->sig1anf+1);
	 if (akfdlg->sig1end-akfdlg->sig1anf+1 != akfdlg->perlaenge)
		 sprintf(s,"%3.4f",(float)akfx[x]/1000000/(akfdlg->sig1end-akfdlg->sig1anf+1));

	 if (akfdlg->sig1end-akfdlg->sig1anf >1000)
		 sprintf(s,"%3.4f",(float)akfx[x]/10000/(akfdlg->sig1end-akfdlg->sig1anf+1));

	 akfdlg->staticpakferg->SetText(s);


	 if (bitexist) {
		  TClientDC dc(*this);
		  TMemoryDC memdc(dc);
		  memdc.SelectObject(*bitmap);
		  dc.BitBlt(rectk.left,rectk.top,rectk.Width(),rectk.Height(),
						memdc,(rectf.right-point.x),0,SRCCOPY);
		  memdc.RestoreBitmap();

		  int xa,xb;
		  LONG ia,ie;
		  int x=point.x;
		  ia=refanf[point.x];
		  ie=refanf[point.x + 1];
		  dc.FillRect(rectm,TBrush(TColor::LtBlue));
		  TPen pn(RGB(0,0,0),1,PS_SOLID);

		  dc.SelectObject(pn);
		  dc.MoveTo(listex[W(ia)],listey[W(ia)]);
		  for(LONG i=ia;i<ie;i++)
			 {
				dc.LineTo(listex[W(i)],listey[W(i-1)]);
				dc.LineTo(listex[W(i)],listey[W(i)]);

			 }

		  static TRect cursorold;
		  static TPoint pkt;
		  pkt.x=0;pkt.y=0;

		  cursorold.left = xalt;
		  cursorold.right = xalt+1;
		  cursorold.top = recta.top;
		  cursorold.bottom = recta.bottom;




		  static TBitmap cursor(dc,10,800,FALSE);
		  TMemoryDC curdc(dc);
		  curdc.SelectObject(cursor);

		  if (x != -1)
			 {
				 dc.BitBlt(cursorold,curdc,pkt,SRCCOPY);

				 xalt = x;

				 curdc.BitBlt(0,0,1,recta.Height(),dc,x,recta.top,SRCCOPY);
				 curdc.RestoreBitmap();

				 dc.MoveTo(x,recta.top);
				 dc.LineTo(x,recta.bottom);
			 }



	 }


}


void AKFWin::Zeichbit (TBitmap* bitmap,TRect rect, int folge[129], TPen pen,int min, int max)
{

}

void AKFWin::AKFDialogfkt ()
{
}


void AKFWin::EvLButtonDblClk (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDblClk(modKeys, point);

}

void AKFWin::Titelsetzen()
{
if (akfdlg) ; else return;
  if (Initialisierung != INIT_OK) return;

 char title[255];
 char s[255];
	 switch(akfdlg->signal1)
	 {
		case SIG_Q  : strcpy(akfdia->s,"q(t)"); break;
		case SIG_X1 : strcpy(akfdia->s,"c1(t)"); break;
		case SIG_X2 : strcpy(akfdia->s,"c2(t)"); break;
		case SIG_S  : strcpy(akfdia->s,"s(t)"); break;
		case SIG_N : strcpy(akfdia->s,"n(t)"); break;
		case SIG_E1 : strcpy(akfdia->s,"k(t)"); break;
		case SIG_E2 : strcpy(akfdia->s,"i(t)"); break;
		case SIG_E  : strcpy(akfdia->s,"r(t)"); break;
		case SIG_R : strcpy(akfdia->s,"m(t)"); break;
		case SIG_X12 : strcpy(akfdia->s,"c(t)"); break;
		case SIG_B : strcpy(akfdia->s,"b(t)"); break;
		case SIG_D : strcpy(akfdia->s,"d(t)"); break;
		case SIG_V : strcpy(akfdia->s,"v(t)"); break;
		default: strcpy(akfdia->s,"X(t)");
	 }

  if ((akfdlg->signal1 == akfdlg->signal2) && (akfdlg->sig1satz == akfdlg->sig2satz))
	  { strcpy(title,"AKF von ");
		 lstrcat(title,akfdia->s);
		 if (akfdlg->sig1satz==1)	 strcpy(s," Satz 1");
			else    strcpy(s," Satz 2");
		 lstrcat(title,s);
	  }
	 else
	  {
		 strcpy(title,"KKF von ");
		 lstrcat(title,akfdia->s);

		 if (akfdlg->sig1satz != akfdlg->sig2satz)
			{
			  if (akfdlg->sig1satz==1)	 strcpy(s," Satz 1");
				else    strcpy(s," Satz 2");
			  lstrcat(title,s);
			}

		 switch(akfdlg->signal2)
		 {
			case SIG_X1 : strcpy(s," und c1(t)"); break;
			case SIG_X2 : strcpy(s," und c2(t)"); break;
			case SIG_S  : strcpy(s," und s(t)"); break;
			case SIG_E1 : strcpy(s," und k(t)"); break;
			case SIG_E  : strcpy(s," und r(t)"); break;
			case SIG_R : strcpy(s," und m(t)"); break;
			case SIG_X12 : strcpy(s," und c(t)"); break;
			case SIG_B : strcpy(s," und b(t)"); break;
			case SIG_D : strcpy(s," und d(t)"); break;
   		default: strcpy(akfdia->s,"X(t)");
		 }
		 lstrcat(title,s);
			  if (akfdlg->sig2satz==1)	 strcpy(s," Satz 1");
				else    strcpy(s," Satz 2");
			  lstrcat(title,s);

	  }




	 Parent->SetWindowText(title);

}


UINT AKFWin::Transfer (void* buffer, TTransferDirection direction)
{
	 UINT result;
  if (Initialisierung != INIT_OK) return 0;


	 if (direction <= 2 ) result = TWindow::Transfer(buffer, direction);
	 else
		{
			if (direction == 45)
									 {
										Fenster();
										akfdlg->akfgueltig = TRUE;

										TPoint point;
										point.x=rectf.right/2;
										point.y= 0;
										xalt = -1;
										EvMouseMove(0,point);
									 }
		}
	 return result;
}

