#if !defined(__akfwin_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __akfwin_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        akfwin.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer AKFWin (TWindow).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\window.h>

#include "pnapp.rh"            // Definition aller Ressourcen
#include "akfhptdl.h"

#include "staticgr.h"
#include "parmtrwn.h"
#include "akfdialg.h"
#include "akfdilg2.h"
#include "akfhptdl.h"

//{{TWindow = AKFWin}}
class AKFWin : public TWindow {
public:
    AKFWin (TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~AKFWin ();
      
    ParameterDialog* par1;
    ParameterDialog* par2;
    ParameterDialog* par;
    AKFHauptDialog* akfdlg;
	 TBitmap* bit1;
    float wert1[1500];
    int Initialisierung;
//{{AKFWinVIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
    virtual void Paint (TDC& dc, BOOL erase, TRect& rect);
    virtual void AKFWin::Zeichbit (TBitmap* bitmap,TRect rect, int folge[129], TPen pen,int min, int max);

    virtual UINT Transfer (void* buffer, TTransferDirection direction);
//{{AKFWinVIRTUAL_END}}
private:
    AKFDialog *akfdia;
	 Staticgrau *St_Parameter1;
    TBitmap     *bitmap;
    BOOL bitexist;
    TRect rectf,rectk,rectm,recta;
    int signal;
    int* listex[30];
    int* listey[30];
    LONG refanf[1300];
    int* folge;
    int* folgeakf;

    int* folge1;
    int* folge2;

    LONG* akfy;
    LONG* akfi;
    float* akf;
    LONG* akfx;
    int xalt;
    int bildlen;
    int folglen;
    BOOL PAKF;
    BOOL BIPOLAR;
    BOOL INVAKF;
    int  Invers(int);
    void Titelsetzen();
//{{AKFWinRSP_TBL_BEGIN}}
protected:
    void EvLButtonDown (UINT modKeys, TPoint& point);
    void EvHScroll (UINT scrollCode, UINT thumbPos, HWND hWndCtl);
    void EvSize (UINT sizeType, TSize& size);
    void Fenster ();
    void EvMouseMove (UINT modKeys, TPoint& point);
    void AKFDialogfkt ();
    void EvLButtonDblClk (UINT modKeys, TPoint& point);
//{{AKFWinRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(AKFWin);
};    //{{AKFWin}}


#endif                                      // __akfwin_h

