/*  Projekt CDMA
	 Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        sigwin.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von FehlerWin (TWindow).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\scroller.h>
#include "fehlerwn.h"


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(FehlerWin, TWindow)
//{{FehlerWinRSP_TBL_BEGIN}}
	 EV_WM_LBUTTONDOWN,
	 EV_WM_SIZE,
	 EV_COMMAND(CM_SIGNALFENSTER, Fenster),
	 EV_WM_LBUTTONDBLCLK,
	 EV_WM_MOUSEMOVE,
    EV_WM_HSCROLL,
//{{FehlerWinRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{FehlerWin Implementation}}


FehlerWin::FehlerWin (TWindow* parent, const char far* title, TModule* module):
	 TWindow(parent, title, module)
{
	 Initialisierung = INIT_START;
	 // Hintergrundfarbe des Fensters aendern
	 SetBkgndColor(RGB(0xc0, 0xc0, 0xc0));
		 Attr.Style |=WS_VISIBLE;
setupzaehler = 0;
fensterzaehler = 0;
	 TClientDC dc(*this);
	 bitmap =  new TBitmap(dc,100,28,TRUE);
//	 Scroller = new TScroller(this, 20,0,310,0);
//	 sigdia=new SignalHauptDialog(this);
//x	 wdfdia = new WDFDialog(this);
	 fehlerdia = new FehlerDialog(this);
//	 St_Parameter1 = new Staticgrau(this,ID_STATIC," ",5,5,120,20);

}


FehlerWin::~FehlerWin ()
{
	 if (bitmap) delete bitmap;
	 Destroy();


}


void FehlerWin::EvLButtonDown (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDown(modKeys, point);

}


void FehlerWin::SetupWindow ()
{
	 TWindow::SetupWindow();
		  char st[255];
		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();
setupzaehler++;



	 string s;
	 bitexist = FALSE;

	 TClientDC dc(*this);
	 TRect rcc = GetClientRect();

	 if (Parametersatz == 1) par = par1;
	 if (Parametersatz == 2) par = par2;
	 fehlerdia->par1=par1;
	 fehlerdia->par2=par2;
	 fehlerdia->par=par;
	 fehlerdia->Parametersatz = Parametersatz;

	 fehlerdia->Create();
	 TRect rc = GetClientRect();

	 Initialisierung = INIT_OK;

	 Titelsetzen();
	 rc = GetWindowRect();
	 Parent->MoveWindow(rc.left,rc.top,800,400);

	 fehleropt[0] = 0.157;
	 fehleropt[1] = 0.135;
	 fehleropt[2] = 0.1133;
	 fehleropt[3] = 0.09318;
	 fehleropt[4] = 0.075734;
	 fehleropt[5] = 0.05986;
	 fehleropt[6] = 0.045969;
	 fehleropt[7] = 0.034419;
	 fehleropt[8] = 0.02524;
	 fehleropt[9] = 0.017789;
	 fehleropt[10] = 0.01205;
    fehleropt[11] = 0.0078133;
    fehleropt[12] = 0.0047998;
    fehleropt[13] = 0.0028289;
    fehleropt[14] = 0.0015812;
    fehleropt[15] = 0.0008181;
    fehleropt[16] = 0.00038667;
    fehleropt[17] = 0.00017406;
    fehleropt[18] = 0.000068768;
    fehleropt[19] = 0.000024877;
    fehleropt[20] = 0.0000081689;
    stop = FALSE;
}




void FehlerWin::Paint (TDC& dc, BOOL erase, TRect& rc)
{

	 TWindow::Paint(dc, erase, rc);

  if (Initialisierung != INIT_OK) return;

		  TMemoryDC memdc(dc);
		  memdc.SelectObject(*bitmap);

		  dc.BitBlt(0,90,rcc.Width(),rcc.Height(),
						memdc,0,0,SRCCOPY);
		  memdc.RestoreBitmap();

char s[255];
char s1[255];
int t;// = Scroller->XPos;
sprintf(s,"%d) = %2.2f  ",t,(float)par->Signal[signal].folge[t+20]/100);
if ((signal==SIG_X1)||(signal==SIG_X2)) sprintf(s,"%d) = %d  ",t,(float)par->Signal[signal].folge[t+20]);
strcpy(s1,sst);
strcat(s1,s);


}


void FehlerWin::EvSize (UINT sizeType, TSize& size)
{
	 TWindow::EvSize(sizeType, size);
  if (Initialisierung != INIT_OK) return;
	 TRect rc;
	 GetWindowRect(rc);


	 rc = GetWindowRect();

	 Fenster();
}


void FehlerWin::Fenster ()
{
  if (Initialisierung != INIT_OK) return;
	signal=SIG_WDF;
	char ssigtext[255];
	fensterzaehler++;
	if (fensterzaehler<=2)return;
	 rcc = GetClientRect();

	if (par->pixel==0) return;
	int scr = par->Signal[signal].laenge - rcc.Width()/par->pixel;
	if (scr < 0) scr = 0;

	 switch(signal)
	 {
		case SIG_Q  : strcpy(ssigtext,"Quellensignal"); strcpy(sst,"q("); break;
		case SIG_X1 : strcpy(ssigtext,"Spreizfolge 1"); strcpy(sst,"x1(");  break;
		case SIG_X2 : strcpy(ssigtext,"Spreizfolge 2"); strcpy(sst,"x2(");  break;
		case SIG_S  : strcpy(ssigtext,"Sendesignal"); strcpy(sst,"s(");  break;
		case SIG_N : strcpy(ssigtext,"Rauschen"); strcpy(sst,"n(");  break;
		case SIG_E1 : strcpy(ssigtext,"Empfang Teilnehmer 1"); strcpy(sst,"e1(");  break;
		case SIG_E2 : strcpy(ssigtext,"Empfang andere Teilnehmer"); strcpy(sst,"e2(");  break;
		case SIG_E  : strcpy(ssigtext,"Empfangssignal"); strcpy(sst,"e(");  break;
		case SIG_R : strcpy(ssigtext,"Ausgang vom RAKE"); strcpy(sst,"r(");  break;
		case SIG_XTKR : strcpy(ssigtext,"x(t-Tkr)"); strcpy(sst,"x(");  break;
		case SIG_B : strcpy(ssigtext,"b(t)"); strcpy(sst,"b(");  break;
		case SIG_D : strcpy(ssigtext,"d(t)"); strcpy(sst,"d(");  break;
		case SIG_V : strcpy(ssigtext,"v(t)"); strcpy(sst,"v(");  break;
	 }

	pixel=par->Signal[signal].pixel;
	int laenge = par->Signal[signal].laenge;
	laenge = 50;
	pixel=5;
	int folglen1=par->laenge1;
	int datenbits = par->Signal[signal].datenbits;

	memwidth = rcc.Width();




	 TClientDC dc(*this);
	 if (bitmap) delete bitmap;
	 bitmap =  new TBitmap(dc,rcc.Width(),rcc.Height()-90,FALSE);
	 bitexist = TRUE;
	 TMemoryDC memdc(dc);
	 memdc.SelectObject(*bitmap);

	 TSize Grid(pixel,pixel);
	 memdc.FillRect(rcc,TBrush(TColor::White));


	 struct sigstruct { int l,r,l0,r0;
							  float min,max;
							} sigpar;

	 sigpar.l=0;
	 sigpar.r=10;
	 sigpar.l0=0;
	 sigpar.r0=laenge;
	 int min=par->Signal[signal].min;
	 int max=par->Signal[signal].max;

	 sigpar.min = min - (max-min)*0.2;
	 sigpar.max = max + (max-min)*0.25;

	 int i;
	 LONG y,xf;
	 float yp;
	 LONG ymax = rcc.Height()-90;
	 LONG xmax = memwidth;


	 TBrush br(RGB(164,200,240));
	 TPen pn5(RGB(0,180,0),1,PS_SOLID);
	 memdc.SelectObject(pn5);

TRect zrect = rcc;
		zrect.top = 90;
		zrect.bottom = 90 + zrect.Height() * 0.9;
		zrect.left = zrect.Width() * 0.05;

zxmax = zrect.Width();
int zymax = abs(zrect.Height());
if (zymax==0)return;

double yf;
char sx[255];
LONG x;
int hoch = (rcc.Height()-90) * 0.07;
int breit = rcc.Width() * 0.01;
if (hoch <1)return;
if (breit <1)return;
if (hoch >200)return;
if (breit >200)return;
TFont font("Times New Roman",hoch,breit);
TFont fontk("Times New Roman",(int)(hoch*0.8),(int)breit*0.8);
memdc.SelectObject(font);

for (i= -5;i<0;i++)
  {
	  for (y = 1; y<= 9;y++)
		 {
			 yf = pow10(i) * y;
			 yf = log10(yf) + 5;
			 yf = yf / 5 * zymax;

			 memdc.MoveTo(zrect.left,zrect.bottom-yf-90);
			 memdc.LineTo(zrect.left+zxmax,zrect.bottom-yf-90);
			 if (y == 1)
				{
               memdc.TextOut(0,zrect.bottom-yf-90-hoch*0.6,"10");
               sprintf(sx,"%d",i);
               memdc.SelectObject(fontk);
               memdc.TextOut(breit*2.8,zrect.bottom-yf-90-hoch*0.8,sx);
               memdc.SelectObject(font);

               if (i == -1)
                 {
                   memdc.TextOut(0,zrect.bottom-yf-90-hoch*2,"BER");

					  }

				}

       }
  }
//1vreturn;
for (i=0;i<=10;i++)
  {
	  x = i * zxmax / 10;
		 memdc.MoveTo(zrect.left+x,zrect.bottom-90);
		 memdc.LineTo(zrect.left+x,zrect.top-90);
		 sprintf(sx,"%d",i);
		 if (i==10) x-=breit*2;
		 memdc.TextOut(zrect.left+x-breit*0.5,zrect.bottom-90,sx);
		if (i==8)
			 {
				memdc.TextOut(zrect.left+x+breit*2,zrect.bottom-90+hoch*0.4,"E  /N");
				memdc.TextOut(zrect.left+9*zxmax/10.1+breit*2,zrect.bottom-90+hoch*0.4,"[dB]");

				memdc.SelectObject(fontk);
				memdc.TextOut(zrect.left+x+breit*3.3,zrect.bottom-90+hoch*0.7,"b");
				memdc.TextOut(zrect.left+x+breit*7.2,zrect.bottom-90+hoch*0.7,"0");
				memdc.SelectObject(font);
			 }
  }

	 TPen pn7(RGB(0,0,200),1,PS_SOLID);
	 memdc.SelectObject(pn7);

if (zymax==0)return;
//3vreturn;
for (i=0;i<=20;i++)
  {
	  x = i * zxmax / 20;
	  yf = fehleropt[i]/2;
	  yf = log10(yf) + 5;
	  yf = yf / 5 * zymax;

	  if(i==0) 	 memdc.MoveTo(zrect.left+x,zrect.bottom-yf-90);
		 else memdc.LineTo(zrect.left+x,zrect.bottom-yf-90);
  }

	 TPen pn8(RGB(255,0,0),1,PS_SOLID);
	 memdc.SelectObject(pn8);
	 TPen pn9(RGB(0,0,0),1,PS_SOLID);
int cx,cy;
int satz;
//4vreturn;//4
zxleft = zrect.left;
for (satz=2;satz >0;satz--)
 for (i=0;i<=10;i++)
  {
if (fehlerdia->fehleron[satz][i]==TRUE)
  {  x = i * zxmax / 10;
	  yf = fehlerdia->fehler[satz][i];
	  if (yf < 1e-10) yf = 1e-10;

	  yf = log10(yf) + 5;
	  yf = yf / 5 * zymax;

	  cx = zrect.left+x;
	  cy = zrect.bottom-yf-90;
	 if (satz==1)  memdc.SelectObject(pn9);

		memdc.Ellipse(cx-5,cy-5,cx+5,cy+5);
  }

  }
  memdc.SelectObject(pn8);

//2nreturn;//2
BOOL start;
if (fehlerdia->verbinden == TRUE)
 for (satz=2;satz >0;satz--)
  {
  start = TRUE;
  for (i=0;i<=10;i++)
  {
	  if (satz==1)  memdc.SelectObject(pn9);

	  x = i * zxmax / 10;
	  yf = fehlerdia->fehler[satz][i];
	  if (yf < 1e-10) yf = 1e-10;
	  yf = log10(yf) + 5;
     yf = yf / 5 * zymax;

     cx = zrect.left+x;
	  cy = zrect.bottom-yf-90;
     if (fehlerdia->fehleron[satz][i]==TRUE) {  if (start == TRUE)  memdc.MoveTo(cx,cy);
                                            else memdc.LineTo(cx,cy);
                                          start = FALSE;
                                       }


  }
  }


memdc.RestoreBitmap();
Invalidate(FALSE);
UpdateWindow();
return;


}




void FehlerWin::EvLButtonDblClk (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDblClk(modKeys, point);

}

void FehlerWin::Titelsetzen()
{
	 strcpy(title,"Fehlerwahrscheinlichkeit");
	 Parent->SetWindowText(title);

}


void FehlerWin::EvMouseMove (UINT modKeys, TPoint& point)
{
  if (Initialisierung != INIT_OK) return;
 char s[255];
 strcpy(s,"  ");
	 TWindow::EvMouseMove(modKeys, point);
char s1[255];
if (zxmax==0)return;

LONG x = point.x;
  int i= (x-zxleft)*10/zxmax;
  if ((float)(x-zxleft)*10/zxmax >9.7) i=10;
  if (fehlerdia->fehleron[1][i]==TRUE)
   {
	 sprintf(s,"Satz1:BER(%d) = %1.5f",i,fehlerdia->fehler[1][i]);
	 fehlerdia->staticfehler1->SetText(s);
   }
    else  fehlerdia->staticfehler1->SetText("  ");
  if (fehlerdia->fehleron[2][i]==TRUE)
   {
	 sprintf(s,"Satz2:BER(%d) = %1.5f",i,fehlerdia->fehler[2][i]);
	 fehlerdia->staticfehler2->SetText(s);
   }
    else  fehlerdia->staticfehler2->SetText("  ");

		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();

		  if (par1->folgegueltig == FALSE) client->Transfer(s,5);
		  if (par2->folgegueltig == FALSE) client->Transfer(s,6);

}





UINT FehlerWin::Transfer (void* buffer, TTransferDirection direction)
{
	 UINT result;

	 if (direction <= 2 ) result = TWindow::Transfer(buffer, direction);
	 else
		{
  if (Initialisierung != INIT_OK) return 0;
			if (direction == 58) Fenster();
			if (direction == 3)
									 {
										if (Parametersatz == 1)
																		{
																		  for (int i=0;i<=10;i++)fehlerdia->fehleron[1][i]=FALSE;
                                                        fehlerdia->Update();
																		  Fenster();
																		}
									 }

			if (direction == 4)
									 {
										if (Parametersatz == 2)
																		{
																		  for (int i=0;i<=10;i++)fehlerdia->fehleron[2][i]=FALSE;
                                                        fehlerdia->Update();
																		  Fenster();
																		}
									 }

int t;
int p = par->ScrollPos;
if (par->laenge1==0)return result;

if ((signal==SIG_Q) || (signal == SIG_V)) p=p/par->laenge1;
			if (direction == 11)
									 {
										if (Parametersatz == 1)
																		{
																		}
									 }

			if (direction == 12)
									 {
										if (Parametersatz == 2)
																		{
																		}
									 }

		}
	 return result;
}



void FehlerWin::EvHScroll (UINT scrollCode, UINT thumbPos, HWND hWndCtl)
{
	 TWindow::EvHScroll(scrollCode, thumbPos, hWndCtl);
}

