/*  Projekt CDMA
	 Copyright  1995. 

    SYSTEM:       CDMA.EXE  (Application)
    DATEI:        fehlrdlg.cpp
	 AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Quelltextdatei fuer die Implementation von FehlerDialog (TDialog).
*/

#define W(x) (x)/16000][(x)%16000
#include <owl\owlpch.h>
#pragma hdrstop

#include "fehlrdlg.h"


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(FehlerDialog, TDialog)
//{{FehlerDialogRSP_TBL_BEGIN}}
    EV_BN_CLICKED(IDC_CHECK0dB, check0BNClicked),
    EV_BN_CLICKED(IDC_CHECK10dB, check10BNClicked),
    EV_BN_CLICKED(IDC_CHECK1dB, check1BNClicked),
    EV_BN_CLICKED(IDC_CHECK2dB, check2BNClicked),
	 EV_BN_CLICKED(IDC_CHECK3dB, check3BNClicked),
    EV_BN_CLICKED(IDC_CHECK4dB, check4BNClicked),
    EV_BN_CLICKED(IDC_CHECK5dB, check5BNClicked),
    EV_BN_CLICKED(IDC_CHECK6dB, check6BNClicked),
    EV_BN_CLICKED(IDC_CHECK7dB, check7BNClicked),
    EV_BN_CLICKED(IDC_CHECK8dB, check8BNClicked),
    EV_BN_CLICKED(IDC_CHECK9dB, check9BNClicked),
    EV_BN_CLICKED(IDC_CHECKPARSATZ1, checkpar1BNClicked),
    EV_BN_CLICKED(IDC_CHECKPARSATZ2, checkpar2BNClicked),
    EV_BN_CLICKED(IDC_CHECKVERBINDEN, checkverbindenBNClicked),
    EV_BN_CLICKED(IDC_PUSHALLE, pushalleBNClicked),
    EV_BN_CLICKED(IDC_PUSHALLE2, pushalle2BNClicked),
    EV_BN_CLICKED(IDC_CHECKABBRUCH, checkabbruchBNClicked),
//{{FehlerDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{FehlerDialog Implementation}}


static FehlerDialogXfer FehlerDialogData;

FehlerDialog::FehlerDialog (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 Initialisierung = INIT_START;

//{{FehlerDialogXFER_USE}}
    check0db = new TCheckBox(this, IDC_CHECK0dB, 0);
    check10db = new TCheckBox(this, IDC_CHECK10dB, 0);
    check1db = new TCheckBox(this, IDC_CHECK1dB, 0);
    check2db = new TCheckBox(this, IDC_CHECK2dB, 0);
    check3db = new TCheckBox(this, IDC_CHECK3dB, 0);
    check4db = new TCheckBox(this, IDC_CHECK4dB, 0);
    check5db = new TCheckBox(this, IDC_CHECK5dB, 0);
    check6db = new TCheckBox(this, IDC_CHECK6dB, 0);
    check7db = new TCheckBox(this, IDC_CHECK7dB, 0);
    check8db = new TCheckBox(this, IDC_CHECK8dB, 0);
    check9db = new TCheckBox(this, IDC_CHECK9dB, 0);
    checkpar1 = new TCheckBox(this, IDC_CHECKPARSATZ1, 0);
    checkpar2 = new TCheckBox(this, IDC_CHECKPARSATZ2, 0);
    checkverbinden = new TCheckBox(this, IDC_CHECKVERBINDEN, 0);
    pushalle = new TButton(this, IDC_PUSHALLE);
    staticfehler1 = new TStatic(this, IDT_FEHLER1, 255);
    editabbruch = new Spinedit(this, IDC_EDITABBRUCH, 255);
    editdurchlauf = new Spinedit(this, IDC_EDITFEHLERDURCHLAUF, 255);
    checkabbruch = new TCheckBox(this, IDC_CHECKABBRUCH, 0);
	 pushalle2 = new TButton(this, IDC_PUSHALLE2);
    staticfehler2 = new TStatic(this, IDT_FEHLER2, 255);

    SetTransferBuffer(&FehlerDialogData);
//{{FehlerDialogXFER_USE_END}}

  nlistealt = new int[32000];
  e2listealt = new int[32000];
  wahrlistealt = new int[32000];


	 int i;
	 Parametersatz = 1;
	 Satz1 = TRUE;
	 Satz2 = FALSE;
	 checkpar1->Check();
	 checkpar2->Uncheck();
	 par = par1;
	 verbinden = FALSE;
	 checkverbinden->Uncheck();
	 editdurchlauf->SetRange(durchlaeufe,1,50,1,SPIN_EINS,20);
	 editabbruch->SetRange(abbruch,1,5000,1,SPIN_EINS,100);
	 abbruchmoeglich = FALSE;
	 for (i=0;i<=10;i++) {
								  fehleron[1][i] = FALSE;
								  fehleron[2][i] = FALSE;
								}


}


FehlerDialog::~FehlerDialog ()
{
    Destroy();


}


void FehlerDialog::check0BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check0db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][0]==FALSE) if (Satz1 == TRUE){  up=1; check0db->Check(); Fehlerrechnen(0); }
				if(fehleron[2][0]==FALSE) if (Satz2 == TRUE){  up=1; check0db->Check(); Fehlerrechnen(0); }
				if (up==0)
				 {
					check0db->Uncheck();
					fehleron[1][0] = FALSE;
					fehleron[2][0] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][0]==FALSE) if (Satz1 == TRUE){  check0db->Check(); Fehlerrechnen(0); }
				if(fehleron[2][0]==FALSE) if (Satz2 == TRUE){  check0db->Check(); Fehlerrechnen(0); }
	 }
}


void FehlerDialog::check1BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check1db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][1]==FALSE) if (Satz1 == TRUE){  up=1; check1db->Check(); Fehlerrechnen(1); }
				if(fehleron[2][1]==FALSE) if (Satz2 == TRUE){  up=1; check1db->Check(); Fehlerrechnen(1); }
				if (up==0)
				 {
					check1db->Uncheck();
					fehleron[1][1] = FALSE;
					fehleron[2][1] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][1]==FALSE) if (Satz1 == TRUE){  check1db->Check(); Fehlerrechnen(1); }
				if(fehleron[2][1]==FALSE) if (Satz2 == TRUE){  check1db->Check(); Fehlerrechnen(1); }
	 }
}


void FehlerDialog::check2BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check2db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][2]==FALSE) if (Satz1 == TRUE){  up=1; check2db->Check(); Fehlerrechnen(2); }
				if(fehleron[2][2]==FALSE) if (Satz2 == TRUE){  up=1; check2db->Check(); Fehlerrechnen(2); }
				if (up==0)
				 {
					check2db->Uncheck();
					fehleron[1][2] = FALSE;
					fehleron[2][2] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][2]==FALSE) if (Satz1 == TRUE){  check2db->Check(); Fehlerrechnen(2); }
				if(fehleron[2][2]==FALSE) if (Satz2 == TRUE){  check2db->Check(); Fehlerrechnen(2); }
	 }
}


void FehlerDialog::check3BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check3db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][3]==FALSE) if (Satz1 == TRUE){  up=1; check3db->Check(); Fehlerrechnen(3); }
				if(fehleron[2][3]==FALSE) if (Satz2 == TRUE){  up=1; check3db->Check(); Fehlerrechnen(3); }
				if (up==0)
				 {
					check3db->Uncheck();
					fehleron[1][3] = FALSE;
					fehleron[2][3] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][3]==FALSE) if (Satz1 == TRUE){  check3db->Check(); Fehlerrechnen(3); }
				if(fehleron[2][3]==FALSE) if (Satz2 == TRUE){  check3db->Check(); Fehlerrechnen(3); }
	 }
}


void FehlerDialog::check4BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check4db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][4]==FALSE) if (Satz1 == TRUE){  up=1; check4db->Check(); Fehlerrechnen(4); }
				if(fehleron[2][4]==FALSE) if (Satz2 == TRUE){  up=1; check4db->Check(); Fehlerrechnen(4); }
				if (up==0)
				 {
					check4db->Uncheck();
					fehleron[1][4] = FALSE;
					fehleron[2][4] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][4]==FALSE) if (Satz1 == TRUE){  check4db->Check(); Fehlerrechnen(4); }
				if(fehleron[2][4]==FALSE) if (Satz2 == TRUE){  check4db->Check(); Fehlerrechnen(4); }
	 }
}


void FehlerDialog::check5BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check5db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][5]==FALSE) if (Satz1 == TRUE){  up=1; check5db->Check(); Fehlerrechnen(5); }
				if(fehleron[2][5]==FALSE) if (Satz2 == TRUE){  up=1; check5db->Check(); Fehlerrechnen(5); }
				if (up==0)
				 {
					check5db->Uncheck();
					fehleron[1][5] = FALSE;
					fehleron[2][5] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][5]==FALSE) if (Satz1 == TRUE){  check5db->Check(); Fehlerrechnen(5); }
				if(fehleron[2][5]==FALSE) if (Satz2 == TRUE){  check5db->Check(); Fehlerrechnen(5); }
	 }
}


void FehlerDialog::check6BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check6db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][6]==FALSE) if (Satz1 == TRUE){  up=1; check6db->Check(); Fehlerrechnen(6); }
				if(fehleron[2][6]==FALSE) if (Satz2 == TRUE){  up=1; check6db->Check(); Fehlerrechnen(6); }
				if (up==0)
				 {
					check6db->Uncheck();
					fehleron[1][6] = FALSE;
					fehleron[2][6] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][6]==FALSE) if (Satz1 == TRUE){  check6db->Check(); Fehlerrechnen(6); }
				if(fehleron[2][6]==FALSE) if (Satz2 == TRUE){  check6db->Check(); Fehlerrechnen(6); }
	 }
}


void FehlerDialog::check7BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check7db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][7]==FALSE) if (Satz1 == TRUE){  up=1; check7db->Check(); Fehlerrechnen(7); }
				if(fehleron[2][7]==FALSE) if (Satz2 == TRUE){  up=1; check7db->Check(); Fehlerrechnen(7); }
				if (up==0)
				 {
					check7db->Uncheck();
					fehleron[1][7] = FALSE;
					fehleron[2][7] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][7]==FALSE) if (Satz1 == TRUE){  check7db->Check(); Fehlerrechnen(7); }
				if(fehleron[2][7]==FALSE) if (Satz2 == TRUE){  check7db->Check(); Fehlerrechnen(7); }
	 }
}


void FehlerDialog::check8BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check8db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][8]==FALSE) if (Satz1 == TRUE){  up=1; check8db->Check(); Fehlerrechnen(8); }
				if(fehleron[2][8]==FALSE) if (Satz2 == TRUE){  up=1; check8db->Check(); Fehlerrechnen(8); }
				if (up==0)
				 {
					check8db->Uncheck();
					fehleron[1][8] = FALSE;
					fehleron[2][8] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][8]==FALSE) if (Satz1 == TRUE){  check8db->Check(); Fehlerrechnen(8); }
				if(fehleron[2][8]==FALSE) if (Satz2 == TRUE){  check8db->Check(); Fehlerrechnen(8); }
	 }
}


void FehlerDialog::check9BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check9db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][9]==FALSE) if (Satz1 == TRUE){  up=1; check9db->Check(); Fehlerrechnen(9); }
				if(fehleron[2][9]==FALSE) if (Satz2 == TRUE){  up=1; check9db->Check(); Fehlerrechnen(9); }
				if (up==0)
				 {
					check9db->Uncheck();
					fehleron[1][9] = FALSE;
					fehleron[2][9] = FALSE;
					Update();
				 }
			 }
	  else
			 {
				if(fehleron[1][9]==FALSE) if (Satz1 == TRUE){  check9db->Check(); Fehlerrechnen(9); }
				if(fehleron[2][9]==FALSE) if (Satz2 == TRUE){  check9db->Check(); Fehlerrechnen(9); }
	 }
}


void FehlerDialog::check10BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (check10db->GetCheck() == BN_CLICKED)
			 {
				int up = 0;
				if(fehleron[1][10]==FALSE) if (Satz1 == TRUE){  up=1; check10db->Check(); Fehlerrechnen(10); }
				if(fehleron[2][10]==FALSE) if (Satz2 == TRUE){  up=1; check10db->Check(); Fehlerrechnen(10); }
				if (up==0)
				 {
					check10db->Uncheck();
					fehleron[1][10] = FALSE;
					fehleron[2][10] = FALSE;
					Update();
				 }
			 }
	  else
			 {
            if(fehleron[1][10]==FALSE) if (Satz1 == TRUE){  check10db->Check(); Fehlerrechnen(10); }
            if(fehleron[2][10]==FALSE) if (Satz2 == TRUE){  check10db->Check(); Fehlerrechnen(10); }
    }
}



void FehlerDialog::checkpar1BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (Satz1 == TRUE)      {
                              Satz1 = FALSE;
                              Satz2 = TRUE;
                              for (int i=0;i<=10;i++) fehleron[1][i]=FALSE;
                              checkpar1->Uncheck();
                              checkpar2->Check();
                           }
   else
                           {
                              Satz1 = TRUE;
                              checkpar1->Check();
                              for (int i=0;i<=10;i++) fehleron[1][i]=FALSE;
                           }

	Update();
}


void FehlerDialog::checkpar2BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (Satz2 == TRUE)      {
										Satz2 = FALSE;
										Satz1 = TRUE;
										for (int i=0;i<=10;i++) fehleron[2][i]=FALSE;
                              checkpar2->Uncheck();
                              checkpar1->Check();
                           }
   else
                           {
                              Satz2 = TRUE;
                              checkpar2->Check();
                              for (int i=0;i<=10;i++) fehleron[2][i]=FALSE;
                           }

   Update();

}


void FehlerDialog::checkverbindenBNClicked ()
{
  if (Initialisierung != INIT_OK) return;

  if (verbinden == TRUE) { verbinden = FALSE; checkverbinden->Uncheck(); }
	 else { verbinden = TRUE; checkverbinden->Check(); }
  Update();
}


void FehlerDialog::pushalleBNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	BOOL alle = TRUE;
	for (int i=0;i<=10;i++) if (fehleron[1][i]== FALSE) alle = FALSE;
	for (i=0;i<=10;i++) if (fehleron[2][i]== FALSE) alle = FALSE;
	if (alle == TRUE) for (i=0;i<=10;i++) { fehleron[1][i]=FALSE; fehleron[2][i]=FALSE; }

	 if (fehleron[1][0] == FALSE) { check0db->Check(); check0BNClicked(); }
	 if (fehleron[1][1] == FALSE) { check1db->Check(); check1BNClicked(); }
	 if (fehleron[1][2] == FALSE) { check2db->Check(); check2BNClicked(); }
	 if (fehleron[1][3] == FALSE) { check3db->Check(); check3BNClicked(); }
	 if (fehleron[1][4] == FALSE) { check4db->Check(); check4BNClicked(); }
	 if (fehleron[1][5] == FALSE) { check5db->Check(); check5BNClicked(); }
	 if (fehleron[1][6] == FALSE) { check6db->Check(); check6BNClicked(); }
	 if (fehleron[1][7] == FALSE) { check7db->Check(); check7BNClicked(); }
	 if (fehleron[1][8] == FALSE) { check8db->Check(); check8BNClicked(); }
	 if (fehleron[1][9] == FALSE) { check9db->Check(); check9BNClicked(); }
	 if (fehleron[1][10] == FALSE) { check10db->Check(); check10BNClicked(); }

    if (fehleron[2][0] == FALSE) { check0db->Check(); check0BNClicked(); }
    if (fehleron[2][1] == FALSE) { check1db->Check(); check1BNClicked(); }
    if (fehleron[2][2] == FALSE) { check2db->Check(); check2BNClicked(); }
    if (fehleron[2][3] == FALSE) { check3db->Check(); check3BNClicked(); }
    if (fehleron[2][4] == FALSE) { check4db->Check(); check4BNClicked(); }
    if (fehleron[2][5] == FALSE) { check5db->Check(); check5BNClicked(); }
	 if (fehleron[2][6] == FALSE) { check6db->Check(); check6BNClicked(); }
	 if (fehleron[2][7] == FALSE) { check7db->Check(); check7BNClicked(); }
    if (fehleron[2][8] == FALSE) { check8db->Check(); check8BNClicked(); }
    if (fehleron[2][9] == FALSE) { check9db->Check(); check9BNClicked(); }
    if (fehleron[2][10] == FALSE) { check10db->Check(); check10BNClicked(); }
}


void FehlerDialog::SetupWindow ()
{
    TDialog::SetupWindow();

	 int i;
    Parametersatz = 1;
	 Satz1 = TRUE;
	 Satz2 = FALSE;
	 checkpar1->Check();
	 checkpar2->Uncheck();
	 par = par1;
	 verbinden = FALSE;
	 checkverbinden->Uncheck();
	 editdurchlauf->SetRange(durchlaeufe,1,50,1,SPIN_EINS,20);
	 editabbruch->SetRange(abbruch,1,5000,1,SPIN_EINS,100);
	 abbruchmoeglich = FALSE;
	 checkabbruch->Uncheck();
	 staticfehler1->SetText("  ");
	 staticfehler2->SetText("  ");
	 for (i=0;i<=10;i++) {
								  fehleron[1][i] = FALSE;
								  fehleron[2][i] = FALSE;
								}

	 Initialisierung = INIT_OK;

}


UINT FehlerDialog::Transfer (void* buffer, TTransferDirection direction)
{
	 UINT result;

	 result = TDialog::Transfer(buffer, direction);



	 return result;
}


void FehlerDialog::Update()
{
  if (Initialisierung != INIT_OK) return;


	if (fehleron[1][0]||fehleron[2][0]) check0db->Check(); else check0db->Uncheck();
	if (fehleron[1][1]||fehleron[2][1]) check1db->Check(); else check1db->Uncheck();
	if (fehleron[1][2]||fehleron[2][2]) check2db->Check(); else check2db->Uncheck();
	if (fehleron[1][3]||fehleron[2][3]) check3db->Check(); else check3db->Uncheck();
   if (fehleron[1][4]||fehleron[2][4]) check4db->Check(); else check4db->Uncheck();
   if (fehleron[1][5]||fehleron[2][5]) check5db->Check(); else check5db->Uncheck();
   if (fehleron[1][6]||fehleron[2][6]) check6db->Check(); else check6db->Uncheck();
	if (fehleron[1][7]||fehleron[2][7]) check7db->Check(); else check7db->Uncheck();
   if (fehleron[1][8]||fehleron[2][8]) check8db->Check(); else check8db->Uncheck();
   if (fehleron[1][9]||fehleron[2][9]) check9db->Check(); else check9db->Uncheck();
   if (fehleron[1][10]||fehleron[2][10]) check10db->Check(); else check10db->Uncheck();
 char s[255];
 strcpy(s,"  ");
 Parent->Transfer(s,58);


}

void FehlerDialog::Fehlerrechnen(int rauschen)
{
  if (Initialisierung != INIT_OK) return;

 char s[255];
	 if (Satz1 == TRUE) { Fehlerrechnen1par(rauschen,1);
								 sprintf(s,"Satz1:BER(%d) = %1.5f",rauschen,fehler[1][rauschen]);
                     	 staticfehler1->SetText(s);
                         staticfehler2->SetText("  ");
                       }
                       else staticfehler1->SetText("  ");
    if (Satz2 == TRUE) { Fehlerrechnen1par(rauschen,2);
								 sprintf(s,"Satz2:BER(%d) = %1.5f",rauschen,fehler[2][rauschen]);
                     	 staticfehler2->SetText(s);
								 staticfehler1->SetText("  ");
                       }
                       else staticfehler2->SetText("  ");

}



void FehlerDialog::Fehlerrechnen1par(int rauschen,int Parsatz)
{
  if (Initialisierung != INIT_OK) return;

if (fehleron[Parsatz][rauschen]==TRUE) return;

HCURSOR WaitCursor;
WaitCursor = ::LoadCursor(GetApplication()->GetMainWindow()->GetModule()->GetInstance(), MAKEINTRESOURCE(CURSOR_1));
::SetCursor(WaitCursor);

if (Parsatz == 1) par = par1; else par = par2;
if (par->laenge1 == 0) return;

int i;
for (i=0;i<30000;i++) {
								 wahrlistealt[i] = par->Signal[SIG_Q].folge[i];
								 nlistealt[i] = par->Signal[SIG_N].folge[i];
								 e2listealt[i] = par->Signal[SIG_E2].folge[i];
							 }


bitsprodurchlauf = 32000/par->laenge1;
if (bitsprodurchlauf > 1000) bitsprodurchlauf -= bitsprodurchlauf % 1000;
if (bitsprodurchlauf > 500) bitsprodurchlauf -= bitsprodurchlauf % 100;

int rauschenalt = par->rauschen;
par->rauschen = rauschen*10;

int durchlaufges = durchlaeufe;


int x;
char s[255];
	 UpdateWindow();

fehlerbits=0;
LONG k;
int d;
int dakt;
dakt = durchlaeufe;
double kf;
LONG abbrch = abbruch;
if (abbruchmoeglich == FALSE) abbrch = 2000000000;
for (d=1;(d<=dakt)&&(fehlerbits<abbrch);d++)
  {
	  par->wdfbits=bitsprodurchlauf;
	  par->ParameterUpdate();


	 for (i=0;i<par->Signal[SIG_WDF].laenge;i++)
	 {

		 if (par->Signal[SIG_Q].folge[i+20] != par->Signal[SIG_V].folge[i+20]) fehlerbits++;
	 }
	 sprintf(s,"Berechnung Satz %d, %d von %d Durchlufen",Parsatz,d,dakt);
	 staticfehler1->SetText(s);
	 sprintf(s,"%ddB: %4.0f Fehler bei %6.0f Bits",rauschen,(float)fehlerbits,(float)d*bitsprodurchlauf);
	 staticfehler2->SetText(s);

	 wdfgueltig = FALSE;
	 strcpy(s," ");

  }


if ((double)(d-1)*bitsprodurchlauf < 1.0) return;
fehler[Parsatz][rauschen]=(double)fehlerbits/((double)(d-1)*bitsprodurchlauf);
fehleron[Parsatz][rauschen]= TRUE;
durchlaeufe=durchlaufges;
par->rauschen = rauschenalt;

for (i=0;i<30000;i++) {
								 par->Signal[SIG_Q].folge[i] = wahrlistealt[i];
								 par->Signal[SIG_N].folge[i] = nlistealt[i];
								 par->Signal[SIG_E2].folge[i] = e2listealt[i];
							 }

par->altuebernehmen = TRUE;
par->ParameterUpdate();
wdfgueltig = FALSE;
Parent->Transfer(s,58);
Parent->Invalidate();

}

void FehlerDialog::pushalle2BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	 if (fehleron[1][0] == FALSE) { check0db->Check(); check0BNClicked(); }
	 if (fehleron[1][3] == FALSE) { check3db->Check(); check3BNClicked(); }
	 if (fehleron[1][6] == FALSE) { check6db->Check(); check6BNClicked(); }
	 if (fehleron[1][9] == FALSE) { check9db->Check(); check9BNClicked(); }

	 if (fehleron[2][0] == FALSE) { check0db->Check(); check0BNClicked(); }
	 if (fehleron[2][3] == FALSE) { check3db->Check(); check3BNClicked(); }
	 if (fehleron[2][6] == FALSE) { check6db->Check(); check6BNClicked(); }
	 if (fehleron[2][9] == FALSE) { check9db->Check(); check9BNClicked(); }

}


void FehlerDialog::checkabbruchBNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (abbruchmoeglich == TRUE) {abbruchmoeglich = FALSE; checkabbruch->Uncheck(); }
	  else { abbruchmoeglich = TRUE; checkabbruch->Check(); }
}

