#if !defined(__fehlrdlg_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __fehlrdlg_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        fehlrdlg.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer FehlerDialog (TDialog).
*/

#include <owl\edit.h>
#include <owl\static.h>
#include <owl\button.h>
#include <owl\checkbox.h>
#include <owl\owlpch.h>
#include "prmtrdlg.h"
#pragma hdrstop

#include <owl\dialog.h>

#include "pnapp.rh"            // Definition aller Ressourcen


//{{TDialog = FehlerDialog}}
struct FehlerDialogXfer {
//{{FehlerDialogXFER_DATA}}
    BOOL    check0db;
    BOOL    check10db;
    BOOL    check1db;
    BOOL    check2db;
    BOOL    check3db;
    BOOL    check4db;
    BOOL    check5db;
    BOOL    check6db;
    BOOL    check7db;
    BOOL    check8db;
    BOOL    check9db;
    BOOL    checkpar1;
    BOOL    checkpar2;
    BOOL    checkverbinden;
    char    staticfehler[ 255 ];
    char    editabbruch[ 255 ];
    char    editdurchlauf[ 255 ];
    BOOL    checkabbruch;
    char    staticfehler2[ 255 ];
//{{FehlerDialogXFER_DATA_END}}
};


class FehlerDialog : public TDialog {
public:
    FehlerDialog (TWindow* parent, TResId resId = IDD_FEHLER, TModule* module = 0);
    virtual ~FehlerDialog ();


public:

    ParameterDialog* par;
    ParameterDialog* par1;
    ParameterDialog* par2;

    int Initialisierung;
    int fehleron[3][12];
    float fehler[3][12];
    int Parametersatz;
    BOOL verbinden;


    int durchlaeufe;
    int abbruch;
    BOOL abbruchmoeglich;
    int bitsprodurchlauf;
    int memwidth;
    int wdfmin;
    int wdfmax;
    LONG wdflaenge;
    BOOL wdfgueltig;
    int wdfnull;
    BOOL eindurchlauf;
    LONG fehlerbits;

    BOOL Satz1;
    BOOL Satz2;

    int *wahrlistealt;
    int *nlistealt;
    int *e2listealt;

    void Update();
    void Fehlerrechnen(int);
    void Fehlerrechnen1par(int,int);
    TStatic *staticfehler1;
    TStatic *staticfehler2;

//{{FehlerDialogXFER_DEF}}
protected:
    TCheckBox *check0db;
    TCheckBox *check10db;
    TCheckBox *check1db;
    TCheckBox *check2db;
    TCheckBox *check3db;
    TCheckBox *check4db;
    TCheckBox *check5db;
    TCheckBox *check6db;
    TCheckBox *check7db;
    TCheckBox *check8db;
    TCheckBox *check9db;
    TCheckBox *checkpar1;
    TCheckBox *checkpar2;
    TCheckBox *checkverbinden;
    TButton *pushalle;
    Spinedit *editabbruch;
    Spinedit *editdurchlauf;
    TCheckBox *checkabbruch;
    TButton *pushalle2;

//{{FehlerDialogXFER_DEF_END}}

//{{FehlerDialogVIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
    virtual UINT Transfer (void* buffer, TTransferDirection direction);
//{{FehlerDialogVIRTUAL_END}}

//{{FehlerDialogRSP_TBL_BEGIN}}
protected:
    void check0BNClicked ();
    void check10BNClicked ();
    void check1BNClicked ();
    void check2BNClicked ();
    void check3BNClicked ();
    void check4BNClicked ();
    void check5BNClicked ();
    void check6BNClicked ();
    void check7BNClicked ();
    void check8BNClicked ();
    void check9BNClicked ();
    void checkpar1BNClicked ();
    void checkpar2BNClicked ();
    void checkverbindenBNClicked ();
    void pushalleBNClicked ();
    void pushalle2BNClicked ();
    void checkabbruchBNClicked ();
//{{FehlerDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(FehlerDialog);
};    //{{FehlerDialog}}


#endif                                      // __fehlrdlg_h

