/*  Projekt CDMA
	 Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        parmtrwn.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von ParameterWin (TWindow).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "parmtrwn.h"
#include <owl\groupbox.h>
//#include "var.h"


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(ParameterWin, TWindow)
//{{ParameterWinRSP_TBL_BEGIN}}
	 EV_WM_MOUSEMOVE,
	 EV_CBN_SELCHANGE(COMBO_SP,ComboSpreizChange),
	 EV_CBN_SELCHANGE(COMBO_LEN,ComboLENChange),
	 EV_CBN_SELCHANGE(COMBO_NR,ComboNRChange),
	 EV_WM_LBUTTONDOWN,
	 EV_WM_CLOSE,
//{{ParameterWinRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{ParameterWin Implementation}}


ParameterWin::ParameterWin (TWindow* parent, const char far* title, TModule* module):
	 TWindow(parent, title, module)
{
	 // Hintergrundfarbe des Fensters aendern
	 SetBkgndColor(RGB(0xc0, 0xc0, 0xc0));

	 // EINFUEGEN>> Ihren Konstruktor-Code fuegen Sie hier ein
//  Attr.Style |= WS_VSCROLL | WS_HSCROLL;
	Scroller = new TScroller(this, 1, 0, 80, 0);
	TRect winrect;
	LONG winx,winy;

	for (int i=0;i<11;i++) Signal[i].folge=new int[17000];

	par1=new ParameterDialog(this);
	par2=new ParameterDialog(this);
	winrect = GetClientRect();
	char s[255];

	wsprintf(s,"x: %4d, y: %4d ",winx,winy);

	 new TGroupBox(this,ID_STATIC,"Group",1113,3,235,160);

	 St_Parameter1 = new Staticgrau(this,ID_STATIC," ",1115,5,140,20);

	 St_Einfolge1 = new Staticgrau(this,ID_STATIC," ",1115,30,150,20);

	 St_Spreizfolge1 = new Staticgrau(this,ID_STATIC," ",1115,61,90,20);

	 SpinDaten = new TEdit(this,ID_STATIC,"spin",1150,26,80,30,0);
 //	 SpinDaten->LineMag = 5;

	 new Staticgrau(this,ID_STATIC,"Grad:",1115,90,47,20);
	 new Staticgrau(this,ID_STATIC,"Nr.",1127,90,30,20);
/*#define SP_PN 0
#define SP_M  1
#define SP_GOLD 2
#define SP_WALSH 3
#define SP_PHASE 4

typedef struct { int Spreiz;
			int PNLen;
			int PNNr;
			int MLen;
			int MNr;
			int GoldLen;
			int GoldNr;
			int WalshLen;
			int WalshNr;
			int PhaseLen;
			int PhaseNr;
		 } ParStruct;

ParStruct P1,P2;


.Spreiz = 0;
P1.PNLen = 4;
P1.PNNr  = 7;
P1.MLen = 7;
P1.MNr = 352;
*/

Init();

}


ParameterWin::~ParameterWin ()
{
	 Destroy();

	 // EINFUEGEN>> Ihren Destruktor-Code fuegen Sie hier ein

}


void ParameterWin::SetupWindow ()
{
	 TWindow::SetupWindow();
// -->
	 if (Teilnehmer == 0)
		CanDestroy = FALSE;
	 else
		CanDestroy = TRUE;
// -->
	par1->par1=par1;
   par1->par2=par2;
   par2->par1=par1;
   par2->par2=par2;
   par2->par = par2;
	par1->par = par1;
	if (Teilnehmer > 0) par1->par = par;
par1->Teilnehmer = Teilnehmer;
par2->Teilnehmer = 0;

if (Teilnehmer > 0)	Parent->MoveWindow(0,0,291,471,TRUE);

			 string s;
if (Teilnehmer == 0)	 par1->Parametersatz = 1; else par1->Parametersatz = Teilnehmer + 2;
	 par2->Parametersatz = 2;

	 par1->Create();
if (!Teilnehmer) par2->Create();

	 par1->MoveWindow(3,3,277,432,TRUE);
if (!Teilnehmer) 	 par2->MoveWindow(283,3,277,432,TRUE);

	 St_Parameter1->SetText((s = "Parametersatz 1").c_str());
	 St_Einfolge1->SetText((s = "Datensignal P(1) = ").c_str());
	 St_Spreizfolge1->SetText((s = "Spreizfolge:").c_str());

	 ComboSpreiz = new Combo(this,COMBO_SP,1100,58,130,154,CBS_DROPDOWNLIST,25);

	 ComboSpreiz->Create();
	// ComboSpreiz->SetFocus();
	 ComboSPLaenge = new Combo(this,COMBO_LEN,1160,89,60,155,CBS_DROPDOWNLIST,25);
	 ComboSPLaenge->Create();

	 ComboSPNr = new Combo(this,COMBO_NR,1150,89,80,170,CBS_DROPDOWNLIST,25);
	 ComboSPNr->Create();

	 ComboSpreiz->ClearList();
	 ComboSpreiz->AddString("PN-Folge");
	 ComboSpreiz->AddString("M-Sequenz");
	 ComboSpreiz->AddString("Gold-Code");
	 ComboSpreiz->AddString("Walsh-Funkt.");
	 ComboSpreiz->AddString("mehrph. Folge");

	 int i;
	 for(i=0;i<8;i++)PNlistenr[i]=0;
	 folglenindex=2; P1.PNLen=2;
	 PNlistenr[2]=2;
	 folgnr=2;
	 for(i=0;i<8;i++)Walshlistenr[i]=0;
	 P1.WalshLen=2;
	 WalshFolgedef();

if (Teilnehmer > 0)	Parent->MoveWindow(450,100,291,472,TRUE);
 else Parent->MoveWindow(0,0,571,472,TRUE);


	 Update();
}



void ParameterWin::SetText ()
{
	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein

}
BOOL ParameterWin::CanClose() {
return CanDestroy;
}

void ParameterWin::EvClose () {
	ParameterWin::CanClose();
}

void ParameterWin::EvMouseMove (UINT modKeys, TPoint& point)
{
	 TWindow::EvMouseMove(modKeys, point);

	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein
	 char s[255];

	 wsprintf(s,"x:%4d, y:%4d",point.x,point.y);
	 St_Parameter1->SetText(s);



}


void ParameterWin::Update ()
{
/*P1.Spreiz = 0;
P1.PNLen = 4;
P1.PNNr  = 7;
P1.MLen = 7;
P1.MNr = 352;
*/
int sp,neu;
int i;

folgechanged = TRUE;


if (P1.Spreiz == SP_PN)
  { if (folglenindex==-1) {
									  folglenindex=P1.PNLen;
									  folgnr = P1.PNNr;
								  }

	 if (folgnr==-1)       {
									  folgnr = PNlistenr[folglenindex];
								  }




	 P1.PNLen = folglenindex;
	 P1.PNNr = folgnr;

	 int listelen=InitVarPN(P1.PNLen+3);
	 PNlistenr[folglenindex]=folgnr;

	 ComboSpreiz->SetSelIndex(0);
	 ComboSPLaenge->ClearList();
	 ComboSPLaenge->AddString(" 3 ");
	 ComboSPLaenge->AddString(" 4 ");
	 ComboSPLaenge->AddString(" 5 ");
	 ComboSPLaenge->AddString(" 6 ");
	 ComboSPLaenge->AddString(" 7 ");
	 ComboSPLaenge->AddString(" 8 ");

	 ComboSPLaenge->SetSelIndex(P1.PNLen);
	 folglen=Getfolglen();

	 ComboSPNr->ClearList();
	 for (i=0;i<listelen;i++)
	 ComboSPNr->AddString(ListePN[i]);
	 ComboSPNr->SetSelIndex(PNlistenr[folglenindex]);
	 folglenext=1;
	 for(i=1;i<=folglen;i++) folglenext*=2;
	 folglenext--;
	 PNFolgedef();

  }


if (P1.Spreiz == SP_WALSH)
{
	 if (folglenindex==-1) {
									  folglenindex=P1.WalshLen;
									  folgnr = P1.WalshNr;
								  }
	 if (folgnr==-1)       {
									  folgnr = Walshlistenr[folglenindex];
								  }

	 P1.WalshLen = folglenindex;
	 P1.WalshNr = folgnr;


	 Walshlistenr[folglenindex]=folgnr;
	 P1.WalshNr=folgnr;
	 ComboSpreiz->SetSelIndex(3);
	 ComboSPLaenge->ClearList();
	 ComboSPLaenge->AddString(" 1 ");
	 ComboSPLaenge->AddString(" 2 ");
	 ComboSPLaenge->AddString(" 3 ");
	 ComboSPLaenge->AddString(" 4 ");
	 ComboSPLaenge->AddString(" 5 ");
	 ComboSPLaenge->AddString(" 6 ");

	 ComboSPLaenge->SetSelIndex(P1.WalshLen);
	 folglen=Getfolglen();
	 folglenext=1;
	 for(i=1;i<=folglen;i++) folglenext*=2;

	 ComboSPNr->ClearList();
	 for (i=0;i<folglenext;i++)
		{ wsprintf(s," %2d",i);
		  ComboSPNr->AddString(s);
		}
	 ComboSPNr->SetSelIndex(Walshlistenr[folglenindex]);


	 for(i=0;i<folglenext;i++) folge[i]=Walshfolge[P1.WalshNr][i];


  }




int look[3200];

  for (i=0;i<folglenext;i++) {
										 Signal[SIG_X1].folge[i]=folge[i];
										 look[i]=folge[i];
									  }
  Signal[SIG_X1].laenge=folglenext;
  Signal[SIG_X1].datenbits=1;
  Signal[SIG_X1].min=-1;
  Signal[SIG_X1].max=1;
  Signal[SIG_X1].pixel = 30;

  for (i=0;i<100;i++) Signal[SIG_Q].folge[i]=2*((float)random(2)-0.5);
  Signal[SIG_Q].laenge=10;
  Signal[SIG_Q].datenbits=10;
  Signal[SIG_Q].min=-1;
  Signal[SIG_Q].max=1;
  Signal[SIG_Q].pixel = 80;

  for (i=0;i<10*folglenext;i++)
			 Signal[SIG_S].folge[i]=Signal[SIG_Q].folge[i/folglenext]*Signal[SIG_X1].folge[i%folglenext];
  Signal[SIG_S].laenge=10*folglenext;
  Signal[SIG_S].datenbits=10;
  Signal[SIG_S].min=-1;
  Signal[SIG_S].max=1;
  Signal[SIG_S].pixel = 10;



}


void ParameterWin::PNFolgedef()
{
  LONG i,x;

  x=ComboSPNr->GetSelIndex();
  ComboSPNr->GetString(s,x);
  for (i=0;i<5;i++) if(s[i]==' ')s[i]='0';
  PNLaenge();      //PNBelegung holen
	 int aus=0;
	 int reglen = 4;

	 int regin[257];
	 for (i=0;i<=folglenext; i++) regin[i]=-1;
	 regin[1] = 1;
	 regin[4] = 1;
	 for (x=0;x<folglenext;x++)
	  {
		 aus = regin[folglen-1];
		 for (i=reglen-1;i>0; i--)
			{
			  if (PNBelegung[i] == 1)
				 {
					if (aus == regin[i]) aus = -1;
						else aus = 1;
				 }

			}

		 folge[x] = aus;
		 for (i=folglen-1;i>0;i--) regin[i] =regin[i-1];
		 regin[0] = aus;
	  }


i=0;

}



void ParameterWin::WalshFolgedef()
{
  int i,x;
  int k,y;

  x=ComboSPNr->GetSelIndex();
  ComboSPNr->GetString(s,x);


  Walshfolge[0][0]=-1;
  Walshfolge[0][1]=-1;
  Walshfolge[1][0]=-1;
  Walshfolge[1][1]=1;
  k=1;
  for (i=1;i<=5;i++)
	 {  k*=2;
		 for (x=k;x<2*k;x++)
			{
				for (y=0;y<k;y++)
				  Walshfolge[x][y] = Walshfolge[x-k][y];
			}
		 for (x=0;x<k;x++)
			{
				for (y=k;y<2*k;y++)
				  Walshfolge[x][y] = Walshfolge[x][y-k];
			}
		 for (x=k;x<2*k;x++)
			{
				for (y=k;y<2*k;y++)
				  Walshfolge[x][y] = -1+2*Walshfolge[x-k][y-k];
			}
	 }


i=0;

}




void ParameterWin::Init ()
{

P1.Spreiz = 0;
P1.PNLen = 4;
P1.PNNr  = 2;
P1.MLen = 7;
P1.MNr = 1;
P1.WalshLen=3;
P1.WalshNr = 1;

}

void ParameterWin::ComboSpreizChange ()
{   int x;
	 char s[255];
	 x=ComboSpreiz->GetSelIndex();
	 wsprintf(s,"x:%4d, y:%4d",x);
	 St_Parameter1->SetText(s);
	 folglenindex=-1;

	 int old,neu;
	 old = P1.Spreiz;
	 P1.Spreiz = ComboSpreiz->GetSelIndex();
	 if (old != P1.Spreiz) Update();

	 neu = ComboSPLaenge->GetSelIndex();

	 len = neu;
/*	 if (P1.Spreiz == SP_PN)  P1.PNLen = neu;
	 if (P1.Spreiz == SP_M) P1.MLen = neu;
	 if (P1.Spreiz == SP_WALSH) P1.WalshLen = neu;

	 neu = ComboSPNr->GetSelIndex();
	 if (P1.Spreiz == SP_PN) P1.PNNr = neu;
	 if (P1.Spreiz == SP_M) P1.MNr = neu;
	 if (P1.Spreiz == SP_WALSH) P1.WalshNr = neu;
*/
//	 Update();
}

void ParameterWin::ComboLENChange ()
{   int x;
	 char s[255];
	 folglenindex=ComboSPLaenge->GetSelIndex();
	 folgnr = -1;
	 if (folglen != Getfolglen()) Update();
	 wsprintf(s,"pos:%4d, len:%4d",x,Getfolglen());
	 St_Parameter1->SetText(s);
}

void ParameterWin::ComboNRChange ()
{   int x;
	 char s[255];
	 x=ComboSPNr->GetSelIndex();
	 folgnr=x;
	 Update();
	 //wsprintf(s,"x:%4d, y:%4d",x);
	 //St_Parameter1->SetText(s);
}

int ParameterWin::Getfolglen()
{
  int x;
  char s[8];

  x=ComboSPLaenge->GetSelIndex();
  ComboSPLaenge->GetString(s,x);
  if(s[0]==' ')s[0]='0';

  x=atoi(s);
  return(x);
}


void ParameterWin::EvLButtonDown (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDown(modKeys, point);
	 ComboSpreiz->HideList();
	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein


		// Einen DC fr den Client-Bereich anfordern
	 TWindowDC dc(*this);

	 // Ein Rechteck erzeugen,...
	 TRect rc(point.x - 10, point.y - 10, point.x + 10, point.y + 10);

	 TPen pn(RGB(0,0,0),1,PS_SOLID);
	 TBrush br(RGB(0,0,255));

	 // Auswhlen des Pens und des Brushes als aktuelle Zeichenobjekte
	 dc.SelectObject(pn);
	 dc.SelectObject(br);

	 // Rechteck zeichen
	 dc.Rectangle(rc);


}


void ParameterWin::Paint (TDC& dc, BOOL erase, TRect& rect)
{
	 ComboSpreiz->HideList();
	 TWindow::Paint(dc, erase, rect);

/*	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein
  for (int i = 0; i <= 49; i++) {
	 int x = 10 + i*8;
	 int y = 30 + i*5;
	 int w = x;
	 int h = y * 2;
//    if (Scroller->IsVisibleRect((x-Scroller->XUnit/2)/Scroller->XUnit,
//                                (y-Scroller->YUnit/2)/Scroller->YUnit,
//                                (w+Scroller->XUnit/2)/Scroller->XUnit,
//                                (h+Scroller->YUnit/2)/Scroller->YUnit))
		dc.Rectangle(x, y, x+w, y+h);
  }
*/
}


int ParameterWin::InitVarPN(int l)
{


  int i,j,k;
  int k1,k2,k3,k4,k5,k6;
  int listelen = 0;
  strcpy(s ,"00000");
  PNLaenge();
  k1=k2+3;

	  for (k2=0;k2<8;k2++)
		{
		  for (k3=0;k3<8;k3++)
			{
			  for (k4=0;k4<8;k4++)
				{
				  for (k5=0;k5<8;k5++)
					{
					  for (k6=1;k6<8;k6+=2)
						{
						  s[0]=k2+0x30;
						  s[1]=k3+0x30;
						  s[2]=k4+0x30;
						  s[3]=k5+0x30;
						  s[4]=k6+0x30;
						  if (PNLaenge() ==  l) {
															for(i=0;s[i]=='0';i++) s[i]=' ';
															strcpy(ListePN[listelen++],s);
														}
						}
					}
				}
			}
		}



  return(listelen);

}

int ParameterWin::PNLaenge()
{

  int i,k;
  for (i=0;i<=4;i++)
	 { k=4-i;
if (s[i]=='0')  PNBelegung[17]=3;
if (s[i]=='4')  PNBelegung[17]=4;
if (s[i]=='5')  PNBelegung[17]=5;

		if ((s[k]=='0')|(s[k]=='2')|(s[k]=='4')|(s[k]=='6'))  PNBelegung[i*3]=0; else PNBelegung[i*3]=1;
		if ((s[k]=='0')|(s[k]=='1')|(s[k]=='4')|(s[k]=='5'))  PNBelegung[i*3+1]=0; else PNBelegung[i*3+1]=1;
		if ((s[k]=='0')|(s[k]=='1')|(s[k]=='2')|(s[k]=='3'))  PNBelegung[i*3+2]=0; else PNBelegung[i*3+2]=1;
	 }

  int lastone =0;
  for (i=0;i<=15;i++)
	 {
		if (PNBelegung[i]==1) lastone=i;
	 }

  return(lastone);

}




int ParameterWin::InitVarWalsh(int l)
{


  int x;
  int y;




  int i,j,k;
  int k1,k2,k3,k4,k5,k6;
  int listelen = 0;
  strcpy(s ,"00000");
  PNLaenge();
  k1=k2+3;

	  for (k2=0;k2<8;k2++)
		{
		  for (k3=0;k3<8;k3++)
			{
			  for (k4=0;k4<8;k4++)
				{
				  for (k5=0;k5<8;k5++)
					{
					  for (k6=1;k6<8;k6+=2)
						{
						  s[0]=k2+0x30;
						  s[1]=k3+0x30;
						  s[2]=k4+0x30;
						  s[3]=k5+0x30;
						  s[4]=k6+0x30;
						  if (PNLaenge() ==  l) {
															for(i=0;s[i]=='0';i++) s[i]=' ';
															strcpy(ListePN[listelen++],s);
														}
						}
					}
				}
			}
		}



  return(listelen);

}



void ParameterWin::BerechneFolge()
{

}


