#if !defined(__parmtrwn_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __parmtrwn_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        parmtrwn.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer ParameterWin (TWindow).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\window.h>

#include "pnapp.rh"            // Definition aller Ressourcen
#include "staticgr.h"
#include "spinedit.h"
#include "combo.h"
#include <owl\scroller.h>
#include <owl\combobox.h>
#include "sigdia1.h"
#include "prmtrdlg.h"

//{{TWindow = ParameterWin}}
class ParameterWin : public TWindow {
private:
	 Staticgrau *St_Parameter1,
               *St_Einfolge1,
               *St_Spreizfolge1;
    TEdit *SpinDaten;
    Combo *ComboSpreiz,
          *ComboSPLaenge,
          *ComboSPNr;
public:
    ParameterWin (TWindow* parent, const char far* title = 0, TModule* module = 0);
    virtual ~ParameterWin ();
           
int Teilnehmer;
int len;
int xyz;
BOOL CanDestroy;

typedef struct { int Spreiz;
			int PNLen;
			int PNNr;
			int MLen;
			int MNr;
			int GoldLen;
			int GoldNr;
			int WalshLen;
			int WalshNr;
			int PhaseLen;
			int PhaseNr;
		 } ParStruct;
	 ParStruct P1,P2;

typedef struct { int* folge;
                 int  laenge;
                 int  pixel;
                 int  datenbits;
                 int  min;
                 int  max;
               } Signalstruct;

    Signalstruct Signal[11];




public:
    ParameterDialog* par1;
    ParameterDialog* par2;
    ParameterDialog* par;
	 char ListePN[50][8];
	 char ListeM[50][8];
    char ListeWalsh[66][8];
    int Walshfolge[64][64];
	 int folge[17000];
	 int folglen;
	 int folgnr;
    int folglenext;
    int folglenindex;
	 int PNBelegung[19];
    int WalshBelegung[10];
	 BOOL Bipolar;
    BOOL folgechanged;
    char s[80];
    int PNlistenr[8];
    int Walshlistenr[8];

    int multianf;
    int multiend;
    
/*#define SP_PN 0
#define SP_M  1
#define SP_GOLD 2
#define SP_WALSH 3
#define SP_PHASE 4
*/
//{{ParameterWinVIRTUAL_BEGIN}}
public:
	 virtual void SetupWindow ();
	 virtual void Paint (TDC& dc, BOOL erase, TRect& rect);
	 virtual void EvClose();
	 virtual BOOL CanClose();

//{{ParameterWinVIRTUAL_END}}

//{{ParameterWinRSP_TBL_BEGIN}}
protected:
	 void SetText ();
	 void EvMouseMove (UINT modKeys, TPoint& point);
	 void Update ();
	 int InitVarPN(int);
    int InitVarWalsh(int);
	 int PNLaenge();
    void PNFolgedef();
    void WalshFolgedef();
	 void BerechneFolge();
	 void Init ();
	 void ComboSpreizChange ();
	 void ComboLENChange ();
	 void ComboNRChange ();
    int  Getfolglen();
	 void EvLButtonDown (UINT modKeys, TPoint& point);
	 void ParameterUpdate ();
//{{ParameterWinRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(ParameterWin);
};    //{{ParameterWin}}


#endif                                      // __parmtrwn_h

