/*  Projekt CDMA
Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        pnapp.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von pnApp (TApplication).
*/


#include <owl\owlpch.h>
#pragma hdrstop


#include "pnapp.h"
#include "pnmdicln.h"
#include "pnabtdlg.h"                        // Definition des Info-Dialogs


//
// Gernerierte Hilfe-Datei
//
const char HelpFileName[] = "cdma.hlp";
pnMDIClient* pClientParam;

//{{pnApp Implementation}}

//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften /
// Befehle generieren
//
DEFINE_RESPONSE_TABLE1(pnApp, TApplication)
//{{pnAppRSP_TBL_BEGIN}}
	 EV_COMMAND(CM_HELPCONTENTS, CmHelpContents),
	 EV_COMMAND(CM_HELPUSING, CmHelpUsing),
	 EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
	 EV_WM_WININICHANGE,
//{{pnAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//////////////////////////////////////////////////////////
// pnApp
// =====
//
pnApp::pnApp () : TApplication("CDMA")
{
	 HelpState = FALSE;
	 ContextHelp = FALSE;
	 HelpCursor = 0;

	 Printer = 0;
	 Printing = FALSE;

	 // EINFUEGEN>> Ihren Konstruktor-Code fuegen Sie hier ein

}


pnApp::~pnApp ()
{
	 if (Printer)
		  delete Printer;

	 // EINFUEGEN>> Ihren Destruktor-Code fuegen Sie hier ein

}


BOOL pnApp::CanClose ()
{
 	 pClientParam->com_parwin->CanDestroy = TRUE;
	 BOOL result = TApplication::CanClose();

	 //
	 // Hilfe-System schliessen, wenn es verwendet wurde
	 //
	 if (result && HelpState)
		  MainWindow->WinHelp(HelpFileName, HELP_QUIT, 0L);

	 return result;
}


void pnApp::SetupSpeedBar (TDecoratedMDIFrame *frame)
{
	 //
	 // New-Operator fuer Toolbar erzeugen und Befehle den Schaltern zuordnen
	 //
	 TControlBar* cb = new TControlBar(frame);
	 cb->Insert(*new TButtonGadget(CM_MDIFILENEW, CM_MDIFILENEW));
	 cb->Insert(*new TButtonGadget(CM_SIGNALFENSTER2, CM_SIGNALFENSTER2));
	 cb->Insert(*new TSeparatorGadget(8));
	 cb->Insert(*new TButtonGadget(CM_TEILNEHMER1, CM_TEILNEHMER1));
	 cb->Insert(*new TButtonGadget(CM_TEILNEHMER2, CM_TEILNEHMER2));
	 cb->Insert(*new TButtonGadget(CM_MULTITEILNEHMER, CM_MULTITEILNEHMER));
	 cb->Insert(*new TSeparatorGadget(8));
	 cb->Insert(*new TButtonGadget(CM_AKF, CM_AKF));
	 cb->Insert(*new TSeparatorGadget(6));
	 cb->Insert(*new TButtonGadget(CM_WDF, CM_WDF));
	 cb->Insert(*new TSeparatorGadget(8));
	 cb->Insert(*new TButtonGadget(CM_FEHLER, CM_FEHLER));
	 cb->Insert(*new TSeparatorGadget(20));
	 cb->Insert(*new TButtonGadget(CM_PARAMETERFENSTER11, CM_PARAMETERFENSTER11));
	 cb->Insert(*new TSeparatorGadget(5));
	 cb->Insert(*new TButtonGadget(CM_PARAMETERFENSTER12, CM_PARAMETERFENSTER12));
	 cb->Insert(*new TSeparatorGadget(30));

/*	 cb->Insert(*new TButtonGadget(CM_MDIFILEOPEN, CM_MDIFILEOPEN));
	 cb->Insert(*new TButtonGadget(CM_FILESAVE, CM_FILESAVE));
	 cb->Insert(*new TSeparatorGadget(6));
	 cb->Insert(*new TButtonGadget(CM_EDITCUT, CM_EDITCUT));
	 cb->Insert(*new TButtonGadget(CM_EDITCOPY, CM_EDITCOPY));
	 cb->Insert(*new TButtonGadget(CM_EDITPASTE, CM_EDITPASTE));
	 cb->Insert(*new TSeparatorGadget(6));
	 cb->Insert(*new TButtonGadget(CM_EDITUNDO, CM_EDITUNDO));
	 cb->Insert(*new TSeparatorGadget(6));
	 cb->Insert(*new TButtonGadget(CM_EDITFIND, CM_EDITFIND));
	 cb->Insert(*new TButtonGadget(CM_EDITFINDNEXT, CM_EDITFINDNEXT));
	 cb->Insert(*new TSeparatorGadget(6));
	 cb->Insert(*new TButtonGadget(CM_FILEPRINT, CM_FILEPRINT));
	 cb->Insert(*new TButtonGadget(CM_FILEPRINTPREVIEW, CM_FILEPRINTPREVIEW));
*/	 cb->Insert(*new TSeparatorGadget(6));
	 cb->Insert(*new TButtonGadget(CM_HELPCONTENTS, CM_HELPCONTENTS));

	 // Statuszeilen Hilfetexte hinzufuegen
	 cb->SetHintMode(TGadgetWindow::EnterHints);

	 frame->Insert(*cb, TDecoratedFrame::Top);
}


//////////////////////////////////////////////////////////
// pnApp
// =====
// Anwendungsinitialisierung
//
void pnApp::InitMainWindow ()
{
	 pClientParam = new pnMDIClient;
	 TDecoratedMDIFrame* frame = new TDecoratedMDIFrame(Name, MDI_MENU, *pClientParam, TRUE);
	 // TDecoratedMDIFrame* frame = new TDecoratedMDIFrame(Name, MDI_MENU, *(new pnMDIClient), TRUE);

	 // Standard-Fensterstil fuer das Hauptfenster aendern
	frame->Attr.Style |= WS_BORDER | WS_CAPTION | WS_CLIPCHILDREN  | WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE;
//   frame->Attr.Style |= WS_BORDER | WS_CAPTION | WS_CLIPCHILDREN | WS_HSCROLL | WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_SYSMENU | WS_VISIBLE | WS_VSCROLL;

//	 frame->Attr.Style &= ~(WS_CHILD | WS_THICKFRAME);

	 nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWMAXIMIZED : nCmdShow;

    //
    // Zuordnung des Symbols
    //
    frame->SetIcon(this, IDI_MDIAPPLICATION);
    //
    // Zuordnung des Menues zum Fenster
    //
    frame->AssignMenu(MDI_MENU);
    
    //
    // Zuordnung der Tastenkuerzeltabelle
    //
    frame->Attr.AccelTable = MDI_MENU;


    SetupSpeedBar(frame);

    TStatusBar *sb = new TStatusBar(frame, TGadget::Recessed,
                                    TStatusBar::CapsLock        |
                                    TStatusBar::NumLock         |
                                    TStatusBar::ScrollLock      |
                                    TStatusBar::Overtype);
    frame->Insert(*sb, TDecoratedFrame::Bottom);

    MainWindow = frame;

    //
    // Windows 3-D Dialogelemente
    //
	 EnableCtl3d(TRUE);
	 EnableBWCC(TRUE);
}


//////////////////////////////////////////////////////////
// pnApp
// =====
// Befehl HelpContents
void pnApp::CmHelpContents ()
{
    //
    // Inhaltsverzeichnis der Hilfe anzeigen
    //
    HelpState = MainWindow->WinHelp(HelpFileName, HELP_CONTENTS, 0L);
}


//////////////////////////////////////////////////////////
// pnApp
// =====
// Befehl HelpUsing
void pnApp::CmHelpUsing ()
{
    //
    // Inhalt der Windows-Hifedatei anzeigen
    //
    HelpState = MainWindow->WinHelp(HelpFileName, HELP_HELPONHELP, 0L);
}


//////////////////////////////////////////////////////////
// pnApp
// ===========
// Menu Help About pn.exe command
void pnApp::CmHelpAbout ()
{
    //
    // Den modalen Dialog anzeigen
    //
    pnAboutDlg(MainWindow).Execute();
}


BOOL pnApp::ProcessAppMsg (MSG& msg)
{
    if (msg.message == WM_COMMAND) {
        if (ContextHelp || (GetKeyState(VK_F1) < 0)) {
            ContextHelp = FALSE;
            MainWindow->WinHelp(HelpFileName, HELP_CONTEXT, msg.wParam);
            return TRUE;
        }
    } else
        switch (msg.message) {
        case WM_KEYDOWN:
            if (msg.wParam == VK_RETURN) return TRUE;
            if (msg.wParam == VK_F1) {
                // Bei Umschalt+F1 HelpCursor setzen und modale Hilfe einschalten
                if (::GetKeyState(VK_SHIFT) < 0) {
                    ContextHelp = TRUE;
                    HelpCursor = ::LoadCursor(MainWindow->GetModule()->GetInstance(), MAKEINTRESOURCE(IDC_HELPCURSOR));
                    ::SetCursor(HelpCursor);
                    return TRUE;        // Botschaft verschlucken
                } else {
                    // Bei F1+Umschalttaste wird das Hilfe-Inhaltsverzeichnis angezeigt
                    MainWindow->WinHelp(HelpFileName, HELP_INDEX, 0L);
                    return TRUE;        // Botschaft verschlucken
                }
            } else {
                if (ContextHelp && (msg.wParam == VK_ESCAPE)) {
                    if (HelpCursor)
                        ::DestroyCursor(HelpCursor);
                    ContextHelp = FALSE;
                    HelpCursor = 0;
                    MainWindow->SetCursor(0, IDC_CROSS);
                    return TRUE;    // Botschaft verschlucken
                }
            }
            break;

        case WM_MOUSEMOVE:
        case WM_NCMOUSEMOVE:
            if (ContextHelp) {
                ::SetCursor(HelpCursor);
                return TRUE;        // Botschaft verschlucken
            }
            break;

        case WM_INITMENU:
            if (ContextHelp) {
                ::SetCursor(HelpCursor);
                return TRUE;        // Botschaft verschlucken
            }
            break;
        
        case WM_ENTERIDLE:
            if (msg.wParam == MSGF_MENU)
                if (GetKeyState(VK_F1) < 0) {
                ContextHelp = TRUE;
                MainWindow->PostMessage(WM_KEYDOWN, VK_RETURN, 0L);
                return TRUE;        // Botschaft verschlucken
            }
            break;
        
        default:
            ;
        };  // Ende der Switch-Anweisung

    // Normale Bearbeitung fortsetzen
    return TApplication::ProcessAppMsg(msg);
}


void pnApp::EvWinIniChange (char far* section)
{
    if (lstrcmp(section, "windows") == 0) {
        // Wurde der Eintrag in der Datei WIN.INI geaendert, so wurde evtl.
        // der Drucker gewechselt. Existiert ein TPrinter-Objekt, dann wird
        // es ueberprueft und sichergestellt, dass es mit dem aktuellen
        // Geraeteeintrag in WIN.INI uebereinstimmt.
        if (Printer) {
            char printDBuffer[255];
            LPSTR printDevice = printDBuffer;
            LPSTR devName = 0;
            LPSTR driverName = 0;
            LPSTR outputName = 0;
        
            if (::GetProfileString("windows", "device", "", printDevice, sizeof(printDevice))) {
                // Der zurueckgelieferte String sollte etwa so aussehen:
                //
                //      HP LaserJet III,hppcl5a,LPT1:
                //
                // Er hat das folgende Format:
                //
                //      devName,driverName,outputName
                //
                devName = printDevice;
                while (*printDevice) {
                    if (*printDevice == ',') {
                        *printDevice++ = 0;
                        if (!driverName)
                            driverName = printDevice;
                        else
                            outputName = printDevice;
                    } else
                        printDevice = AnsiNext(printDevice);
                }

                if ((Printer->GetSetup().Error != 0)                                ||
                    (lstrcmp(devName, Printer->GetSetup().GetDeviceName()) != 0)    ||
                    (lstrcmp(driverName, Printer->GetSetup().GetDriverName()) != 0) ||
                    (lstrcmp(outputName, Printer->GetSetup().GetOutputName()) != 0)) {
                
                    // Neuer Drucker wurde installiert, daher neues TPrinter-Objekt erzeugen
                    delete Printer;
                    Printer = new TPrinter;
                }
            } else {
                // Kein Drucker installiert (GetProfileString gescheitert).
                delete Printer;
                Printer = new TPrinter;
            }
        }
    }
}


int OwlMain (int , char* [])
{
    pnApp     App;
    int             result;

    result = App.Run();

    return result;
}
