#if !defined(__pnapp_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __pnapp_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        pnapp.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer pnApp (TApplication).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\statusba.h>
#include <owl\controlb.h>
#include <owl\buttonga.h>
#include <owl\printer.h>

#include "pnapp.rh"            // Definition aller Ressourcen


//{{TApplication = pnApp}}
class pnApp : public TApplication {
private:
    BOOL            HelpState;                          // Wurde das Hilfe-System verwendet
    BOOL            ContextHelp;                        // Status von Umschalt-F1 (kontextbezogene Hilfe)
    HCURSOR         HelpCursor;                         // Cursor der kontextbezogenen Hilfe

private:
    void SetupSpeedBar (TDecoratedMDIFrame *frame);
      
public:
    pnApp ();
    virtual ~pnApp ();

    // Public-Datenelemente, die von den Befehlen des Druckmenues und der Paint-Routine in MDIChild verwendet werden
    TPrinter        *Printer;                           // Druckerunterstuetzung
    BOOL            Printing;                           // Flag: Beim Drucken

//{{pnAppVIRTUAL_BEGIN}}
public:
    virtual void InitMainWindow();
    virtual BOOL CanClose ();
    virtual BOOL ProcessAppMsg (MSG& msg);
//{{pnAppVIRTUAL_END}}
//{{pnAppRSP_TBL_BEGIN}}
protected:
    void CmHelpContents ();
    void CmHelpUsing ();
    void CmHelpAbout ();
    void EvWinIniChange (char far* section);
//{{pnAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(pnApp);
};    //{{pnApp}}


#endif                                      // __pnapp_h
