/*  Projekt CDMA
	 Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        pnmdicln.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von pnMDIClient (TMDIClient).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <dir.h>

#include "pnapp.h"
#include "pnmdicln.h"
#include "pnsgchld.h"
#include "akfchild.h"
#include "apxprint.h"
#include "apxprev.h"

#include "par1.h"
#include "prmtrchl.h"
#include "mlttlndl.h"
#include "fhlrchld.h"

#include <owl\decframe.h>
#include <owl\framewin.h>


//{{pnMDIClient Implementation}}


//
// Antworttabelle fuer alle von pnMDIClient behandelten Botschaften &
// befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(pnMDIClient, TMDIClient)
//{{pnMDIClientRSP_TBL_BEGIN}}
	 EV_COMMAND(CM_MDIFILENEW, CmFileNew),
	 EV_COMMAND(CM_MDIFILEOPEN, CmFileOpen),
	 EV_COMMAND(CM_FILEPRINT, CmFilePrint),
	 EV_COMMAND(CM_FILEPRINTERSETUP, CmFilePrintSetup),
    EV_COMMAND(CM_FILEPRINTPREVIEW, CmFilePrintPreview),
	 EV_COMMAND_ENABLE(CM_FILEPRINT, CmPrintEnable),
	 EV_COMMAND_ENABLE(CM_FILEPRINTERSETUP, CmPrintEnable),
	 EV_COMMAND_ENABLE(CM_FILEPRINTPREVIEW, CmPrintEnable),
	 EV_COMMAND(CM_SIGNALFENSTER, Signalfenstererz),
	 EV_COMMAND(CM_AKF, AKFErzeugen),
    EV_COMMAND(CM_SIGNALFENSTER2, signalfenster2erz),
    EV_COMMAND(CM_TEILNEHMER1, Teilnehmer1Erz),
    EV_COMMAND(CM_TEILNEHMER2, Teilnehmer2Erz),
    EV_COMMAND(CM_WDF, WDF_Erzeugen),
    EV_COMMAND(CM_MULTITEILNEHMER, MultiTeilnehmer),
    EV_COMMAND(CM_FEHLER, FehlerErzeugen),
    EV_COMMAND(CM_PARAMETERFENSTER11, ShowParameter1),
    EV_COMMAND(CM_PARAMETERFENSTER12, ShowParameter12),
//{{pnMDIClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//////////////////////////////////////////////////////////
// pnMDIClient
// ===========
// Erzeugen und Entfernen
 pnMDIClient::pnMDIClient ()
 : TMDIClient ()
{
	 ChildCount = 0;

	 // EINFUEGEN>> Ihren Konstruktor-Code fuegen Sie hier ein
	signalfirst1=0;
	signalfirst2=0;
}


 pnMDIClient::~pnMDIClient ()
{
	 Destroy();

    // EINFUEGEN>> Ihren Destruktor-Code fuegen Sie hier ein

}


//////////////////////////////////////////////////////////
// pnMDIClient
// ===========
// MDIClient-Initialisierung
void pnMDIClient::SetupWindow ()
{
	 // Standard-SetUpWindow-Verarbeitung
	 TMDIClient::SetupWindow ();
	 signalakt1 = 0;
	 signalakt2 = 0;
	 teilnehmerzaehler = 1;
	 // Allgemeine Datei-Flags und Filter fuer die Dialoge Oeffnen/Speichern unter.
	 // Dateiname und Verzeichnis werden in den Elementfunktionen  CmFileOpen und CmFileSaveAs erzeugt
	 FileData.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_CREATEPROMPT | OFN_OVERWRITEPROMPT;
	 FileData.SetFilter("Alle Dateien (*.*)|*.*|");

	 ParameterWindowErz();

}


//////////////////////////////////////////////////////////
// pnMDIClient
// ===========
// Befehl FileNew
void pnMDIClient::CmFileNew ()
{
	 char    title[255];
	 char    numberStr[16];

	 // Generate a title for the MDI child window.
	 if (GetModule()->LoadString(IDS_UNTITLED, title, sizeof(title))) {
		  wsprintf(title, "Signal x(t)");
		 // lstrcat(title, numberStr);
	 } else
		  title[0] = '\0';

	 if (par1->folgegueltig == FALSE) Clientmessage1();
	 if (par2->folgegueltig == FALSE) Clientmessage2();

	 if (signalfirst1 == 0) signalakt1=0;
		 else signalakt1++;
	 signalfirst1=1;
	 if(signalakt1>12) signalakt1=0;

	 sigmainwin= new SigMainWin(0,"");
	 sig1 = new SigWin(0,"");
	 pnSigChild* child = new pnSigChild(*this, title, sig1,FALSE);
	 sigmainwin->sigwin = sig1;
	 sig1->par1 = par1;
	 sig1->par2 = par2;
	 sig1->Parametersatz=1;
	 sig1->signal=signalakt1;
	 // Diesem Kindfenster Symbol zuordnen
	 child->SetIcon(GetApplication(), IDI_DOC);

	 // Ist das aktive MDI-Kindfenster maximiert, so sollte auch dieses maximiert werden
	 pnSigChild *curChild = (pnSigChild *)GetActiveMDIChild();
	 if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
		  child->Attr.Style |= WS_MAXIMIZE;

	 child->Create();
//	 sig1->Create();
	 TRect rc = sig1->GetWindowRect();

//    sig1->MoveWindow(0,75,rc.right,rc.Height()-75);
//	 TClientDC dc(*child);
//	 TMemoryDC memdc(dc);
//	 aus1rect = child->GetClientRect();

//	 bitaus1 = new TBitmap(memdc,600,rcc.Height(),FALSE);




}


void pnMDIClient::OpenFile (const char *fileName)
{
	 char    title[255];
	 char    numberStr[16];

	 // Generate a title for the MDI child window.
	 if (GetModule()->LoadString(IDS_UNTITLED, title, sizeof(title))) {
		  wsprintf(title, "Signal - x(t)");
		  //lstrcat(title, numberStr);
	 } else
		  title[0] = '\0';

	 if (par1->folgegueltig == FALSE) Clientmessage1();
	 if (par2->folgegueltig == FALSE) Clientmessage2();

	 sig1 = new SigWin(0,"");
	 pnSigChild* child = new pnSigChild(*this, "Signal x(t)", sig1,FALSE);
	 sig1->par1 = par1;
	 sig1->par2 = par2;
	 // Diesem Kindfenster Symbol zuordnen
	 child->SetIcon(GetApplication(), IDI_DOC);

	 // Ist das aktive MDI-Kindfenster maximiert, so sollte auch dieses maximiert werden
	 pnSigChild *curChild = (pnSigChild *)GetActiveMDIChild();
	 if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
		  child->Attr.Style |= WS_MAXIMIZE;

	 child->Create();
//	 TClientDC dc(*child);
//	 TMemoryDC memdc(dc);
//	 aus1rect = child->GetClientRect();

//	 bitaus1 = new TBitmap(memdc,600,rcc.Height(),FALSE);




}


//////////////////////////////////////////////////////////
// pnMDIClient
// ===========
// Befehl FileOpen
void pnMDIClient::CmFileOpen ()
{
	 //
	 // Standarddialog Oeffnen anzeigen und Dateinamen auswaehlen
	 //
	 *FileData.FileName = 0;
	 if (TFileOpenDialog(this, FileData).Execute() == IDOK)
		  OpenFile();
}


// Vom ListBox-Client fuer das Einlesen einer Textdatei verwendet
void pnMDIClient::LoadTextFile ()
{
	 char            buf[255+1];
    ifstream        *inStream;

	 pnSigChild  *curChild = (pnSigChild *)GetActiveMDIChild();
	 TListBox        *client = TYPESAFE_DOWNCAST(curChild->GetClientWindow(), TListBox);

    // Nur, falls die Client-Klasse vom Typ TListBox ist
	 if (client) {
		  client->ClearList();
		  inStream = new ifstream(FileData.FileName);
		  while (inStream->good()) {
				inStream->getline(buf, sizeof(buf) - 1);
            if (inStream->good())
                client->AddString(buf);
		  }

		  // Fehlermeldung zurueckliefern, wenn eine Stream-Fehler ungleich EOF aufgetreten ist
        if (inStream->bad() && !inStream->eof()) {
            string msgTemplate(*GetModule(), IDS_UNABLEREAD);
				char*  msg = new char[MAXPATH + msgTemplate.length()];
				wsprintf(msg, msgTemplate.c_str(), *FileData.FileName);
				MessageBox(msg, GetApplication()->GetName(), MB_ICONEXCLAMATION | MB_OK);
            delete msg;
		  }

        delete inStream;
    }
}


//////////////////////////////////////////////////////////
// pnMDIClient
// ==========
// Befehl FilePrint
void pnMDIClient::CmFilePrint ()
{
    //
	 // Printer-Objekt erzeugen, sofern es nicht bereits existiert
	 //
	 pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
	 if (theApp) {
        if (!theApp->Printer)
            theApp->Printer = new TPrinter;

		  //
		  // Druckfenster erzeugen und Eigenschaften festlegen
		  //
        APXPrintOut printout(theApp->Printer, Title, GetActiveMDIChild(), TRUE);

		  theApp->Printing = TRUE;

        //
		  // Druckdialog anzeigen und Dokument ausdrucken
        //
		  theApp->Printer->Print(GetActiveMDIChild()->GetClientWindow(), printout, TRUE);

		  theApp->Printing = FALSE;
	 }
}


//////////////////////////////////////////////////////////
// pnMDIClient
// ==========
// Befehl FilePrintSetup
void pnMDIClient::CmFilePrintSetup ()
{
	 pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
	 if (theApp) {
        if (!theApp->Printer)
            theApp->Printer = new TPrinter;

        //
		  // Dialog Drucker einrichten anzeigen
		  //
		  theApp->Printer->Setup(this);
	 }
}


//////////////////////////////////////////////////////////
// pnMDIClient
// ==========
// Befehl FilePrintPreview
void pnMDIClient::CmFilePrintPreview ()
{
	 pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
	 if (theApp) {
		  if (!theApp->Printer)
				theApp->Printer = new TPrinter;

		  theApp->Printing = TRUE;

		  PreviewWindow *prevW = new PreviewWindow(Parent, theApp->Printer, GetActiveMDIChild(), "Druckvorschau", new TLayoutWindow(0));
        prevW->Create();

		  GetApplication()->BeginModal(GetApplication()->MainWindow);

        // Das Vorschau-Fenster muss explizit entfernt werden, da es ansonsten
        // erst zusammen mit MainWindow entfernt wird.
		  prevW->Destroy();
		  delete prevW;

		  theApp->Printing = FALSE;
    }
}


//////////////////////////////////////////////////////////
// pnMDIClient
// ==========
// Menue-Aktivierung, die von Print, PrintSetup und PrintPreview benutzt wird
void pnMDIClient::CmPrintEnable (TCommandEnabler &tce)
{
    if (GetActiveMDIChild()) {
		  pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
		  if (theApp) {
            // Wenn bereits ein Printer-Objekt existiert, wird es ueberprueft.
				// Andernfalls wird ein Printer-Objekt erzeugt und sichergestellt, dass
				// der Drucker existiert. Danach wird das Printer-Objekt wieder entfernt.
				if (!theApp->Printer) {
					 theApp->Printer = new TPrinter;

					 tce.Enable(theApp->Printer->GetSetup().Error == 0);
				} else
					 tce.Enable(theApp->Printer->GetSetup().Error == 0);
		  }
	 } else
		  tce.Enable(FALSE);
}



void pnMDIClient::Par1Dialog ()
{
	int erg;
	Par1 p1(this);
	erg = p1.Execute();

	if (erg == IDOK) MessageBox("OK gedrckt","Meldung",MB_OK);
	else MessageBox("Abbrechen gedrckt","Meldung",MB_OK);


}



void pnMDIClient::ParameterWindowErz ()
{
	 char    title[255];
	 char    numberStr[16];

	 // Generate a title for the MDI child window.
//    if (GetModule()->LoadString(IDS_UNTITLED, title, sizeof(title))) {
		  wsprintf(title, "Parameter");
//        lstrcat(title, numberStr);
//    } else
//        title[0] = '\0';
	 parwin = new ParameterWin(0,"");
	 // -->
	 com_parwin = parwin;
	 // -->
	 parwin->Teilnehmer = 0;
	 parchild = new ParameterChild(*this, title, parwin,FALSE);
// Diesem Kindfenster Symbol zuordnen
	 parchild->SetIcon(GetApplication(), IDI_DOC);

	 // Ist das aktive MDI-Kindfenster maximiert, so sollte auch dieses maximiert werden
//    pnSigChild *curChild = (pnSigChild *)GetActiveMDIChild();
//    if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
//        child->Attr.Style |= WS_MAXIMIZE;
	 parchild->par1=parwin->par1;
	 parchild->par2=parwin->par2;
	 parwin->par1->multianf = -1;
	 parwin->par2->multianf = -1;
	 parchild->Attr.W = 500;
	 parchild->Attr.H = 400;
	 parchild->Create();
	 par1=parwin->par1;
	 par2=parwin->par2;

}


void pnMDIClient::Signalfenstererz ()
{
	 TClientDC dc(*this);
	 TRect rcc = GetClientRect();
	 TBitmap* m_pOffScreen;
	 m_pOffScreen = new TBitmap(dc,rcc.Width(),rcc.Height(),FALSE);

	 TMemoryDC memdc(dc);
	 memdc.SelectObject(*m_pOffScreen);

	 TSize Grid(16,16);
	 memdc.FillRect(rcc,TBrush(TColor::White));
	 for (int i = 0; i < rcc.bottom; i += Grid.cy)
		  for (int j = 0; j < rcc.right; j += Grid.cx)
				dc.SetPixel(j,i,RGB(0,0,0));

	 memdc.RestoreBitmap();

}


void pnMDIClient::AKFErzeugen ()
{
	 char    title[255];
	 char    numberStr[16];
	 if (par1->folgegueltig == FALSE) Clientmessage1();
	 if (par2->folgegueltig == FALSE) Clientmessage2();

	 // Generate a title for the MDI child window.
	 if (GetModule()->LoadString(IDS_UNTITLED, title, sizeof(title))) {
		  wsprintf(numberStr, " - %d", par1->laenge1);
		  lstrcat(title, numberStr);
	 } else
		  title[0] = '\0';
	 wsprintf(title,"AKF");

	 akf1 = new AKFWin(0,"");
	 AKFChild* child = new AKFChild(*this, title, akf1,FALSE);
	 akf1->par1 = par1;
	 akf1->par2 = par2;
	 // Diesem Kindfenster Symbol zuordnen
	 child->SetIcon(GetApplication(), IDI_DOC);

	 // Ist das aktive MDI-Kindfenster maximiert, so sollte auch dieses maximiert werden

	 child->Create();
}



void Sendmessage1(TWindow* win,void*)
{
  char s[255];
  strcpy(s,"  ");
  win->Transfer(s,3);
}
void pnMDIClient::Clientmessage1 ()
{
par1->ParameterUpdate();
ForEach(Sendmessage1);
}



void Sendmessage2(TWindow* win,void*)
{
  char s[255];
  strcpy(s,"  ");
  win->Transfer(s,4);
}
void pnMDIClient::Clientmessage2 ()
{
par2->ParameterUpdate();
ForEach(Sendmessage2);
}

void Sendmessage11(TWindow* win,void*)
{
  char s[255];
  strcpy(s,"  ");
  win->Transfer(s,11);
}
void pnMDIClient::Clientmessage11 ()
{
ForEach(Sendmessage11);
}

void Sendmessage12(TWindow* win,void*)
{
  char s[255];
  strcpy(s,"  ");
  win->Transfer(s,12);
}
void pnMDIClient::Clientmessage12 ()
{

ForEach(Sendmessage12);
}

void Sendmessage41(TWindow* win,void*)
{
  char s[255];
  strcpy(s,"  ");
  win->Transfer(s,41);
}
void pnMDIClient::Clientmessage41 ()
{

ForEach(Sendmessage41);
}

void Sendmessage42(TWindow* win,void*)
{
  char s[255];
  strcpy(s,"  ");
   win->Transfer(s,42);
}
void pnMDIClient::Clientmessage42 ()
{
ForEach(Sendmessage42);

}


UINT pnMDIClient::Transfer (void* buffer, TTransferDirection direction)
{
	 UINT result;

	 if (direction <= 2 ) result = TMDIClient::Transfer(buffer, direction);
	 else
		{
HCURSOR WaitCursor;
WaitCursor = ::LoadCursor(GetApplication()->GetMainWindow()->GetModule()->GetInstance(), MAKEINTRESOURCE(CURSOR_1));
::SetCursor(WaitCursor);

			if (direction == 5) Clientmessage1();
			if (direction == 6) Clientmessage2();
			if (direction == 21) Clientmessage11();
			if (direction == 22) Clientmessage12();
			if (direction == 31) Clientmessage41();
			if (direction == 32) Clientmessage42();
		}

	 return result;
}


void pnMDIClient::signalfenster2erz ()
{
	 char    title[255];
	 char    numberStr[16];

	 // Generate a title for the MDI child window.
	 if (GetModule()->LoadString(IDS_UNTITLED, title, sizeof(title))) {
		  wsprintf(title, "Signal x(t)");
		 // lstrcat(title, numberStr);
	 } else
		  title[0] = '\0';

	 if (par1->folgegueltig == FALSE) Clientmessage1();
	 if (par2->folgegueltig == FALSE) Clientmessage2();

	 if (signalfirst2== 0) {signalakt2=0;}
		 else signalakt2++;
	 signalfirst2=1;
	 if(signalakt2>12) signalakt2=0;

	 sigmainwin= new SigMainWin(0,"");
	 sig1 = new SigWin(0,"");
	 pnSigChild* child = new pnSigChild(*this, title, sig1,FALSE);
	 sigmainwin->sigwin = sig1;
	 sig1->par1 = par1;
	 sig1->par2 = par2;
	 sig1->Parametersatz=2;
	 sig1->signal=signalakt2;
	 // Diesem Kindfenster Symbol zuordnen
	 child->SetIcon(GetApplication(), IDI_DOC);

	 // Ist das aktive MDI-Kindfenster maximiert, so sollte auch dieses maximiert werden
	 pnSigChild *curChild = (pnSigChild *)GetActiveMDIChild();
	 if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
		  child->Attr.Style |= WS_MAXIMIZE;

	 child->Create();
//	 sig1->Create();
	 TRect rc = sig1->GetWindowRect();

//    sig1->MoveWindow(0,75,rc.right,rc.Height()-75);
//	 TClientDC dc(*child);
//	 TMemoryDC memdc(dc);
//	 aus1rect = child->GetClientRect();

//	 bitaus1 = new TBitmap(memdc,600,rcc.Height(),FALSE);




}


void pnMDIClient::Teilnehmer1Erz ()
{
	 char    title[255];
	 char    numberStr[16];

		  wsprintf(title, "Teilnehmer %d Satz 1",++teilnehmerzaehler);

	 parwin = new ParameterWin(0,"");
	 parwin->Teilnehmer = 1;
	 parwin->par = par1;
	 ParameterChild* parchild = new ParameterChild(*this, title, parwin,FALSE);

	 parchild->SetIcon(GetApplication(), IDI_DOC);
	 parchild->par1=parwin->par1;
	 parchild->par2=parwin->par2;
	 parwin->par1->multianf = -1;
	 parwin->par1->multiend = -1;
	 parchild->Create();

}


void pnMDIClient::Teilnehmer2Erz ()
{
	 char    title[255];
	 char    numberStr[16];

		  wsprintf(title, "Teilnehmer %d Satz 2",++teilnehmerzaehler);

	 parwin = new ParameterWin(0,"");
	 parwin->Teilnehmer = 2;
	 parwin->par = par2;
	 ParameterChild* parchild = new ParameterChild(*this, title, parwin,FALSE);
// Diesem Kindfenster Symbol zuordnen
	 parchild->SetIcon(GetApplication(), IDI_DOC);
	 parchild->par1=parwin->par1;
	 parchild->par2=parwin->par2;
	 parwin->par1->multianf = -1;
	 parwin->par1->multiend = -1;
	 parchild->Create();

}


void pnMDIClient::WDF_Erzeugen ()
{
	 char    title[255];
	 char    numberStr[16];

	 // Generate a title for the MDI child window.
	 if (GetModule()->LoadString(IDS_UNTITLED, title, sizeof(title))) {
		  wsprintf(title, "WDF des Detektionssignals");
		 // lstrcat(title, numberStr);
	 } else
		  title[0] = '\0';

	 if (par1->folgegueltig == FALSE) Clientmessage1();
	 if (par2->folgegueltig == FALSE) Clientmessage2();

	 if (signalfirst2== 0) {signalakt2=0;}
		 else signalakt2++;
	 signalfirst2=1;
	 if(signalakt2>12) signalakt2=0;

	 wdfwin = new WDFWin(0,"");
	 WDFChild* child = new WDFChild(*this, title, wdfwin,FALSE);
	 wdfwin->par1 = par1;
	 wdfwin->par2 = par2;
	 wdfwin->Parametersatz=1;
	 wdfwin->signal=SIG_WDF;
	 // Diesem Kindfenster Symbol zuordnen
	 child->SetIcon(GetApplication(), IDI_DOC);

	 // Ist das aktive MDI-Kindfenster maximiert, so sollte auch dieses maximiert werden
	 pnSigChild *curChild = (pnSigChild *)GetActiveMDIChild();
	 if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
		  child->Attr.Style |= WS_MAXIMIZE;

	 child->Create();
//	 wdfwin->Create();
	 TRect rc = wdfwin->GetWindowRect();

//    wdfwin->MoveWindow(0,75,rc.right,rc.Height()-75);
//	 TClientDC dc(*child);
//	 TMemoryDC memdc(dc);
//	 aus1rect = child->GetClientRect();

//	 bitaus1 = new TBitmap(memdc,600,rcc.Height(),FALSE);





}


void pnMDIClient::MultiTeilnehmer ()
{
	 char    title[255];
	 char    numberStr[16];
	 int x;

	 MultiTeilnDialog multidia(this);

	 multidia.parmoeglich = 0;

	 x=par1->combospreiz1->GetSelIndex();
	 if (x == SP_WALSH) multidia.parmoeglich = 1;

	 x=par2->combospreiz1->GetSelIndex();
	 if (x == SP_WALSH) multidia.parmoeglich += 2;

	 if (multidia.parmoeglich == 0) return;

	 multidia.walshmax1 = par1->walshlaenge[par1->walshgrad1];
	 multidia.walshmax2 = par2->walshlaenge[par1->walshgrad1];

	 if (multidia.Execute() == IDOK)

		{

		 int p = multidia.parsatz;
		 wsprintf(title, "Mehrfach-Teiln. %d Satz %d",++teilnehmerzaehler,p);

		 parwin = new ParameterWin(0,"");
		 parwin->Teilnehmer = p;
		 parwin->par = par1;
		 if (p == 2) parwin->par = par2;
		 ParameterChild* parchild = new ParameterChild(*this, title, parwin,FALSE);

		 parchild->SetIcon(GetApplication(), IDI_DOC);
		 parchild->par1=parwin->par1;
		 parchild->par2=parwin->par2;
		 parwin->par1->multianf = multidia.multianf;
		 parwin->par1->multiend = multidia.multiend;
		 parchild->Create();
		}

}


void pnMDIClient::FehlerErzeugen ()
{
	 char    title[255];
	 char    numberStr[16];

	 // Generate a title for the MDI child window.
	 if (GetModule()->LoadString(IDS_UNTITLED, title, sizeof(title))) {
		  wsprintf(title, "Fehlerwahrscheinlichkeit");
		 // lstrcat(title, numberStr);
	 } else
		  title[0] = '\0';

	 if (par1->folgegueltig == FALSE) Clientmessage1();
	 if (par2->folgegueltig == FALSE) Clientmessage2();

	 if (signalfirst2== 0) {signalakt2=0;}
		 else signalakt2++;
	 signalfirst2=1;
	 if(signalakt2>12) signalakt2=0;

	 fehlerwin = new FehlerWin(0,"");
	 FehlerChild* child = new FehlerChild(*this, title, fehlerwin,FALSE);
	 fehlerwin->par1 = par1;
	 fehlerwin->par2 = par2;
	 fehlerwin->Parametersatz=1;
	 fehlerwin->signal=SIG_WDF;
	 // Diesem Kindfenster Symbol zuordnen
	 child->SetIcon(GetApplication(), IDI_DOC);

	 // Ist das aktive MDI-Kindfenster maximiert, so sollte auch dieses maximiert werden
	 pnSigChild *curChild = (pnSigChild *)GetActiveMDIChild();
	 if (curChild && (curChild->GetWindowLong(GWL_STYLE) & WS_MAXIMIZE))
		  child->Attr.Style |= WS_MAXIMIZE;

	 child->Create();
	 TRect rc = fehlerwin->GetWindowRect();


}


void pnMDIClient::ShowParameter1 ()
{
	parchild->BringWindowToTop();
	parchild->ShowWindow(SW_SHOWNORMAL);
	parchild->MoveWindow(0,0,291,472,TRUE);

}


void pnMDIClient::ShowParameter12 ()
{
	parchild->BringWindowToTop();
	parchild->ShowWindow(SW_SHOWNORMAL);
	parchild->MoveWindow(0,0,571,472,TRUE);

}

