#if !defined(__pnmdicln_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __pnmdicln_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        pnmdicln.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer pnMDIClient (TMDIClient).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\opensave.h>

#include "pnapp.rh"            // Definition aller Ressourcen

#include "parmtrwn.h"
#include "prmtrchl.h"
#include "sigwin.h"
#include "akfwin.h"
#include "sigmanwn.h"
#include "wdfchild.h"
#include "wdfwin.h"
#include "fehlerwn.h"

//{{TMDIClient = pnMDIClient}}
class pnMDIClient : public TMDIClient {
public:
    int                     ChildCount;                 // Nummer des erzeugten Kindfensters
    TOpenSaveDialog::TData  FileData;                   // Daten zur Steuerung des Standarddialogs Oeffnen/Speichern unter
     
    pnMDIClient ();
    virtual ~pnMDIClient ();

    void OpenFile (const char *fileName = 0);
    ParameterWin* parwin;
// -->
    ParameterWin* com_parwin;	// Pointer auf allgemeinen Parametersatz
// -->
    ParameterChild* parchild;
    ParameterDialog* par1;
    ParameterDialog* par2;

    WDFWin *wdfwin;
    FehlerWin *fehlerwin;
    SigWin *sig1;
    SigMainWin *sigmainwin;
    AKFWin *akf1;
    int parlen;
    pnMDIClient* client;
//    TBitmap* memaus1,memaus2,memaus3,memaus4;
//    TRect aus1rect;

protected:
     int signalakt1;
     int signalakt2;
     int signalfirst1;
     int signalfirst2;
     int teilnehmerzaehler;
private:
    void LoadTextFile ();
//    void Sendmessage1(TWindow* win,void*);
//{{pnMDIClientVIRTUAL_BEGIN}}
protected:
    virtual void SetupWindow ();
    virtual UINT Transfer (void* buffer, TTransferDirection direction);
//{{pnMDIClientVIRTUAL_END}}

//{{pnMDIClientRSP_TBL_BEGIN}}
protected:
    void CmFileNew ();
    void CmFileOpen ();
    void CmFilePrint ();
    void CmFilePrintSetup ();
    void CmFilePrintPreview ();
    void CmPrintEnable (TCommandEnabler &tce);
    void Par1Dialog ();
    void ParameterWindowErz ();
    void Signalfenstererz ();
    void AKFErzeugen ();
    void Clientmessage1 ();
    void Clientmessage2 ();
    void Clientmessage11 ();
    void Clientmessage12 ();
    void Clientmessage41 ();
    void Clientmessage42 ();
    void signalfenster2erz ();
    void Teilnehmer1Erz ();
    void Teilnehmer2Erz ();
    void WDF_Erzeugen ();
    void MultiTeilnehmer ();
    void FehlerErzeugen ();
    void ShowParameter1 ();
    void ShowParameter12 ();
//{{pnMDIClientRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(pnMDIClient);
};    //{{pnMDIClient}}


#endif                                      // __pnmdicln_h
