/*  Projekt CDMA
	 Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        prmtrdlg.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von ParameterDialog (TDialog).
*/
#define W(x) (x)/16200][(x)%16200

#include <owl\owlpch.h>
#include <owl\validate.h>
#pragma hdrstop

#include "prmtrdlg.h"
#define filt_len 100


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(ParameterDialog, TDialog)
//{{ParameterDialogRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDC_BUTTONWIESATZ2, WieSatz2BNClicked),
	 EV_WM_MOUSEMOVE,
	 EV_CBN_SELCHANGE(IDC_COMBONR1, combonr1CBNSelchange),
	 EV_CBN_SELCHANGE(IDC_COMBONR2, combonr2CBNSelchange),
	 EV_CBN_SELCHANGE(IDC_COMBOSPREIZ1, combospreiz1CBNSelchange),
	 EV_CBN_SELCHANGE(IDC_COMBOSPREIZ2, combospreiz2CBNSelchange),
	 EV_WM_LBUTTONDBLCLK,
	 EV_EN_CHANGE(IDC_EDITPHASE1, editphase1ENChange),
	 EV_EN_CHANGE(IDC_EDITPHASE2, editphase2ENChange),
	 EV_EN_CHANGE(IDC_EDITPIXEL1, editpixelENChange),
	 EV_EN_CHANGE(IDC_EDITQUELLEBITS, bitsENChange),
	 EV_EN_CHANGE(IDC_EDITQUELLEWAHR, wahrENChange),
	 EV_EN_CHANGE(IDC_EDITKANALA0, editkanala0ENChange),
	 EV_EN_CHANGE(IDC_EDITKANALA1, editkanala1ENChange),
	 EV_EN_CHANGE(IDC_EDITKANALA2, editkanala2ENChange),
	 EV_EN_CHANGE(IDC_EDITKANALA3, editkanala3ENChange),
	 EV_EN_CHANGE(IDC_EDITKANALRAUSCHEN, editkanalrauschenENChange),
	 EV_EN_CHANGE(IDC_EDITE1, edite1ENChange),
	 EV_EN_CHANGE(IDC_EDITE2, edite2ENChange),
	 EV_EN_CHANGE(IDC_EDITE3, edite3ENChange),
	 EV_CBN_EDITCHANGE(IDC_COMBODOPPLER, combodopplerCBNEditchange),
	 EV_BN_CLICKED(IDC_CHECKRAYLEIGH, checkrayleighBNClicked),
	 EV_CBN_SELCHANGE(IDC_COMBODOPPLER, combodopplerCBNSelchange),
	 EV_WM_KEYDOWN,
	 EV_BN_CLICKED(IDC_CHECKRAKE, checkrakeBNClicked),
	 EV_COMMAND(CM_EINSTELLUNGENRAYLEIGH, Einstellung_Rayleigh),
//{{ParameterDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{ParameterDialog Implementation}}



ParameterDialog::ParameterDialog (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 Initialisierung = INIT_START;
	 bits = 20;
	 laenge1 = 1;
	 pixel = 5;
	 wahrinit = 0;
//{{ParameterDialogXFER_USE}}
	 combonr1 = new TComboBox(this, IDC_COMBONR1, 1);
	 combonr2 = new TComboBox(this, IDC_COMBONR2, 1);
	 combospreiz1 = new TComboBox(this, IDC_COMBOSPREIZ1, 1);
	 combospreiz2 = new TComboBox(this, IDC_COMBOSPREIZ2, 1);
	 editkanala0 = new Spinedit(this, IDC_EDITKANALA0, 255);
	 editkanala1 = new Spinedit(this, IDC_EDITKANALA1, 255);
	 editkanala2 = new Spinedit(this, IDC_EDITKANALA2, 255);
	 editkanala3 = new Spinedit(this, IDC_EDITKANALA3, 255);
	 editrauschen = new Spinedit(this, IDC_EDITKANALRAUSCHEN, 255);
	 editbits = new Spinedit(this, IDC_EDITQUELLEBITS, 255);
	 editwahr = new Spinedit(this, IDC_EDITQUELLEWAHR, 255);
	 editpixel = new Spinedit(this, IDC_EDITPIXEL1, 255);
	 staticpar1 = new TStatic(this, IDT_PAR1, 255);
	 staticphase1 = new TStatic(this, IDT_PHASE1, 255);
	 staticphase2 = new TStatic(this, IDT_PHASE2, 255);
	 editphase1 = new Spinedit(this, IDC_EDITPHASE1, 255);
	 editphase2 = new Spinedit(this, IDC_EDITPHASE2, 255);
	 buttonwiesatz2 = new TButton(this, IDC_BUTTONWIESATZ2);
	 edite1 = new Spinedit(this, IDC_EDITE1, 255);
	 edite2 = new Spinedit(this, IDC_EDITE2, 255);
	 edite3 = new Spinedit(this, IDC_EDITE3, 255);
	 statickanal = new TStatic(this, IDT_KANAL, 255);
	 staticpixel = new TStatic(this, IDT_PIXEL, 255);
	 statickanal5 = new TStatic(this, IDT_KANAL5, 255);
	 statickanal2 = new TStatic(this, IDT_KANAL2, 255);
	 statickanal3 = new TStatic(this, IDT_KANAL3, 255);
	 statickanal4 = new TStatic(this, IDT_KANAL4, 255);
	 combodoppler = new TComboBox(this, IDC_COMBODOPPLER, 1);
	 checkrayleigh = new TCheckBox(this, IDC_CHECKRAYLEIGH, 0);
	 checkrake = new TCheckBox(this, IDC_CHECKRAKE, 0);
//	 SetTransferBuffer(&ParameterDialogData);

//{{ParameterDialogXFER_USE_END}}

	 folgsel1 = 0;
	 folgsel2 = 0;
}


ParameterDialog::~ParameterDialog ()
{
	 Destroy();


}


void ParameterDialog::SetupWindow ()
{
	 TDialog::SetupWindow();
	 Initialisierung = INIT_OK;
	 int i;

	 folge = new int[32700];
	 folge15q = new int[32700];
	 folge15i = new int[32700];


	 int pixelanf = 5;
	 ScrollPos=0;
	 rauschen=0;
	 pixel = 20;
	 pixelmin = 1;
	 RAKE = TRUE;
	 RAKEalt = TRUE;
	 altuebernehmen = FALSE;

	 checkrake->Check();
	 int signalanz=15;
	 if (Teilnehmer > 0) signalanz = 15;
	 for (i=0;i<=signalanz;i++) Signal[i].folge=new int[32766];
	 SignalWDF[0] = new LONG[16300];
	 SignalWDF[1] = new LONG[16300];
	 wahrinit = 1;
	 if (Parametersatz == 2) {
										staticpar1->SetText("Parametersatz 2");
										buttonwiesatz2->SetWindowText("wie Satz 1");
									 }

	 teilnaktiv = TRUE;
	 AnzTeilnehmer = 1;

	 editrauschen->SetRange(rauschen,0,125,5,SPIN_ZEHN,125);
	 editphase1->SetRange(phase1,1,100,1,SPIN_OKTAL,20);
	 editphase2->SetRange(phase2,1,100,1,SPIN_OKTAL,20);
	 if (Teilnehmer == 0)
								{
									statickanal5->SetText("E  /N");
									statickanal2->SetText("b");
									statickanal3->SetText("0");
								}

	 if (Teilnehmer > 0) { staticpar1->SetText("Teilnehmer ist");
								  buttonwiesatz2->SetWindowText("aktiv");
								  statickanal->SetText("Kanal");
								  statickanal2->SetText(" ");
								  statickanal3->SetText(" ");
								  statickanal4->SetText(" ");
								  statickanal5->SetText(" ");
								  staticpixel->SetText("Phasendiff.");
								  rauschen=100;

								  editrauschen->SetRange(rauschen,100,100,1,SPIN_ZEHNHUND,100);
								  editrauschen->Hide();
								  checkrake->Uncheck();

								  RAKE=FALSE;
								  RAKEalt=FALSE;
								  checkrake->SetWindowText(" ");
								  pixel = 0;
								  pixelmin = 0;
								  pixelanf = 0;
								  par->AnzTeilnehmer+=multiend-multianf+1;
								  char s[255];
								  sprintf(s,"Kanal: (%2d Teiln.)",par->AnzTeilnehmer);
								  par->statickanal->SetText(s);

								  if (multianf != -1)
											{
												editphase1->SetRange(phase1,par->phase1,par->phase1,1,SPIN_EINS,0);
											}


								}

	 editkanala0->SetRange(kanala0,-100,100,5,SPIN_HUND,100);
	 editkanala1->SetRange(kanala1,-100,100,5,SPIN_HUND,0);
	 editkanala2->SetRange(kanala2,-100,100,5,SPIN_HUND,0);
	 editkanala3->SetRange(kanala3,-100,100,5,SPIN_HUND,0);
	 edite1->SetRange(e1,1,9,1,SPIN_DIGIT,1);
	 edite2->SetRange(e2,1,9,1,SPIN_DIGIT,2);
	 edite3->SetRange(e3,1,9,1,SPIN_DIGIT,3);

	 editbits->SetRange(bits,1,10000,51,SPIN_EINS,40);
	 editwahr->SetRange(wahr,0,100,5,SPIN_HUND,50);
	 editpixel->SetRange(pixel,pixelmin,100,1,SPIN_EINS,pixelanf);

	 par->folgegueltig=FALSE;
	 PNListeGenerierung();
	 WalshGenerierung();
	 walshgrad1 = 4;
	 walshgrad2 = 4;
	 for (i=2;i<7;i++) {
								 walshnr1[i]=1;
								 walshnr2[i]=1;
							 }

	 combospreiz1->ClearList();
	 combospreiz1->AddString("PN-Folge");
	 combospreiz1->AddString("Walsh-Funktion");
	 combospreiz1->AddString("keine");
	 combospreiz1->SetSelIndex(SP_PN);
	 spreiz1=SP_KEINE;
	 pnfolge1 = 10;
	 folgsel1 = 0;
	 folgsel2 = 0;


	 combospreiz1CBNSelchange ();

	 combospreiz2->ClearList();
	 combospreiz2->AddString("PN-Folge");
	 combospreiz2->AddString("Walsh-Funktion");
	 combospreiz2->AddString("keine");
	 combospreiz2->SetSelIndex(SP_KEINE);
	 spreiz2=SP_PN;
	 pnfolge2 = 10;


	 combospreiz2CBNSelchange ();

	 rayleigh = FALSE;
	 doppler = 0;
	 combodoppler->ClearList();
	 combodoppler->AddString("50Hz");
	 combodoppler->AddString("100Hz");
	 combodoppler->AddString("200Hz");
	 combodoppler->AddString("400Hz");
	 combodoppler->AddString("5kHz");
	 combodoppler->AddString("FIRF");
	 combodoppler->SetSelIndex(par->doppler);
	 rayleigh = par->rayleigh;
	 rayl_fakt[0] = new float[16300];
	 rayl_fakt[1] = new float[16300];

	 if (par->rayleigh) checkrayleigh->Check();
	 load_rayl_file();

	 load_wgn_file("gauss.dat");

								  combospreiz1->SetSelIndex(par->spreiz1);
								  combospreiz1CBNSelchange();
								  combospreiz2->SetSelIndex(par->spreiz2);
								  combospreiz2CBNSelchange();
								  phase1=par->phase1;
								  editphase1ENChange();
								  phase2=par->phase2;
								  editphase2ENChange();
								  combonr1->SetSelIndex(par->combonr1->GetSelIndex());
								  combonr1CBNSelchange();
								  combonr2->SetSelIndex(par->combonr2->GetSelIndex());
								  combonr2CBNSelchange();

								  phase1=par->phase1;
								  editphase1ENChange();
								  phase2=par->phase2;
								  editphase2ENChange();

								  editphase1->SetPosition(phase1);
								  editphase2->SetPosition(phase2);
								  editbits->SetPosition(par->bits);
								  editwahr->SetPosition(par->wahr);

								  editkanala0->SetPosition(par->kanala0);
								  editkanala1->SetPosition(par->kanala1);
								  editkanala2->SetPosition(par->kanala2);
								  editkanala3->SetPosition(par->kanala3);
								  edite1->SetPosition(par->e1);
								  edite2->SetPosition(par->e2);
								  edite3->SetPosition(par->e3);

								  wahr = 55;
								  wahrENChange();
								  wahr = 50;
								  wahrENChange();

								  a0alt = kanala0;
								  a1alt = kanala1;
								  a2alt = kanala2;
								  a3alt = kanala3;
								  e1alt = e1; e2alt = e2; e3alt = e3;
								  checkrayleighBNClicked ();

	 par->wdfbits = 0;


 double x1,x2;

for (i=0;i<=500;i++) rayl_z1[i]=0;
for (i=0;i<=500;i++) rayl_z2[i]=0;
for (i=0;i<=filt_len+20;i++) {
							  x1 = difi_gauss2();
							  x2 = difi_gauss1();
							}

PNGenerierung(40057,15,32000,32767);
for (i=0;i<32000;i++) folge15q[i] = folge[i];
PNGenerierung(41889,15,32000,32767);
for (i=0;i<32000;i++) folge15i[i] = folge[i];


	 ParameterUpdate();


}




void ParameterDialog::Paint (TDC& dc, BOOL erase, TRect& rect)
{
	 TDialog::Paint(dc, erase, rect);


}


void ParameterDialog::WieSatz2BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (Teilnehmer >0) {
								if (teilnaktiv == TRUE) {
																	teilnaktiv = FALSE;
																	buttonwiesatz2->SetWindowText("inaktiv");
																	par->folgegueltig = FALSE;

																	par->AnzTeilnehmer-=multiend-multianf+1;
																	if (par->AnzTeilnehmer <1) par->AnzTeilnehmer=1;
																	char s[255];
																	sprintf(s,"Kanal: (%2d Teiln.)",par->AnzTeilnehmer);
																	par->statickanal->SetText(s);
																	par->statickanal5->SetText("E  /N");
																	par->statickanal2->SetText("b");
																	par->statickanal3->SetText("0");
																}
								  else                  {
																	teilnaktiv = TRUE;
																	buttonwiesatz2->SetWindowText("aktiv");
																	par->folgegueltig = FALSE;

																	par->AnzTeilnehmer+=multiend-multianf+1;
																	char s[255];
																	sprintf(s,"Kanal: (%2d Teiln.)",par->AnzTeilnehmer);
																	par->statickanal->SetText(s);
																	par->statickanal5->SetText("E  /N");
																	par->statickanal2->SetText("b");
																	par->statickanal3->SetText("0");
																}
							 }
	else
	 {
			 if (Parametersatz == 1)  par = par2;
				 else par = par1;
								  combospreiz1->SetSelIndex(par->spreiz1);
								  combospreiz1CBNSelchange();
								  combospreiz2->SetSelIndex(par->spreiz2);
								  combospreiz2CBNSelchange();
								  phase1=par->phase1;
								  editphase1ENChange();
								  phase2=par->phase2;
								  editphase2ENChange();
								  combonr1->SetSelIndex(par->combonr1->GetSelIndex());
								  combonr1CBNSelchange();
								  combonr2->SetSelIndex(par->combonr2->GetSelIndex());
								  combonr2CBNSelchange();

								  phase1=par->phase1;
								  editphase1ENChange();
								  phase2=par->phase2;
								  editphase2ENChange();

								  editphase1->SetPosition(phase1);
								  editphase2->SetPosition(phase2);
								  editbits->SetPosition(par->bits);
								  editwahr->SetPosition(par->wahr);

								  editkanala0->SetPosition(par->kanala0);
								  editkanala1->SetPosition(par->kanala1);
								  editkanala2->SetPosition(par->kanala2);
								  editkanala3->SetPosition(par->kanala3);
								  edite1->SetPosition(par->e1);
								  edite2->SetPosition(par->e2);
								  edite3->SetPosition(par->e3);
								  editrauschen->SetPosition(par->rauschen);
								  editpixel->SetPosition(par->pixel);
								  wahrENChange();

								  a0alt = par->a0alt;
								  a1alt = par->a1alt;
								  a2alt = par->a2alt;
								  a3alt = par->a3alt;
								  e1alt = par->e1alt;
								  e2alt = par->e2alt;
								  e3alt = par->e3alt;
								  RAKEalt = par->RAKEalt;

								  RAKE = par->RAKE;
								  if (RAKE == TRUE)  checkrake->Check(); else checkrake->Uncheck();

								  rayleigh = par->rayleigh;
								  if (rayleigh == TRUE) checkrayleigh->Check(); else checkrayleigh->Uncheck();
								  checkrayleighBNClicked();

								  editkanala0->SetPosition(par->kanala0);
								  editkanala1->SetPosition(par->kanala1);
								  editkanala2->SetPosition(par->kanala2);
								  editkanala3->SetPosition(par->kanala3);
								  edite1->SetPosition(par->e1);
								  edite2->SetPosition(par->e2);
								  edite3->SetPosition(par->e3);

								  RAKE = par->RAKE;
								  if (RAKE == TRUE)  checkrake->Check(); else checkrake->Uncheck();

			 if (Parametersatz == 1)  par = par1;
				 else par = par2;

	 }
}




void ParameterDialog::EvMouseMove (UINT modKeys, TPoint& point)
{
	 TDialog::EvMouseMove(modKeys, point);

	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein
	char s[255];
	wsprintf(s,"%4d %4d ",phase1,phase2);
//	staticpar1->SetText(s);
}


void ParameterDialog::PNListeGenerierung()
{
  if (Initialisierung != INIT_OK) return;

pnlistemax=0;
PNListeAdd(2,5,7,3);
PNListeAdd(3,9,15,7);
PNListeAdd(4,17,31,15);
PNListeAdd(5,33,63,31);
PNListeAdd(6,65,127,63);
PNListeAdd(7,129,255,127);
PNListeAdd(8,257,511,255);
PNListeAdd(15,40057,40057,32767);
PNListeAdd(15,41889,41889,32767);

for (int i=0;i<=pnlistemax;i++) pnliste2[i]=pnliste1[i];
//pnlistemax -=2;

}

void ParameterDialog::PNListeAdd(int grad,LONG min,LONG max,int laenge)
{
  if (Initialisierung != INIT_OK) return;

	LONG i;
	char s[255];
	char cM;

	for (i=min;i<=max;i++)
	  {
		  if (i & 1)
			 {
				 if (laenge == 32767) laenge = 32000;

				 pnliste1[pnlistemax].grad = grad;
				 pnliste1[pnlistemax].nr = i;
				 pnliste1[pnlistemax].laenge = laenge;
				 pnliste1[pnlistemax].phase    = laenge;

				 if (laenge < 256)
					  pnliste1[pnlistemax].Max = PNGenerierung(i,grad,laenge,laenge);
				 else
					  pnliste1[pnlistemax].Max = TRUE;

				 cM = ' ';
				 if (pnliste1[pnlistemax].Max == TRUE)
						 sprintf(pnliste1[pnlistemax].pnstr,"(%d)%6o M ",grad,i);
					else
						 sprintf(pnliste1[pnlistemax].pnstr,"(%d)%6o  ",grad,i);


				 pnlistemax++;
			 }

	  }

}

int ParameterDialog::PNGenerierung(LONG folgnr,int grad,int laenge,int phase)
{
  if (Initialisierung != INIT_OK) return 0;

	BOOL MSeq = TRUE;
	BOOL Mx;
	if (phase==32000) phase = 32767;
	LONG i,x;
	 int aus=0;
	 int reglen = 4;

	 int regin[16];
	 int reg[17];

	 int i2=1;
	 for (i=0;i<=grad; i++)
		{
			regin[i]= 1;      //"0"
			if (phase & i2) regin[i]=-1;  //"L"
			i2 *=2;
		}
	 i2=1;
	 for (i=0;i<=grad; i++)
		{
			reg[i]= 0;
			if (folgnr & i2) reg[i]=1;
			i2 *=2;
		}
	 for (x=0;x<laenge;x++)
	  {
		 aus = regin[0];
		 for (i=1;i<grad; i++)
			{
			  if (reg[i] == 1)
				 {
					aus = aus * regin[i];
				 }

			}

		 if (x<32010) folge[x] = aus;
		 for (i=0;i<grad-1;i++) regin[i] =regin[i+1];
		 regin[grad-1] = aus;
		 Mx=TRUE;
		 for (i=0;i<grad;i++) if (regin[i] != -1) Mx = FALSE;
		 if (x<laenge-1) if (Mx == TRUE) MSeq = FALSE;
	  }

	return(MSeq);
}


void ParameterDialog::WalshGenerierung()
{
  if (Initialisierung != INIT_OK) return;

  int i,x;
  int k,y;

  walshlaenge[2]=4;
  walshlaenge[3]=8;
  walshlaenge[4]=16;
  walshlaenge[5]=32;
  walshlaenge[6]=64;

  Walshfolge[0][0]=1;
  Walshfolge[0][1]=1;
  Walshfolge[1][0]=1;
  Walshfolge[1][1]=-1;
  k=1;
  for (i=1;i<=5;i++)
	 {  k*=2;
		 for (x=k;x<2*k;x++)
			{
				for (y=0;y<k;y++)
				  Walshfolge[x][y] = Walshfolge[x-k][y];
			}
		 for (x=0;x<k;x++)
			{
				for (y=k;y<2*k;y++)
				  Walshfolge[x][y] = Walshfolge[x][y-k];
			}
		 for (x=k;x<2*k;x++)
			{
				for (y=k;y<2*k;y++)
				  Walshfolge[x][y] = -Walshfolge[x-k][y-k];
			}
	 }


}



void ParameterDialog::combonr1CBNSelchange ()
{
  if (Initialisierung != INIT_OK) return;

	int x;
	int i;
	 char s[255];
	 x=combonr1->GetSelIndex();

	if (multianf != -1) {
								 combonr1->SetSelIndex(0);
								 return;
							  }

	 if (x!=folgsel1)
		{
			par->folgegueltig = FALSE;
			folgsel1 = x;
			if (x > 300) MessageBox("im combonr1","Error",MB_OK);
			if (spreiz1 == SP_PN)
			  {
				  editphase1->SetRange(phase1,1,pnliste1[folgsel1].laenge,1,SPIN_OKTAL,pnliste1[folgsel1].phase);
			  }
			if (spreiz1 == SP_WALSH)
			  {
				  walshnr1[walshgrad1] = x;
			  }




		}


}


void ParameterDialog::combonr2CBNSelchange ()
{
  if (Initialisierung != INIT_OK) return;

	int x;
	int i;
	 char s[255];
	 x=combonr2->GetSelIndex();
	 if (x!=folgsel2)
		{
			par->folgegueltig = FALSE;
			folgsel2 = x;

			if (spreiz2 == SP_PN)
			  {
				  if (pnliste2[folgsel2].laenge>255) editphase2->Hide();
				  else
					 editphase2->SetRange(phase2,1,pnliste2[folgsel2].laenge,1,SPIN_OKTAL,pnliste2[folgsel2].phase);
			  }
			if (spreiz2 == SP_WALSH)
			  {
				  walshnr2[walshgrad2] = x;
			  }




		}



}


void ParameterDialog::combospreiz1CBNSelchange ()
{
  if (Initialisierung != INIT_OK) return;

	int x;
	int i;
	 char s[255];
	 x=combospreiz1->GetSelIndex();

	if (multianf != -1) {
								 x = SP_WALSH;
								 combospreiz1->SetSelIndex(x);
							  }

	 if (x!=spreiz1+55)
		{
			par->folgegueltig = FALSE;
			spreiz1 = x;
			if (x == SP_KEINE)
			  {
				  spreiz1 = SP_KEINE;
				  laenge1 = 1;
				  combonr1->ClearList();
				  editphase1->Hide();

			  }

			if (x == SP_PN)
			  {
				  staticphase1->SetText("Phase:");
				  spreiz1 = SP_PN;
				  folgsel1 = pnfolge1;
					  if (folgsel1 > 300) MessageBox("im spreiz1","Error",MB_OK);

				  editphase1->SetRange(phase1,1,pnliste1[folgsel1].laenge,1,SPIN_OKTAL,pnliste1[folgsel1].phase);
				  combonr1->ClearList();
				  for (i=0;i<pnlistemax-2;i++) combonr1->AddString(pnliste1[i].pnstr);
				  combonr1->SetSelIndex(folgsel1);
			  }

			if (x == SP_WALSH)
			  {
				  spreiz1 = SP_WALSH;
				  folgsel1 = walshnr1[walshgrad1];
				  staticphase1->SetText("Grad:");
				  combonr1->ClearList();

				  if (multianf != -1)
					 {
												sprintf(s,"   %d ... %d ",multianf,multiend);
												combonr1->AddString(s);
												combonr1->SetSelIndex(0);
					 }
				  else
					 {
						for (i=0;i<walshlaenge[walshgrad1];i++)
								 {
									 sprintf(s,"%8d ",i);
									 combonr1->AddString(s);
								 }
						editphase1->SetRange(phase1,2,6,1,SPIN_EINS,walshgrad1);
						combonr1->SetSelIndex(folgsel1);

					 }
			  }




		}

}


void ParameterDialog::combospreiz2CBNSelchange ()
{
  if (Initialisierung != INIT_OK) return;

	int x;
	int i;
	 char s[255];
	 x=combospreiz2->GetSelIndex();
	 if (x!=spreiz2)
		{
			par->folgegueltig = FALSE;
			spreiz2 = x;
			if (x == SP_KEINE)
			  {
				  spreiz2 = SP_KEINE;
				  laenge2 = 1;
				  combonr2->ClearList();
				  editphase2->Hide();

			  }

			if (x == SP_PN)
			  {
				  staticphase2->SetText("Phase:");
				  spreiz2 = SP_PN;
				  folgsel2 = pnfolge2;
				  editphase2->SetRange(phase2,1,pnliste2[folgsel2].laenge,1,SPIN_OKTAL,pnliste2[folgsel2].phase);
				  combonr2->ClearList();
				  for (i=0;i<pnlistemax;i++) combonr2->AddString(pnliste2[i].pnstr);
				  combonr2->SetSelIndex(folgsel2);
			  }

			if (x == SP_WALSH)
			  {
				  spreiz2 = SP_WALSH;
				  folgsel2 = walshnr2[walshgrad2];
				  staticphase2->SetText("Grad:");
				  editphase2->SetRange(phase2,2,6,1,SPIN_EINS,walshgrad2);
				  combonr2->ClearList();
				  for (i=0;i<walshlaenge[walshgrad2];i++)
								 {
									 sprintf(s,"%8d ",i);
									 combonr2->AddString(s);
								 }
				  combonr2->SetSelIndex(folgsel2);
			  }




		}


}


void ParameterDialog::EvLButtonDblClk (UINT modKeys, TPoint& point)
{
	 TDialog::EvLButtonDblClk(modKeys, point);


}


void ParameterDialog::editphase1ENChange ()
{
  if (Initialisierung != INIT_OK) return;

	if (multianf != -1) return;

	if (spreiz1 == SP_PN)
	  {
		  pnliste1[folgsel1].phase = phase1;
		  par->folgegueltig = FALSE;
	  }
	if (spreiz1 == SP_WALSH)
	  {

		  int i;
		  char s[255];
		  walshgrad1 = phase1;
		  folgsel1 = walshnr1[walshgrad1];
		  combonr1->ClearList();
		  for (i=0;i<walshlaenge[walshgrad1];i++)
				 {
					 sprintf(s,"%6d ",i);
					 combonr1->AddString(s);
				 }
		  combonr1->SetSelIndex(folgsel1);

		  par->folgegueltig = FALSE;
	  }

}


void ParameterDialog::editphase2ENChange ()
{
  if (Initialisierung != INIT_OK) return;

	if (spreiz2 == SP_PN)
	  {
		  pnliste2[folgsel2].phase = phase2;
		  par->folgegueltig = FALSE;
	  }
	if (spreiz2 == SP_WALSH)
	  {

		  int i;
		  char s[255];
		  walshgrad2 = phase2;
		  folgsel2 = walshnr2[walshgrad2];
		  combonr2->ClearList();
		  for (i=0;i<walshlaenge[walshgrad2];i++)
				 {
					 sprintf(s,"%6d ",i);
					 combonr2->AddString(s);
				 }
		  combonr2->SetSelIndex(folgsel2);

		  par->folgegueltig = FALSE;
	  }


}




void ParameterDialog::ParameterUpdate ()
{
  if (Initialisierung != INIT_OK) return;

TApplication* app=GetApplication();
TFrameWindow* frame =app->GetMainWindow();
TWindow* client = frame->GetClientWindow();
int look[3200];
int i;
static int x;
int min,max;


/*   **********************************************************************
	  *                        Signal SIG_X1                               *
	  **********************************************************************/

if (Teilnehmer > 0) {
							 wahrENChange();
							 bitsENChange();
							 if (teilnaktiv == FALSE) return;
						  }

if (spreiz1==SP_PN)
  {
		laenge1=pnliste1[folgsel1].laenge;
		LONG nr = pnliste1[folgsel1].nr;
		int grad = pnliste1[folgsel1].grad;
		int phase = pnliste1[folgsel1].phase;
		PNGenerierung(nr,grad,laenge1,phase);

		  for (i=0;i<laenge1;i++) {
											 Signal[SIG_X1].folge[i+20]=folge[i];
										  }

  }

if (spreiz1==SP_WALSH)
  {
		laenge1=walshlaenge[walshgrad1];
		int nr = folgsel1;

		  for (i=0;i<laenge1;i++) {
											 Signal[SIG_X1].folge[i+20]=Walshfolge[nr][i];
										  }

  }

if (spreiz1 == SP_KEINE)
  {
	 laenge1=1;
	 Signal[SIG_X1].folge[20]=1;
  }

  if ((LONG)bits*pixel*laenge1 >20000) editpixel->SetPosition(20000/bits/laenge1);
  if ((LONG)bits*pixel*laenge1 >20000) editbits->SetPosition(20000/pixel/laenge1);

  Signal[SIG_X1].laenge=laenge1;
  Signal[SIG_X1].datenbits=1;
  Signal[SIG_X1].min=-1;
  Signal[SIG_X1].max=1;
  Signal[SIG_X1].pixel = pixel;


if (laenge1>19)
	for (i=0;i<20;i++)  Signal[SIG_X1].folge[i]= Signal[SIG_X1].folge[laenge1+i];
else
  {
	 x = 19;
	 while(x>=-1)
	  {
		for (i=0;i<laenge1;i++)
		  if ( (x-i)>=0) Signal[SIG_X1].folge[x-i]= Signal[SIG_X1].folge[(laenge1-i+19)];
		x-=laenge1;
	  }
	if(laenge1>x+5000) laenge1+=x*2;
  }

/*   *********************************************************************
	  *                        Signal SIG_X2                              *
	  *********************************************************************/


signallaenge=bits*laenge1;
if (par->wdfbits>0) {
							 wahrENChange();
							 signallaenge=par->wdfbits*laenge1;
						  }


if (spreiz2==SP_PN)
  {
		laenge2=pnliste2[folgsel2].laenge;
		LONG nr = pnliste2[folgsel2].nr;
		int grad = pnliste2[folgsel2].grad;
		int phase = pnliste2[folgsel2].phase;

		if (laenge2 < 256)
				PNGenerierung(nr,grad,laenge2,phase);
		else
		  {
			  if (nr == 40057) for (i=0;i<signallaenge;i++) folge[i]=folge15i[i];
			  if (nr == 41889) for (i=0;i<signallaenge;i++) folge[i]=folge15q[i];
		  }

		if (laenge2>signallaenge) laenge2=signallaenge;

		  for (i=0;i<laenge2;i++) {
											 Signal[SIG_X2].folge[i+20]=folge[i];
										  }

  }

if (spreiz2==SP_WALSH)
  {
		laenge2=walshlaenge[walshgrad2];
		int nr = folgsel2;

		  for (i=0;i<laenge2;i++) {
											 Signal[SIG_X2].folge[i+20]=Walshfolge[nr][i];
										  }

  }

if (spreiz2 == SP_KEINE)
  {
	 laenge2=1;
	 Signal[SIG_X2].folge[20]=1;
  }


  Signal[SIG_X2].laenge=laenge2;
  Signal[SIG_X2].datenbits=1;
  Signal[SIG_X2].min=-1;
  Signal[SIG_X2].max=1;
  Signal[SIG_X2].pixel = pixel;


if (laenge2>19)
	for (i=0;i<20;i++)  Signal[SIG_X2].folge[i]= Signal[SIG_X2].folge[laenge2+i];
else
  {
	 x = 19;
	 while(x>=-1)
	  {
		for (i=0;i<laenge2;i++)
		  if ( (x-i)>=0) Signal[SIG_X2].folge[x-i]= Signal[SIG_X2].folge[(laenge2-i+19)];
		x-=laenge2;
	  }
  }



/*   *********************************************************************
	  *                        Signal SIG_Q                               *
	  *********************************************************************/


  Signal[SIG_Q].laenge=bits;
  Signal[SIG_Q].datenbits=10;
  Signal[SIG_Q].min=-1000;
  Signal[SIG_Q].max=1000;
  Signal[SIG_Q].pixel = pixel;


/*   *********************************************************************
	  *                        Signal SIG_S                               *
	  *********************************************************************/



  for (i=0;i<20;i++)
			{
			  Signal[SIG_S].folge[i]= Signal[SIG_Q].folge[19] * Signal[SIG_X1].folge[i];
			  Signal[SIG_S].folge[i]= Signal[SIG_S].folge[i] *  Signal[SIG_X2].folge[i];
			}

  for (i=0;i<signallaenge+10;i++)
			{
			  Signal[SIG_S].folge[i+20]=Signal[SIG_Q].folge[(i/laenge1)+20]*Signal[SIG_X1].folge[(i%laenge1)+20];
			  Signal[SIG_S].folge[i+20]= Signal[SIG_S].folge[i+20] *  Signal[SIG_X2].folge[(i%laenge2)+20];
			}

  Signal[SIG_S].laenge=signallaenge;
  Signal[SIG_S].datenbits=bits;
  Signal[SIG_S].min=-1000;
  Signal[SIG_S].max=1000;
  Signal[SIG_S].pixel = pixel;




/*   *********************************************************************
	  *                        Signal SIG_E1                              *
	  *********************************************************************/

LONG a0l=kanala0;
LONG a1l=kanala1;
LONG a2l=kanala2;
LONG a3l=kanala3;

double x1,x2,q;
double k;
int qi,qi1;
int dopp_fr_anz = 200;
if (rayleigh == TRUE)
 {
  if (doppler == 0) dopp_fr_anz = 1000;
  if (doppler == 1) dopp_fr_anz = 500;
  if (doppler == 2) dopp_fr_anz = 250;
  if (doppler == 3) dopp_fr_anz = 125;
  if (doppler == 4) dopp_fr_anz = 10;
  if (doppler == 5) dopp_fr_anz = 1;

  for (i=0;i< ((signallaenge+30) / dopp_fr_anz)+5;i++)
	 {
		x1 = difi_gauss1();
		x2 = difi_gauss2();
		rayl_fakt[W(i)] = sqrt(x1*x1+x2*x2);
	 }
 }

int rl=0;
if (kanala1!=0) if (e1>rl) rl=e1;
if (kanala2!=0) if (e2>rl) rl=e2;
if (kanala3!=0) if (e3>rl) rl=e3;
rakelen = rl;
if (RAKE == FALSE) { rakelen = 0; rl = 0; }
LONG xl;
max=-32000;
min=32000;
  for (i=10;i<signallaenge+30;i++)
{
if (rayleigh == FALSE)
  {

	xl=Signal[SIG_S].folge[i]*a0l+Signal[SIG_S].folge[i-e1]*a1l+Signal[SIG_S].folge[i-e2]*a2l+Signal[SIG_S].folge[i-e3]*a3l;

	x=xl/100;
  }
else
  {
	 q = (double)i / dopp_fr_anz;
	 qi=q;
	 if (qi==0)qi1=0; else qi1=qi-1;

	 k=q-qi;
	 x1=rayl_fakt[W(qi)] +  (rayl_fakt[W(qi+1)]-rayl_fakt[W(qi)]) * k; // Quadratische Interpolation
	 x1+= -k*(1-k)/4 * ( (rayl_fakt[W(qi+2)]-rayl_fakt[W(qi+1)])  - (rayl_fakt[W(qi)]-rayl_fakt[W(qi1)]) );

    if (doppler == 5) { x1 = rayl_fakt[W(i)]; }
	 x= x1 * Signal[SIG_S].folge[i];
  }
Signal[SIG_E1].folge[i]=x;
if (x>max)max=x;
if (x<min)min=x;

}

if (max==min) {min=min-abs(min)*0.2; max=max+abs(max)*0.2;
					 if (max==0) {min=-1;max=1;} }

  Signal[SIG_E1].laenge=signallaenge+rakelen;
  Signal[SIG_E1].datenbits=bits;
  Signal[SIG_E1].min=min;
  Signal[SIG_E1].max=max;
  Signal[SIG_E1].pixel = pixel;


if (Teilnehmer > 0)
	{
	  int a,b;
	  for (i=10;i<signallaenge+30;i++)
		{
			a = (i-10) * rauschen/100 + pixel;
			par->Signal[SIG_E2].folge[i] += Signal[SIG_E1].folge[i];
         if (par->Signal[SIG_E2].folge[i] > 28000) par->Signal[SIG_E2].folge[i] = 28000;
		}
	  return;
	}




/*   *********************************************************************
	  *                        Signal SIG_N                               *
	  *********************************************************************/


max=-32000;
min=32000;
double sigma;
int ebn0 = rauschen;
if (rauschen == 105) ebn0 = 200;
if (rauschen == 110) ebn0 = 300;
if (rauschen == 115) ebn0 = 400;
if (rauschen == 120) ebn0 = 500;
sigma = sqrt(laenge1) * 1000/sqrt(2.0) * pow(10.0,-(double)ebn0/200);
if (rauschen == 125) sigma=0;
float xf;

  for (i=10;i<signallaenge+30;i++)
{
if (altuebernehmen == FALSE) { x=floor(gauss()*sigma);
										 Signal[SIG_N].folge[i]=x;
									  }
 else x = Signal[SIG_N].folge[i];

if (x>max)max=x;
if (x<min)min=x;

}

if (max==min) {min=min-abs(min)*0.2; max=max+abs(max)*0.2;
					 if (max==0) {min=-1;max=1;} }

  Signal[SIG_N].laenge=signallaenge+rakelen;
  Signal[SIG_N].datenbits=bits;
  Signal[SIG_N].min=min;
  Signal[SIG_N].max=max;
  Signal[SIG_N].pixel = pixel;

/*   *********************************************************************
	  *                        Signal SIG_E2                              *
	  *********************************************************************/


max=-32000;
min=32000;

if (altuebernehmen == FALSE)
 {

	for (i=10;i<signallaenge+30;i++)
	{
		Signal[SIG_E2].folge[i]=0;
	}

	if (Teilnehmer == 0)
		{
			  TApplication* app=GetApplication();
			  TFrameWindow* frame =app->GetMainWindow();
			  TWindow* client = frame->GetClientWindow();
			  char s[255];
			  strcpy(s,"  ");

			  if (par->Parametersatz == 1) client->Transfer(s,31);
			  if (par->Parametersatz == 2) client->Transfer(s,32);
		}
 }

  for (i=10;i<signallaenge+30;i++)
{
x=Signal[SIG_E2].folge[i];

if (x>max)max=x;
if (x<min)min=x;
}


altuebernehmen = FALSE;



if (max==min) {min=min-abs(min)*0.2; max=max+abs(max)*0.2;
					 if (max==0) {min=-1;max=1;} }

  Signal[SIG_E2].laenge=signallaenge+rakelen;
  Signal[SIG_E2].datenbits=bits;
  Signal[SIG_E2].min=min;
  Signal[SIG_E2].max=max;
  Signal[SIG_E2].pixel = pixel;



/*   *********************************************************************
	  *                        Signal SIG_E                               *
	  *********************************************************************/


max=-32000;
min=32000;

  for (i=10;i<signallaenge+30;i++)
{
//if (par->wdfbits==0)
	x=Signal[SIG_E1].folge[i] + Signal[SIG_N].folge[i] + Signal[SIG_E2].folge[i];
/* else {    xf=Signal[SIG_E1].folge[i] + Signalf[SIG_N][W(i)] + Signal[SIG_E2].folge[i];
			  Signalf[SIG_E][W(i)] =xf;
      }
*/
Signal[SIG_E].folge[i]=x;
if (x>max)max=x;
if (x<min)min=x;

}

if (max==min) { min=min-abs(min)*0.2; max=max+abs(max)*0.2;
					 if (max==0) {min=-1;max=1;} }


  Signal[SIG_E].laenge=signallaenge+rakelen;
  Signal[SIG_E].datenbits=bits;
  Signal[SIG_E].min=min;
  Signal[SIG_E].max=max;
  Signal[SIG_E].pixel = pixel;


if (wdfbits>0)
	 {
		  for (i=20;i<signallaenge+30;i++)
			{


			}

    }
/*   *********************************************************************
	  *                        Signal SIG_R                               *
	  *********************************************************************/


max=-32000;
min=32000;
  for (i=20;i<signallaenge+30;i++)
{
xl=Signal[SIG_E].folge[i-rl]*a0l+Signal[SIG_E].folge[i-rl+e1]*a1l+Signal[SIG_E].folge[i-rl+e2]*a2l+Signal[SIG_E].folge[i-rl+e3]*a3l;
x=xl/100;
if (RAKE==FALSE) x = Signal[SIG_E].folge[i];
Signal[SIG_R].folge[i]=x;
if (x>max)max=x;
if (x<min)min=x;

}

if (max==min) { min=min-abs(min)*0.2; max=max+abs(max)*0.2;
					 if (max==0) {min=-1;max=1;} }


  Signal[SIG_R].laenge=signallaenge+rakelen;
  Signal[SIG_R].datenbits=bits;
  Signal[SIG_R].min=min;
  Signal[SIG_R].max=max;
  Signal[SIG_R].pixel = pixel;


/*   *********************************************************************
	  *                        Signal SIG_XTKR                            *
	  *********************************************************************/


  for (i=0;i<rl;i++)
{
x=Signal[SIG_X1].folge[i+20-rl]*Signal[SIG_X2].folge[i+20-rl];
Signal[SIG_XTKR].folge[i+20]=x;
}

  for (i=0;i<signallaenge;i++)
{
x=Signal[SIG_X1].folge[(i%laenge1)+20]*Signal[SIG_X2].folge[(i%laenge2)+20];
Signal[SIG_XTKR].folge[i+20+rl]=x;
Signal[SIG_X12].folge[i+20]=x;
}

  Signal[SIG_XTKR].laenge=signallaenge+rakelen;
  Signal[SIG_X12].laenge=signallaenge;
  Signal[SIG_XTKR].datenbits=bits;
  Signal[SIG_XTKR].min=-1;
  Signal[SIG_XTKR].max=1;
  Signal[SIG_XTKR].pixel = pixel;


/*   *********************************************************************
	  *                        Signal SIG_B                               *
	  *********************************************************************/


max=-32000;
min=32000;

  for (i=20;i<signallaenge+20+rl;i++)
{
x=Signal[SIG_R].folge[i]*Signal[SIG_XTKR].folge[i];

Signal[SIG_B].folge[i]=x;
if (x>max)max=x;
if (x<min)min=x;

}

if (max==min) { min=min-abs(min)*0.2; max=max+abs(max)*0.2;
					 if (max==0) {min=-1;max=1;} }


  Signal[SIG_B].laenge=signallaenge+rakelen;
  Signal[SIG_B].datenbits=bits;
  Signal[SIG_B].min=min;
  Signal[SIG_B].max=max;
  Signal[SIG_B].pixel = pixel;



/*   *********************************************************************
	  *                        Signal SIG_D                               *
	  *********************************************************************/
sigmam1 = 0;
sigmam2 = 0;

int wdfi =0;

LONG wdfmin=3200000;
LONG wdfmax=-3200000;
max=-32000;
min=32000;
int f;
double det;
  for (i=0;i<rl;i++) Signal[SIG_D].folge[i+20]=0;

  for (i=0;i<signallaenge;i++)
{
if(i%laenge1 == 0) xl=0;
xl+= Signal[SIG_B].folge[i+20+rl];
Signal[SIG_D].folge[i+20+rl]=xl/laenge1;

if (i%laenge1 == laenge1-1) {
										 if (xl>=0) { Signal[SIG_V].folge[(i/laenge1)+20] = 1000; }
										  else  { Signal[SIG_V].folge[(i/laenge1)+20] = -1000; }
										 SignalWDF[W(wdfi)] = xl;
										 wdfi++;
										 if (xl>wdfmax)wdfmax=xl;
										 if (xl<wdfmin)wdfmin=xl;
										 det = (double)xl/laenge1/1000;
										 if (Signal[SIG_Q].folge[(i/laenge1)+20] >0) f=1; else f=-1;
                               sigmam1 += det*f;
                               sigmam2 += det * det;

									 }
LONG xxl = xl / laenge1;
if (xxl>max)max=xxl;
if (xxl<min)min=xxl;

}

if (max==min) { min=min-abs(min)*0.2; max=max+abs(max)*0.2;
					 if (max==0){  min=-1;max=1; }
				  }

if (wdfmax==wdfmin) { wdfmin=wdfmin-abs(wdfmin)*0.2;
							 wdfmax=wdfmax+abs(wdfmax)*0.2;
							 if (wdfmax==0) {wdfmin=-1;wdfmax=1;}
						  }


  Signal[SIG_D].laenge=signallaenge+rakelen;
  Signal[SIG_D].datenbits=bits;
  Signal[SIG_D].min=min;
  Signal[SIG_D].max=max;
  Signal[SIG_D].pixel = pixel;

  Signal[SIG_WDF].laenge=wdfi;
  Signal[SIG_WDF].datenbits=wdfi;

  SignalWDFmin=wdfmin;
  SignalWDFmax=wdfmax;
  Signal[SIG_WDF].pixel = pixel;

  Signal[SIG_V].laenge=bits;
  Signal[SIG_V].datenbits=10;
  Signal[SIG_V].min=-1000;
  Signal[SIG_V].max=1000;
  Signal[SIG_V].pixel = pixel;


  folgegueltig = TRUE;
  par->wdfbits=0;


}

void ParameterDialog::CmOk ()
{
MessageBox("cmok","Meldung",MB_OK);
}

void ParameterDialog::editpixelENChange ()
{
  if (Initialisierung != INIT_OK) return;

  if ((LONG)bits*pixel*laenge1 >20000) editbits->SetPosition(20000/pixel/laenge1);
  if ((LONG)bits*pixel*laenge1 >20000) editpixel->SetPosition(20000/bits/laenge1);

  par->folgegueltig = FALSE;
  if (Teilnehmer >0) {
							  bitsENChange();
							}

}


void ParameterDialog::bitsENChange ()
{
  if (Initialisierung != INIT_OK) return;

  if ((LONG)bits*pixel*laenge1 >20000) editpixel->SetPosition(20000/bits/laenge1);
  if ((LONG)bits*pixel*laenge1 >20000) editbits->SetPosition(20000/pixel/laenge1);


  par->folgegueltig = FALSE;
  if (Teilnehmer >0) {
							  bitst = ((LONG)par->bits*rauschen/100+pixel/par->laenge1);
							  if (pixel % par->laenge1 > 0) bitst++;
							  if ((LONG)par->bits*rauschen%100 > 0) bitst++;
							  if (bits != bitst) { bits = bitst;
														  editbits->SetPosition(bitst);
														}
							}
}


void ParameterDialog::wahrENChange ()
{
  if (Initialisierung != INIT_OK) return;

  int i;
  par->folgegueltig = FALSE;
  if (wahrinit == 1)  for (i=0;i<32700;i++) if (prng01() < (float)wahr/100) Signal[SIG_Q].folge[i]=1000;
															  else Signal[SIG_Q].folge[i]=-1000;


}


void ParameterDialog::editkanala0ENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;

}


void ParameterDialog::editkanala1ENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;

}

void ParameterDialog::editkanala2ENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;

}


void ParameterDialog::editkanala3ENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;

}


void ParameterDialog::editkanalrauschenENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;
  if (Teilnehmer >0) {
							  bitsENChange();
							}

}


void ParameterDialog::edite1ENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;

}


void ParameterDialog::edite2ENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;

}


void ParameterDialog::edite3ENChange ()
{
  if (Initialisierung != INIT_OK) return;

  par->folgegueltig = FALSE;

}




/*---------------------------------------------------------------------*

Name            wgn

Usage           double wgn(double sigmax);

Parameters	double sigmax         : Streuung des Gaussprozesses

		float *array          : Pointer auf erstes Element des
					Gauss-Arrays mit JWGN/2 Elementen

Prototype in    wgn_ti.h

Description     Erzeugt gaussverteilte Zufallsgroesse nach dem Verfahren
		"Tabulated Inversion" ohne statistische Bindungen. Fuer
		den Aufruf muss ein Speicherbereich array mit 64kByte zu-
		gewiesen werden.Das Feld wgn_array muss bereits auf sigma
		normiert sein (siehe norm_wgn_array)!!

Return value    gauss'sche ZG mit Streuung sigma und Mittelwert 0
*---------------------------------------------------------------------*/

double ParameterDialog::wgn(double sigmax)
{
  static long kwgn=1;
  unsigned int index,sign;
  double res,u;
  kwgn=0x15a4e35L*kwgn+1;
  sign=(kwgn>>30)&1;
  index=(kwgn>>16)&0x3FFF;
  if((index<JWGN/2-t_wgn))
	return((sign) ? wgn_array[index]*sigmax:-wgn_array[index]*sigmax);
/*	return((sign) ? wgn_array[index]:-wgn_array[index]);*/
  u=prng01()*(double)t_wgn/JWGN;
  res=sigmax*inv_phi(u);
  return((sign) ? res : -res);
}

/*---------------------------------------------------------------------*

Name            norm_wgn_array

Usage           void norm_wgn_array(double sigma);

Parameters              double sigma  : Streuung, auf die das Array normiert
					werden soll

Prototype in    wgn_ti.h

Description     Jedes Element des Arrays wgn_array wird mit einem
		Faktor multipliziert, so dass das Array wgn_array an-
		schliessend auf sigma normiert ist.

Return value    keiner

*---------------------------------------------------------------------*/

void ParameterDialog::norm_wgn_array(double sigma)
{
	static double sigma_alt=1;
		  double factor;
	unsigned i;

	factor=sigma/sigma_alt;
/*	printf("\t\tFaktor bei der Normierung des Gauss-arrays: %f\n",factor);*/
	for(i=0;i<JWGN/2;++i)
		wgn_array[i]*=factor;

	sigma_alt=sigma;
	return;
}

/*---------------------------------------------------------------------*

Name            load_wgn_file

Usage           int load_wgn_file(void);

Parameters	keiner

Prototype in    wgn_ti.h

Description     Laedt Gauss-Daten aus Datei gauss.dat

Return value    1: Erfolgreiche Operation
		-1: Datei nicht gefunden
		-2: Dateigroesse stimmt nicht
		-3: Kein Speicher allokiert
*---------------------------------------------------------------------*/

int ParameterDialog::load_wgn_file(char *gauss_file)
{
  FILE *wgn_file;
//x  wgn_array=(double *)malloc(sizeof(double)*JWGN/2);
  t_wgn=1;
  wgn_array=new float[JWGN/2-1];
  if(wgn_array==0)
	return(-3);
  wgn_file=fopen("gauss.dat","rb");
//  wgn_file=fopen(gauss_file,"rb");
  if(wgn_file==0) /*File not in Directory*/
	return(-1);
  if(file_size(wgn_file)!=(JWGN/2*sizeof(float)))/*mismatched Filesize*/
	return(-2);
  rewind(wgn_file);
  fread(wgn_array,sizeof(float),JWGN/2-1,wgn_file);
  fclose(wgn_file);
  return(1);
}

/*---------------------------------------------------------------------*

Name            create_wgn_file

Usage           int create_wgn_file(void);

Parameters	keiner

Prototype in    wgn_ti.h

Description     Erzeugt Datei gauss.dat

Return value    1: Erfolgreiche Operation
		-1: Misslungene Operation, Datei wurde nicht erzeugt
		-2: Kein Speicher allokiert
*---------------------------------------------------------------------*/

int ParameterDialog::create_wgn_file(void)
{
  FILE *wgn_file;
  long unsigned i,j,samples;
  unsigned anzahl;
  double Ij,Ij_p1,x,x2,dx,Cj,m2,z,pj;
  wgn_array=(float *)malloc(sizeof(float)*JWGN/2);
  if(wgn_array==NULL)
	return(-2);

  samples=1000;
  pj=1.0/(double)JWGN;          /*see eq. (11)*/
  Ij=0;
  j=0;
  for(z=0.5+pj;z<1;z+=pj){
	Ij_p1=inv_phi(z);        /*see eq. (16)*/

	/* Cj with eq. (18) --> Integration*/
	  dx=(Ij_p1 - Ij)/samples;
	  m2=0;
	  for(i=1;i<=samples;++i){
		x=Ij+i*dx;
		x2=x*x;
		m2+=x2*exp(-x2/2);
	  }
	  Cj=sqrt(m2*JWGN*dx*SQRT_1_2PI);

	/* Cj with eq. (19) --> Mean Value*/
	/* Cj=(Ij+Ij_p1)/2;*/

	wgn_array[j++]=Cj;           /*for j >= JWGN/2*/
	Ij=Ij_p1;
  }
  wgn_file=fopen("gauss.dat","wb");
  anzahl=fwrite(wgn_array,sizeof(double),JWGN/2,wgn_file);
  fclose(wgn_file);
  if(anzahl!=(JWGN/2))
	return(-1);
  return(1);
}

/*---------------------------------------------------------------------*

Name            scramble_array

Usage           void scramble_array(void);

Parameters	keiner

Prototype in    wgn_ti.h

Description     Verwuerfelt Gauss-Array beim Laden von gauss.dat, zur
		Speicherreservierung muss zuvor load_wgn_file auf-
		gerufen werden.

Return value    1: Erfolgreiche Operation
		-1: Datei nicht gefunden
		-2: Dateigroesse stimmt nicht
*---------------------------------------------------------------------*/

int ParameterDialog::scramble_array(char *gauss_file)
{
	FILE *wgn_file;

	long j;
	unsigned long k=1234;
	wgn_file=fopen(gauss_file,"rb");
	if(wgn_file==NULL)/*File not in Directory*/
		return(-1);
	if(file_size(wgn_file)!=(JWGN/2*sizeof(double)))/*mismatched Filesize*/
		return(-2);
	rewind(wgn_file);
	for(j=0;j<2*JWGN;++j){
		k=(25173L*k+13849L)%65536;
		if(k<JWGN/2-t_wgn-1)
			fread(&wgn_array[k],sizeof(double),1,wgn_file);
	}
	fclose (wgn_file);
	return(1);
}

/*---------------------------------------------------------------------*

Name            prng01

Usage           double prng01(void);

Parameters	keiner

Prototype in    wgn_ti.h

Description     Erzeugt glvt. ZG. zwischen 0 und 1 mit Periode 2^31-2
		und Quantisierung von ca. 4.7e-10

Return value    1: Erfolgreiche Operation
		-1: Datei nicht gefunden
		 -2: Dateigroesse stimmt nicht
*---------------------------------------------------------------------*/

double ParameterDialog::prng01(void)
{
  long static k=1234;
  long s, m=0x7FFFFFFF,
  a=16807, q=127773, r=2836;
  s=k/q;
  k=a*(k-q*s)-r*s;
  if (k<=0)
	k+=m;
  return ((double)k/m);
}

/*---------------------------------------------------------------------*

Name            phi

Usage           double phi(double z);

Parameters	double z              : Argument der Phi-Funktion

Prototype in    wgn_ti.h

Description     phi(z) entspricht 0.5*(1+erf(z/sqrt(2)) und ist das
		Gauss'sche Fehlerintegral

Return value    Wk. P(x<z) bei Normalverteilung (m=0,sigma=1)
*---------------------------------------------------------------------*/

double ParameterDialog::phi(double z)
{
  double z2,zabs,s,v,
	t1=0.6666667,   t2=0.2666667,
	t3=0.07619048,  t4=0.01693122,
	t5=3.078403E-3, t6=4.736005E-4,
	t7=6.314673E-5, t8=7.429027E-6,
	t9=7.820028E-7,t10=7.447646E-8,
	t11=6.476214E-9;
  if(z==0.0)
	return (0.5);
  z2=z*z/2;
  zabs=sqrt(z2);
  if (zabs<=1.5){
	s=t9+z2*(t10+z2*t11);
	s=t6+z2*(t7+z2*(t8+z2*s));
	s=t3+z2*(t4+z2*(t5+z2*s));
	s=1.+z2*(t1+z2*(t2+z2*s));
	return(0.5+exp(-z2)*SQRT_1_2PI*z*s);
  }
  if(zabs<5.5){
	v=1./(z*z);
	s=v/(1+10*v/(1+11*v/(1+12*v)));
	s=v/(1+7*v/(1+8*v/(1+9*s)));
	s=v/(1+4*v/(1+5*v/(1+6*s)));
	s=1/(z*(1+v/(1+2*v/(1+3*s))));
	s=-SQRT_1_2PI*s*exp(-z2);
  }
  else
	s=exp(-z2)/(2*zabs*SQRTPI);
  return((z<0)? s : 1+s);
}

/*---------------------------------------------------------------------*

Name            inv_phi

Usage           double inv_phi(double q);

Parameters	double q            : Argument der inversen Phi-Funktion

Prototype in    wgn_ti.h

Description     Umkehrfunktion zu Phi(z), d.h. phi(inv_phi(z))=z

Return value    derjenige Wert von x, fr den gilt: P(x<z)=q
*---------------------------------------------------------------------*/

double ParameterDialog::inv_phi(double q)
{
  double dx,x[3],f[2],diff,s;
  diff=(q>1.0e-4)?1.0e-8:q*q;
  x[0]= 3;
  x[1]=-3;
  f[0]=phi(x[0])-q;
  f[1]=phi(x[1])-q;

/* regula falsi */
  while(1){ /*endless loop*/
	s=(f[1]-f[0])/(x[1]-x[0]);
	x[2]=x[1]-f[1]/s;
	dx=x[2]-x[1];
	dx*=dx;
	if(dx<diff)
		return(x[2]); /*exit loop*/
	x[0]=x[1];
	x[1]=x[2];
	f[0]=f[1];
	f[1]=phi(x[1])-q;
  }
}


long ParameterDialog::file_size(FILE *stream)
{
	long curpos, length;

	curpos = ftell(stream);
	fseek(stream, 0L, SEEK_END);
	length = ftell(stream);
	fseek(stream, curpos, SEEK_SET);
	return length;
}

/*-----------------------------------------------------------------------*

Name            res_wgn

Usage           unsigned long res_wgn(void);

Parameters      keine

Prototype in    om_ifht.h

Description     Gibt den reservierten Speicherbereiche
		wieder frei.

Return value    Anzahl der freigewordenen Byte
		Modifizierung weil gcc coreleft nicht kennt:
		Rueckgabewert immer 1111.
*------------------------------------------------------------------------*/

unsigned long ParameterDialog::res_wgn(void)
{
/*	unsigned long byte1,byte2;
	byte1=coreleft();*/
	free(wgn_array);
/*	byte2=coreleft();*/
	return(1111);
}




UINT ParameterDialog::Transfer (void* buffer, TTransferDirection direction)
{
	 UINT result;
	char s[255];
	int i;
	strcpy(s,"   ");
		if (direction <=2) result = TDialog::Transfer(buffer, direction);
	else
	  {
		 if (Initialisierung != INIT_OK) return 0;


		 if (Teilnehmer > 0)
		  {

			 if (direction == 41)  {
											 if (Teilnehmer == 1) {
																			 if (multianf == -1) ParameterUpdate();
																			 else
																			 for (i=multianf;i<multiend;i++) { folgsel1 = i;
																														  ParameterUpdate();
																														}
																		 }
										  }
			 if (direction == 42)  {
											 if (Teilnehmer == 2) {
																			 if (multianf == -1) ParameterUpdate();
																			 else
																			 for (i=multianf;i<multiend;i++) { folgsel1 = i;
																														  ParameterUpdate();
																														}
																		 }
										  }
		  }
	  }




	 return result;
}


BOOL ParameterDialog::CanClose ()
{
  if (Initialisierung != INIT_OK) return TRUE;

	 BOOL result;

	 result = TDialog::CanClose();

								  par->AnzTeilnehmer-=multiend-multianf+1;
								  if (par->AnzTeilnehmer <1) par->AnzTeilnehmer=1;
								  char s[255];
								  sprintf(s,"Kanal: (%2d Teiln.)",par->AnzTeilnehmer);
								  par->statickanal->SetText(s);
								  par->folgegueltig = FALSE;

	 return result;
}


void ParameterDialog::combodopplerCBNEditchange ()
{
}


void ParameterDialog::checkrayleighBNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (checkrayleigh->GetCheck() == BF_CHECKED) rayleigh = TRUE; else rayleigh = FALSE;
	folgegueltig = FALSE;

  if (rayleigh == TRUE)
	 {
		 a0alt = kanala0;
		 a1alt = kanala1;
		 a2alt = kanala2;
		 a3alt = kanala3;
		 e1alt = e1;
		 e2alt = e2;
		 e3alt = e3;

		 combodoppler->ClearList();
		 combodoppler->AddString("50Hz");
		 combodoppler->AddString("100Hz");
		 combodoppler->AddString("200Hz");
		 combodoppler->AddString("400Hz");
		 combodoppler->AddString("5kHz");
		 combodoppler->AddString("FIRF");
		 combodoppler->SetSelIndex(par->doppler);


		 editkanala0->SetRange(kanala0,0,100,5,SPIN_HUND,100);
		 editkanala1->SetRange(kanala1,0,0,5,SPIN_HUND,0);
		 editkanala2->SetRange(kanala2,0,0,5,SPIN_HUND,0);
		 editkanala3->SetRange(kanala3,0,0,5,SPIN_HUND,0);

		 edite1->SetRange(e1,1,1,1,SPIN_DIGIT,1);
		 edite2->SetRange(e1,2,2,1,SPIN_DIGIT,2);
		 edite3->SetRange(e1,3,3,1,SPIN_DIGIT,3);

		 editkanala1->Hide();
		 editkanala2->Hide();
		 editkanala3->Hide();
		 edite1->Hide();
		 edite2->Hide();
		 edite3->Hide();

		 RAKEalt = RAKE;
		 RAKE = FALSE; checkrake->Uncheck();
	 }
  else
	 {
		 kanala0 = a0alt;
		 kanala1 = a1alt;
		 kanala2 = a2alt;
		 kanala3 = a3alt;
		 e1 = e1alt;
		 e2 = e2alt;
		 e3 = e3alt;

		 combodoppler->ClearList();
		 combodoppler->SetSelIndex(0);

		 editkanala0->SetRange(kanala0,-100,100,5,SPIN_HUND,kanala0);
		 editkanala1->SetRange(kanala1,-100,100,5,SPIN_HUND,kanala1);
		 editkanala2->SetRange(kanala2,-100,100,5,SPIN_HUND,kanala2);
		 editkanala3->SetRange(kanala3,-100,100,5,SPIN_HUND,kanala3);

		 edite1->SetRange(e1,1,9,1,SPIN_DIGIT,e1);
		 edite2->SetRange(e2,1,9,1,SPIN_DIGIT,e2);
		 edite3->SetRange(e3,1,9,1,SPIN_DIGIT,e3);
		 RAKE = RAKEalt;
		 if (RAKE == TRUE) checkrake->Check(); else checkrake->Uncheck();

	 }



}


int ParameterDialog::load_rayl_file()
{
  if (Initialisierung != INIT_OK) return -1;

  FILE *rayl_file;
  int i,n;
  char s[255];
  double a,quadrat;

char rayl_string[8100];


rayl_file=fopen("rayl_50.dat","rb");

		 if(rayl_file==0) /*File not in Directory*/
			return(-1);
		 rewind(rayl_file);
		 fread(rayl_string,1,(filt_len+1)*16,rayl_file);
		 fclose(rayl_file);
		 quadrat = 0;
		 for (i=0;i<=filt_len;i++)
		 {
			 for (n=0;n<16;n++) s[n]=rayl_string[n+i*16];
			 a = atof(s);
			 quadrat +=a*a;
			 rayl_array[i]=a;
		 }
		 quadrat = sqrt(quadrat);
		 if (quadrat == 0) quadrat == 1;

		 for (i=0;i<=filt_len;i++)
		 {
			 rayl_array[i] = rayl_array[i] / quadrat;
		 }



  return(1);
}



double ParameterDialog::difi_gauss1()

{
double rueck, x;
int	i;
double v = sqrt(2.0)/2;
x = gauss() * v;
rueck = rayl_array[0] * x + rayl_z1[1];
for (i = 1; i < filt_len; i++)
	rayl_z1[i] = rayl_z1[i+1] + rayl_array[i] * x;
rayl_z1[filt_len] = rayl_array[filt_len] * x;
return rueck;
}

double ParameterDialog::difi_gauss2()

{
double rueck, x;
int	i;
double v = sqrt(2.0)/2;
x = gauss() * v;
rueck = rayl_array[0] * x + rayl_z2[1];
for (i = 1; i < filt_len; i++)
	rayl_z2[i] = rayl_z2[i+1] + rayl_array[i] * x;
rayl_z2[filt_len] = rayl_array[filt_len] * x;
return rueck;
}





void ParameterDialog::combodopplerCBNSelchange ()
{
  if (Initialisierung != INIT_OK) return;

 doppler = combodoppler->GetSelIndex();
 par->folgegueltig = FALSE;

}


void ParameterDialog::Rayleigh_Parameter ()
{
}


void ParameterDialog::EvKeyDown (UINT key, UINT repeatCount, UINT flags)
{
	 if (key != VK_RETURN)    TDialog::EvKeyDown(key, repeatCount, flags);


}


void ParameterDialog::checkrakeBNClicked ()
{
  if (Initialisierung != INIT_OK) return;

	if (RAKE == TRUE) { checkrake->Uncheck(); RAKE = FALSE;}
	 else
		{ checkrake->Check(); RAKE = TRUE;}
 par->folgegueltig = FALSE;
 if (Teilnehmer != 0) checkrake->Uncheck();
}


double ParameterDialog::gauss()
{
  double y,z;

  y = prng01();
  z = prng01();
  if (z == 0) z = prng01();

  return(cos(2*M_PI*y) * sqrt(2*log(1/z)));


}





void ParameterDialog::Einstellung_Rayleigh ()
{
  if (Initialisierung != INIT_OK) return;

								  combospreiz1->SetSelIndex(2);
								  combospreiz1CBNSelchange();
								  combospreiz2->SetSelIndex(2);
								  combospreiz2CBNSelchange();
								  editbits->SetPosition(10000);
								  editwahr->SetPosition(100);
								  checkrayleigh->Check();
								  combodoppler->SetSelIndex(4);
								  combodopplerCBNSelchange();
								  editpixel->SetPosition(1);
								  wahrENChange



								  ();
								  a0alt = kanala0;
								  a1alt = kanala1;
								  a2alt = kanala2;
								  a3alt = kanala3;
								  e1alt = e1; e2alt = e2; e3alt = e3;
								  checkrayleighBNClicked ();

								  combodoppler->SetSelIndex(4);
								  combodopplerCBNSelchange();

}

