#if !defined(__prmtrdlg_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __prmtrdlg_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        prmtrdlg.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer ParameterDialog (TDialog).
*/

#include <owl\checkbox.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>

#ifndef SQRT_1_2PI
  #define SQRT_1_2PI .398942280401432686
#endif
#ifndef SQRTPI
  #define SQRTPI     1.77245385090551599
#endif
#ifndef SQRT2
  #define SQRT2      1.41421356237309505
#endif
#define JWGN 32768L


#include <owl\button.h>
#include <owl\static.h>
#include <owl\edit.h>
#include <owl\combobox.h>
#include <owl\owlpch.h>
#pragma hdrstop

#include <stdio.h>
#include <owl\dialog.h>
#include "spinedit.h"
#include "pnapp.rh"            // Definition aller Ressourcen
#include "sigdia1.h"


#define SP_PN 0
#define SP_WALSH 1
#define SP_KEINE 2

#define INIT_START 3333
#define INIT_OK 6666

//{{TDialog = ParameterDialog}}
struct ParameterDialogXfer {
//{{ParameterDialogXFER_DATA}}
    TComboBoxData  combonr1;
    TComboBoxData  combonr2;
    TComboBoxData  combospreiz1;
    TComboBoxData  combospreiz2;
    char    editkanala0[ 255 ];
    char    editkanala1[ 255 ];
    char    editkanala2[ 255 ];
    char    editkanala3[ 255 ];
    char    editrauschen[ 255 ];
    char    editbits[ 255 ];
    char    editwahr[ 255 ];
    char    editpixel[ 255 ];
    char    staticpar1[ 255 ];
    char    staticphase1[ 255 ];
    char    staticphase2[ 255 ];
    char    editphase1[ 255 ];
    char    editphase2[ 255 ];
    char    edite1[ 255 ];
    char    edite2[ 255 ];
    char    edite3[ 255 ];
    char    statickanal[ 255 ];
    char    staticpixel[ 255 ];
    char    statickanal2[ 255 ];
    char    statickanal3[ 255 ];
    char    statickanal4[ 255 ];
    char    statickanal5[ 255 ];
    TComboBoxData  combodoppler;
    BOOL    checkrayleigh;
    BOOL    checkrake;
//{{ParameterDialogXFER_DATA_END}}
};


class ParameterDialog : public TDialog {
public:
    ParameterDialog (TWindow* parent, TResId resId = Parameter, TModule* module = 0);
    virtual ~ParameterDialog ();


public:
    int Initialisierung;
    ParameterDialogXfer ParameterDialogData;
    ParameterDialog* par;
    ParameterDialog* par1;
    ParameterDialog* par2;
    int Parametersatz;
    int kanala0;
	 int kanala1;
	 int kanala2;
	 int kanala3;
    int e1;
    int e2;
    int e3;
    int rakelen;
	 int rauschen;
	 int bits;
    int bitst;
	 int wahr;
	 int pixel;
    int wdfbits;

    int laenge;
    int laenge1;
    int laenge2;

    BOOL folgegueltig;
    int* folge;
    int* folge15q;
    int* folge15i;
    int* folge1;
    int* folge2;
    int signallaenge;
    int Teilnehmer;
    BOOL teilnaktiv;
    int ScrollPos;
    int AnzTeilnehmer;

    int walshlaenge[7];
    int walshgrad1;

    int multianf;
    int multiend;

    BOOL rayleigh;
    int doppler;
    double rayl_array[510];
    double rayl_z1[505];
    double rayl_z2[505];
    float* rayl_fakt[3];
    double gauss();

    double sigmam1;
    double sigmam2;

    int a0alt;
    int a1alt;
    int a2alt;
    int a3alt;
    int e1alt;
    int e2alt;
    int e3alt;

    BOOL RAKE;
    BOOL RAKEalt;
    BOOL altuebernehmen;

    LONG* SignalWDF[2];
    LONG SignalWDFmin;
    LONG SignalWDFmax;

struct pnlistestruct { char pnstr[18];
                       LONG nr;
                       int grad;
                       int laenge;
                       int phase;
                       BOOL Max;
                     } pnliste1[300],pnliste2[300];


typedef struct { int* folge;
                 int  laenge;
                 int  pixel;
                 int  datenbits;
                 int  min;
                 int  max;
               } Signalstruct;

    Signalstruct Signal[20];


protected:
    int pnlistemax;
	 int phase1;
	 int phase2;

	 int spreiz1;
    int spreiz2;
    int spreiz1old;
    int spreiz2old;
	 int sfolge1;
    int sfolge2;

	 int folgsel1;
    int folgsel2;
    int pnfolge1;
    int pnfolge2;
    int walshgrad2;
    int walshnr1[7];
    int walshnr2[7];
    int Walshfolge[64][64];
    void CmOk();
    int wahrinit;
    int pixelmin;

public:
    void ParameterUpdate ();
double wgn(double sigmax);

int load_rayl_file();
double difi_gauss1();
double difi_gauss2();


/* Laden der Gauss-Datei */
int load_wgn_file(char *gauss_file);

/* Normieren des Gauss-Arrays */
void norm_wgn_array(double sigma);

/* Erzeugen der Gauss-Datei */
int create_wgn_file(void);

/* Verwuerfeln des Gauss-Arrays */
int scramble_array(char *gauss_file);

/* Speicherfreigabe */
unsigned long res_wgn(void);


float *wgn_array;

unsigned t_wgn;


double prng01(void);

double phi(double z);

double inv_phi(double q);

long file_size(FILE *stream);


//{{ParameterDialogVIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
    virtual void Paint (TDC& dc, BOOL erase, TRect& rect);
    virtual UINT Transfer (void* buffer, TTransferDirection direction);
    virtual BOOL CanClose ();
//{{ParameterDialogVIRTUAL_END}}

//{{ParameterDialogRSP_TBL_BEGIN}}
protected:
    void WieSatz2BNClicked ();
    void EvMouseMove (UINT modKeys, TPoint& point);
    void PNListeGenerierung();
    int  PNGenerierung(LONG,int,int,int);
    void WalshGenerierung();
    void PNListeAdd(int,LONG,LONG,int);
    void combonr1CBNSelchange ();
    void combonr2CBNSelchange ();
    void combospreiz1CBNSelchange ();
    void combospreiz2CBNSelchange ();
    void EvLButtonDblClk (UINT modKeys, TPoint& point);
    void editphase1ENChange ();
    void editphase2ENChange ();
    void editpixelENChange ();
    void bitsENChange ();
    void wahrENChange ();
    void editkanala0ENChange ();
    void editkanala1ENChange ();
    void editkanala2ENChange ();
    void editkanala3ENChange ();
    void editkanalrauschenENChange ();
    void edite1ENChange ();
    void edite2ENChange ();
    void edite3ENChange ();
    void combodopplerCBNEditchange ();
    void checkrayleighBNClicked ();
    void combodopplerCBNSelchange ();
    void Rayleigh_Parameter ();
    void EvKeyDown (UINT key, UINT repeatCount, UINT flags);
    void checkrakeBNClicked ();
    void Einstellung_Rayleigh ();
//{{ParameterDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(ParameterDialog);

//{{ParameterDialogXFER_DEF}}
protected:
    TComboBox *combonr1;
    TComboBox *combonr2;
public:    TComboBox *combospreiz1;
protected:
    TComboBox *combospreiz2;
    Spinedit *editkanala0;
    Spinedit *editkanala1;
    Spinedit *editkanala2;
    Spinedit *editkanala3;
    Spinedit *editrauschen;
    Spinedit *editbits;
    Spinedit *editwahr;
    Spinedit *editpixel;
    TStatic *staticpar1;
    TStatic *staticphase1;
    TStatic *staticphase2;
    Spinedit *editphase1;
    Spinedit *editphase2;
    TButton *buttonwiesatz2;
    Spinedit *edite1;
    Spinedit *edite2;
    Spinedit *edite3;
    TStatic *statickanal;
    TStatic *staticpixel;
    TStatic *statickanal2;
    TStatic *statickanal3;
    TStatic *statickanal4;
    TStatic *statickanal5;
    TComboBox *combodoppler;
    TCheckBox *checkrayleigh;
    TCheckBox *checkrake;

//{{ParameterDialogXFER_DEF_END}}
};    //{{ParameterDialog}}


#endif                                      // __prmtrdlg_h

