/*  Projekt CDMA
Copyright  1995

	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        sgnlhptd.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von SignalHauptDialog (TDialog).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "sgnlhptd.h"


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(SignalHauptDialog, TDialog)
//{{SignalHauptDialogRSP_TBL_BEGIN}}
	 EV_WM_LBUTTONDBLCLK,
	 EV_WM_PAINT,
    EV_BN_CLICKED(IDC_CHECKTRACE, checktraceBNClicked),
//{{SignalHauptDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{SignalHauptDialog Implementation}}


static SignalHauptDialogXfer SignalHauptDialogData;

SignalHauptDialog::SignalHauptDialog (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
//{{SignalHauptDialogXFER_USE}}
    staticsignal = new TStatic(this, ID_STATICSIGNAL, 255);
    staticxwert = new TStatic(this, ID_STATICXWERT, 255);
    checktrace = new TCheckBox(this, IDC_CHECKTRACE, 0);

    SetTransferBuffer(&SignalHauptDialogData);
//{{SignalHauptDialogXFER_USE_END}}

	 // EINFUEGEN>> Ihren Konstruktor-Code fuegen Sie hier ein
	  //		 Attr.Param |= WS_MAXIMIZE;
}


SignalHauptDialog::~SignalHauptDialog ()
{
	 Destroy();

}


void SignalHauptDialog::SetupWindow ()
{
	 TDialog::SetupWindow();
	 checktrace->Check();
	 trace=TRUE;
	// ShowWindow(SW_SHOWMAXIMIZED);
	//Fenster();
}


void SignalHauptDialog::EvLButtonDblClk (UINT modKeys, TPoint& point)
{
	 TDialog::EvLButtonDblClk(modKeys, point);

	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein
//	 sig->Execute();
}

void SignalHauptDialog::Fenster()
{


	int signal = sig->signal;

	int pixel=par->Signal[signal].pixel;
	int laenge = par->Signal[signal].laenge;

	int folglen1=par->laenge1;
	int datenbits = par->Signal[signal].datenbits;

	int memwidth = pixel * laenge;




	 TClientDC dc(*this);
	 TRect rcc = GetClientRect();
	 bitmap =  new TBitmap(dc,memwidth,rcc.Height(),FALSE);
	 bitexist = TRUE;
	 TMemoryDC memdc(dc);
	 memdc.SelectObject(*bitmap);

	 TSize Grid(pixel,pixel);
	 dc.FillRect(rcc,TBrush(TColor::White));
/*	 for (int i = 0; i < rcc.bottom; i += Grid.cy)
		  for (int j = 0; j < rcc.right; j += Grid.cx)
				memdc.SetPixel(j,i,RGB(0,0,0));
*/
	 struct sigstruct { int l,r,l0,r0;
							  float min,max;
							} sigpar;

	 sigpar.l=0;
	 sigpar.r=10;
	 sigpar.l0=0;
	 sigpar.r0=laenge;
	 int min=par->Signal[signal].min;
	 int max=par->Signal[signal].max;

	 sigpar.min = min - (max-min)*0.2;
	 sigpar.max = max + (max-min)*0.25;


	 LONG y,xf;
	 float yp;
	 LONG ymax = rcc.Height();
	 LONG xmax = memwidth;
	 TPen pn(RGB(0,0,0),1,PS_SOLID);
	 dc.SelectObject(pn);


	 for( int x=0;x<xmax;x++)
		{
		  xf = x * (sigpar.r0-sigpar.l0) / xmax;
		  yp = ymax - ((par->Signal[signal].folge[xf]-sigpar.min) * ymax / (sigpar.max-sigpar.min));

		  dc.LineTo(x-1,yp);
		  dc.LineTo(x,yp);

		}



	 char s[255];
	 wsprintf(s,"%4d:%4d,%3d",xmax,ymax,yp);
//	 St_Parameter1->SetText(s);


	 memdc.RestoreBitmap();
	 Invalidate();


}

void SignalHauptDialog::EvPaint ()
{
	 TDialog::EvPaint();


}


void SignalHauptDialog::Paint (TDC& dc, BOOL erase, TRect& rect)
{
	 TDialog::Paint(dc, erase, rect);

/*		  TMemoryDC memdc(dc);
		  memdc.SelectObject(*bitmap);
		  dc.BitBlt(rect.left,rect.top,rect.Width(),rect.Height(),
						memdc,rect.left,rect.top,SRCCOPY);
		  memdc.RestoreBitmap();
*/
}




void SignalHauptDialog::checktraceBNClicked ()
{
 char s[255];
 strcpy(s,"  ");
if (checktrace->GetCheck()) trace = TRUE; else trace = FALSE;
if (trace == TRUE) if (par->Parametersatz == 1) Parent->Transfer(s,11);
if (trace == TRUE) if (par->Parametersatz == 2) Parent->Transfer(s,12);
}

