#if !defined(__sigdia1_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __sigdia1_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        sigdia1.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer Sigdia1 (TDialog).
*/

#include <owl\edit.h>
#include <owl\checkbox.h>
#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\dialog.h>

#include "pnapp.rh"            // Definition aller Ressourcen


// Definition der Krzel der einzelnen Signale
#define SIG_Q     0
#define SIG_X1    1
#define SIG_X2    2
#define SIG_S     3
#define SIG_E1    4
#define SIG_N     5
#define SIG_E2    6
#define SIG_E     7
#define SIG_R     8
#define SIG_XTKR  9
#define SIG_B    10
#define SIG_D    11
#define SIG_V    12
#define SIG_WDF  13
#define SIG_X12  14
//{{TDialog = Sigdia1}}
struct Sigdia1Xfer {
//{{Sigdia1XFER_DATA}}
    BOOL    Schalter1;
    char    editpixel[ 255 ];
    char    editsignal[ 255 ];
    BOOL    checkpar1;
    BOOL    checkpar2;
//{{Sigdia1XFER_DATA_END}}
};
      

class Sigdia1 : public TDialog {
public:
    Sigdia1 (TWindow* parent, TResId resId = IDD_SIGD1, TModule* module = 0);
    virtual ~Sigdia1 ();


public:

    int signal;
    int pixel;
    char ssignal[255];
    int Parametersatz;

//{{Sigdia1XFER_DEF}}
protected:
    TCheckBox *Schalter1;
    TEdit *editpixel;
    TEdit *editsignal;
    char s[255];
    TCheckBox *checkpar1;
    TCheckBox *checkpar2;
    
//{{Sigdia1XFER_DEF_END}}

//{{Sigdia1VIRTUAL_BEGIN}}
public:
    virtual BOOL CanClose ();
    virtual void SetupWindow ();
//{{Sigdia1VIRTUAL_END}}

//{{Sigdia1RSP_TBL_BEGIN}}
protected:
    void PIXELENChange ();
    void SIG_B_BNClicked ();
    void SIG_D_BNClicked ();
    void SIG_E_BNClicked ();
    void SIG_N_BNClicked ();
    void SIG_Q_BNClicked ();
    void SIG_R_BNClicked ();
    void SIG_S_BNClicked ();
    void SIG_V_BNClicked ();
    void SIG_X1_BNClicked ();
    void SIG_XTKR_BNClicked ();
    void SIG_E1_BNClicked ();
    void SIG_E2_BNClicked ();
    void X2_BNClicked ();
    void checkpar1BNClicked ();
    void checkpar2BNClicked ();
//{{Sigdia1RSP_TBL_END}}
DECLARE_RESPONSE_TABLE(Sigdia1);
};    //{{Sigdia1}}


#endif                                      // __sigdia1_h

