/*  Projekt CDMA
	 Copyright  1995
             
	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        sigwin.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von SigWin (TWindow).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "sigwin.h"
#include <owl\scroller.h>


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(SigWin, TWindow)
//{{SigWinRSP_TBL_BEGIN}}
	 EV_WM_LBUTTONDOWN,
	 EV_WM_SIZE,
	 EV_COMMAND(CM_SIGNALFENSTER, Fenster),
	 EV_WM_LBUTTONDBLCLK,
	 EV_WM_MOUSEMOVE,
    EV_WM_HSCROLL,
    EV_WM_RBUTTONDOWN,
//{{SigWinRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{SigWin Implementation}}


SigWin::SigWin (TWindow* parent, const char far* title, TModule* module):
	 TWindow(parent, title, module)
{
	 // Hintergrundfarbe des Fensters aendern
	 SetBkgndColor(RGB(0xc0, 0xc0, 0xc0));
		 Attr.Style |= WS_HSCROLL | WS_VISIBLE;
setupzaehler = 0;
fensterzaehler = 0;
	 TClientDC dc(*this);
	 bitmap =  new TBitmap(dc,100,28,TRUE);
	 Scroller = new TScroller(this, 20,0,310,0);
    sigdia=new SignalHauptDialog(this);

}


SigWin::~SigWin ()
{
	 if (bitmap) delete bitmap;
	 Destroy();


}


void SigWin::EvLButtonDown (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDown(modKeys, point);

}


void SigWin::SetupWindow ()
{
	 TWindow::SetupWindow();
		  char st[255];
		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();
setupzaehler++;


	 string s;
	 bitexist = FALSE;

	 TClientDC dc(*this);
	 TRect rcc = GetClientRect();

	 if (Parametersatz == 1) par = par1;
	 if (Parametersatz == 2) par = par2;
    sigdia->par1=par1;
    sigdia->par2=par2;
    sigdia->par = par;
	 sigdia->Create();

	 sig = new Sigdia1(this);
	 Titelsetzen();
}




void SigWin::Paint (TDC& dc, BOOL erase, TRect& rc)
{
SetCursor(0,IDC_WAIT);

	 TWindow::Paint(dc, erase, rc);


		  TMemoryDC memdc(dc);
		  memdc.SelectObject(*bitmap);

		  dc.BitBlt(0,31,rcc.Width(),rcc.Height(),
						memdc,0,0,SRCCOPY);
		  memdc.RestoreBitmap();
sigdia->MoveWindow(0,0,rc.right+pixel,30,TRUE);
char s[255];
char s1[255];
int t = Scroller->XPos;
sprintf(s,"%d) = %2.2f  ",t,(float)par->Signal[signal].folge[t+20]/1000);
//sprintf(s,"%d %d %d %d",rc.left,rc.top,rc.right,rc.bottom);
if ((signal==SIG_X1)||(signal==SIG_X2)) sprintf(s,"%d) = %d  ",t,(float)par->Signal[signal].folge[t+20]);
if (signal == SIG_D) sprintf(s,"%d) = %1.3f  ",t,(float)par->Signal[signal].folge[t+20]/1000);
strcpy(s1,sst);
strcat(s1,s);
sigdia->staticxwert->SetText(s1);

SetCursor(0,IDC_ARROW);

}


void SigWin::EvSize (UINT sizeType, TSize& size)
{
	 TWindow::EvSize(sizeType, size);
    TRect rc;
	 GetWindowRect(rc);


	 rc = GetWindowRect();

	 Fenster();
}


void SigWin::Fenster ()
{
	char ssigtext[255];
	fensterzaehler++;
	if (fensterzaehler<=2)return;

HCURSOR WaitCursor;
WaitCursor = ::LoadCursor(GetApplication()->GetMainWindow()->GetModule()->GetInstance(), MAKEINTRESOURCE(CURSOR_1));
::SetCursor(WaitCursor);

	 rcc = GetClientRect();
	int scr = par->Signal[signal].laenge - rcc.Width()/par->pixel;
	if (scr < 0) scr = 0;

	 switch(signal)
	 {
		case SIG_Q  : strcpy(ssigtext,"Quellensignal"); strcpy(sst,"q("); break;
		case SIG_X1 : strcpy(ssigtext,"Spreizfolge 1"); strcpy(sst,"c1(");  break;
		case SIG_X2 : strcpy(ssigtext,"Spreizfolge 2"); strcpy(sst,"c2(");  break;
		case SIG_S  : strcpy(ssigtext,"Sendesignal"); strcpy(sst,"s(");  break;
		case SIG_N : strcpy(ssigtext,"Rauschen"); strcpy(sst,"n(");  break;
		case SIG_E1 : strcpy(ssigtext,"Kanalausgang"); strcpy(sst,"k(");  break;
		case SIG_E2 : strcpy(ssigtext,"Empfang andere Teilnehmer"); strcpy(sst,"i(");  break;
		case SIG_E  : strcpy(ssigtext,"Empfangssignal"); strcpy(sst,"r(");  break;
		case SIG_R : strcpy(ssigtext,"Ausgang vom RAKE"); strcpy(sst,"m(");  break;
		case SIG_XTKR : strcpy(ssigtext,"Entspreizfolge"); strcpy(sst,"c(");  break;
		case SIG_B : strcpy(ssigtext,"Entspreiztes Signal"); strcpy(sst,"b(");  break;
		case SIG_D : strcpy(ssigtext,"Ausgang des Integrators"); strcpy(sst,"d(");  break;
		case SIG_V : strcpy(ssigtext,"Sinkensignal"); strcpy(sst,"v(");  break;
		default: { strcpy(ssigtext,"X(t)"); strcpy(sst,"v(");}
	 }
   sigdia->staticsignal->SetText(ssigtext);

	sig->signal=signal;
	Scroller->SetUnits(par->pixel,0);
	Scroller->SetRange(scr,0);
	pixel=par->Signal[signal].pixel;
	int laenge = par->Signal[signal].laenge;

	int folglen1=par->laenge1;
	int datenbits = par->Signal[signal].datenbits;

	int memwidth = pixel * laenge;




	 TClientDC dc(*this);
	 rcc.right = memwidth;
	 if (bitmap) delete bitmap;
	 bitmap =  new TBitmap(dc,memwidth,rcc.Height()-30,FALSE);
	 bitexist = TRUE;
	 TMemoryDC memdc(dc);
	 memdc.SelectObject(*bitmap);

	 TSize Grid(pixel,pixel);
	 memdc.FillRect(rcc,TBrush(TColor::White));


	 struct sigstruct { int l,r,l0,r0;
							  float min,max;
							} sigpar;

	 sigpar.l=0;
	 sigpar.r=10;
	 sigpar.l0=0;
	 sigpar.r0=laenge;
	 int min=par->Signal[signal].min;
	 int max=par->Signal[signal].max;

	 sigpar.min = min - (max-min)*0.2;
	 sigpar.max = max + (max-min)*0.25;

	 int i;
	 LONG y,xf;
	 float yp;
	 LONG ymax = rcc.Height()-30;
	 LONG xmax = memwidth;

LONG yp0,yp1;
LONG x;
int x1,x2,y1,y2;
x1=par->laenge1*pixel;
if ((signal == SIG_S) || (signal == SIG_E1))
  {
	 TBrush br(RGB(164,200,240));

	 yp0=ymax+sigpar.min*ymax/(sigpar.max-sigpar.min);
	 for( i=0;i<par->Signal[SIG_Q].laenge;i++)
		{

		  yp1=rcc.top;
		  if (par->Signal[SIG_Q].folge[i+20]<0)yp1=rcc.bottom;

		  memdc.FillRect(x1*i+1,yp0,x1*(i+1),yp1,br);

		}


  }
 if (pixel > 1)
	 for (i = 0; i < rcc.bottom; i += Grid.cy)
		  for (int j = 0; j < rcc.right; j += Grid.cx)
				memdc.SetPixel(j,i,RGB(0,0,0));

if ((signal>=SIG_R)&&(signal<=SIG_D))
  {
			 TPen pn0(RGB(0,128,0),1,PS_DASH);
			 memdc.SelectObject(pn0);
			 for (int j = 0; j < rcc.right; j += pixel*par->laenge1)
				{
				  memdc.MoveTo(j+par->rakelen*pixel,0);
				  memdc.LineTo(j+par->rakelen*pixel,rcc.bottom);
				}

  }



	 for (i=0;i<500;i++) look[i]=par->Signal[signal].folge[i+20];


  yp = ymax - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min));
			 TPen pn4(RGB(0,0,200),1,PS_DOT);
			 memdc.SelectObject(pn4);
			 memdc.MoveTo(0,yp);
			 memdc.LineTo(rcc.right,yp);

	 TPen pn1(RGB(0,0,0),1,PS_SOLID);
	 TPen pn2(RGB(255,0,0),1,PS_SOLID);
 if (par->Parametersatz == 1) memdc.SelectObject(pn1);
	else  memdc.SelectObject(pn2);


  yp = ymax - ((par->Signal[signal].folge[20]-sigpar.min) * ymax / (sigpar.max-sigpar.min));

  memdc.MoveTo(0,yp);

	 for(x=0;x<xmax;x++)
		{
		  xf = x * laenge / xmax;
		  yp = ymax - ((par->Signal[signal].folge[xf+20]-sigpar.min) * ymax / (sigpar.max-sigpar.min));

		  memdc.LineTo(x,yp);
		  memdc.LineTo(x+1,yp);

		}


	 memdc.RestoreBitmap();
	 Invalidate();

}




void SigWin::EvLButtonDblClk (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDblClk(modKeys, point);

	 sig->Parametersatz = Parametersatz;

	 if (sig->Execute() == IDOK)
		{
		  signal=sig->signal;
		  Parametersatz = sig->Parametersatz;
		  if (Parametersatz == 1) par = par1;
		  if (Parametersatz == 2) par = par2;
		  sigdia->par1=par1;
		  sigdia->par2=par2;
		  sigdia->par = par;
		}

	 Titelsetzen();
	 Fenster();

}

void SigWin::Titelsetzen()
{
 char s[255];
	 switch(signal)
	 {
		case SIG_Q  : strcpy(sig->ssignal,"q(t)"); break;
		case SIG_X1 : strcpy(sig->ssignal,"c1(t)"); break;
		case SIG_X2 : strcpy(sig->ssignal,"c2(t)"); break;
		case SIG_S  : strcpy(sig->ssignal,"s(t)"); break;
		case SIG_N : strcpy(sig->ssignal,"n(t)"); break;
		case SIG_E1 : strcpy(sig->ssignal,"k(t)"); break;
		case SIG_E2 : strcpy(sig->ssignal,"i(t)"); break;
		case SIG_E  : strcpy(sig->ssignal,"r(t)"); break;
		case SIG_R : strcpy(sig->ssignal,"m(t)"); break;
		case SIG_XTKR : strcpy(sig->ssignal,"c(t)"); break;
		case SIG_B : strcpy(sig->ssignal,"b(t)"); break;
		case SIG_D : strcpy(sig->ssignal,"d(t)"); break;
		case SIG_V : strcpy(sig->ssignal,"v(t)"); break;
	 }
	 strcpy(title,"Signal ");
	 lstrcat(title,sig->ssignal);
if (Parametersatz==1)	 strcpy(s," Satz 1");
 else    strcpy(s," Satz 2");
	 lstrcat(title,s);
	 Parent->SetWindowText(title);

}


void SigWin::EvMouseMove (UINT modKeys, TPoint& point)
{
 char s[255];
 strcpy(s,"  ");
	 TWindow::EvMouseMove(modKeys, point);
char s1[255];
int t = Scroller->XPos+point.x/pixel;
if (t>=par->Signal[signal].laenge)t=par->Signal[signal].laenge-1;
sprintf(s,"%d) = %2.2f  ",t,(float)par->Signal[signal].folge[t+20]/1000);
if ((signal==SIG_X1)||(signal==SIG_X2)||(signal==SIG_XTKR))
		 sprintf(s,"%d) = %d  ",t,par->Signal[signal].folge[t+20]);
if (signal == SIG_D) sprintf(s,"%d) = %1.3f  ",t,(float)par->Signal[signal].folge[t+20]/1000);
strcpy(s1,sst);
strcat(s1,s);
sigdia->staticxwert->SetText(s1);


		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();

		  if (par1->folgegueltig == FALSE) client->Transfer(s,5);
		  if (par2->folgegueltig == FALSE) client->Transfer(s,6);

}





UINT SigWin::Transfer (void* buffer, TTransferDirection direction)
{
	 UINT result;

	 if (direction <= 2 ) result = TWindow::Transfer(buffer, direction);
	 else
		{
			if (direction == 3)
									 {
										if (Parametersatz == 1)
																		{
																		  Fenster();
																		}
									 }

			if (direction == 4)
									 {
										if (Parametersatz == 2)
																		{
																		  Fenster();
																		}
									 }

int t = Scroller->XPos;
int p = par->ScrollPos;
if ((signal==SIG_Q) || (signal == SIG_V)) p=p/par->laenge1;
			if (direction == 11)
									 {
										if (Parametersatz == 1)
																		{
																		  if (t != p)
                                                         if (sigdia->trace == TRUE) Scroller->ScrollTo(p,0);
																		}
									 }

			if (direction == 12)
									 {
										if (Parametersatz == 2)
																		{
																		  if (t != p)
                                                         if (sigdia->trace == TRUE) Scroller->ScrollTo(p,0);
																		}
									 }

		}
	 return result;
}



void SigWin::EvHScroll (UINT scrollCode, UINT thumbPos, HWND hWndCtl)
{
	 TWindow::EvHScroll(scrollCode, thumbPos, hWndCtl);
int t = Scroller->XPos;
if ((signal==SIG_Q) || (signal == SIG_V)) t=t*par->laenge1;
int p = par->ScrollPos;
if (sigdia->trace == TRUE)
  if (t!=p) {
				 par->ScrollPos = t;
				  TApplication* app=GetApplication();
				  TFrameWindow* frame =app->GetMainWindow();
				  TWindow* client = frame->GetClientWindow();
              char s[255];
              strcpy(s,"  ");

				 if (Parametersatz == 1) client->Transfer(s,21);
				 if (Parametersatz == 2) client->Transfer(s,22);
   			 }

}


void SigWin::EvRButtonDown (UINT modKeys, TPoint& point)
{
	 TWindow::EvRButtonDown(modKeys, point);

    EvLButtonDblClk(modKeys, point);

}

