/*  Projekt CDMA
	 Copyright  1995

	 DATEI:        spinedit.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von Spinedit (TEdit).
*/

#include <owl\owlpch.h>
// #include <owl\validate.h>

#pragma hdrstop

#include "spinedit.h"
#include <stdio.h>


DEFINE_RESPONSE_TABLE2(Spinedit, TEdit, TStatic)
//{{SpineditRSP_TBL_BEGIN}}
	 EV_WM_KEYUP,
	 EV_WM_VSCROLL,
//{{SpineditRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{Spinedit Implementation}}

///////////////////////////////////////////////////////////////////////////
// Ctor
// Initialisiert das Editfeld und die internen Variablen fr den
// Bereich und die aktuelle Position.
// LineMagnitude wird auf 1, PageMagnitude wird auf 10 gesetzt.
Spinedit::Spinedit(TWindow *parent, int id,UINT textLen, TModule *module)
	 : TEdit(parent,id,textLen,module)
{
	 Attr.Style &= ~ES_LEFT;
	 Attr.Style |= ES_READONLY | ES_RIGHT | WS_VSCROLL;
	 Attr.Style &= ~WS_HSCROLL;
	 Posadr = NULL;
	 m_Min = 0;
	 m_Max = 100;
	 m_Pos = 0;
	 LineMag = 1;
	 PageMag = 10;

}



Spinedit::~Spinedit ()
{
	 Destroy();

	 // EINFUEGEN>> Ihren Destruktor-Code fuegen Sie hier ein

}

/*///////////////////////////////////////////////////////////////////////////
// Ctor
// Initialisiert das Editfeld und die internen Variablen fr den
// Bereich und die aktuelle Position.
// LineMagnitude wird auf 1, PageMagnitude wird auf 10 gesetzt.
Spinedit::Spinedit(TWindow *parent, int resourceId,
							UINT textLen, TModule *module)
	 : TEdit(parent,resourceId,textLen,module)
{
	 m_Min = 0;
	 m_Max = 100;
	 m_Pos = 0;
	 LineMag = 1;
	 PageMag = 10;
}

*/
///////////////////////////////////////////////////////////////////////////
// Zeigt initial die aktuelle Position an
void Spinedit::SetupWindow()
{
	 TEdit::SetupWindow();
	 HideText=TRUE;
	 // TEdit::SetValidator(new TFilterValidator("1234567890."));
	 SetNewPos(m_Pos);
}

///////////////////////////////////////////////////////////////////////////
// Setzt eine neue Position fr das Editfeld. Die bergebene Position
// wird automatisch auf den durch Min und Max vorgegebenen Bereich
// beschrnkt.
void Spinedit::SetNewPos(int NewPos)
{
	 char buf[255];
	 m_Pos = NewPos;
	 if (m_Pos < m_Min) m_Pos = m_Min;
	 if (m_Pos > m_Max) m_Pos = m_Max;
	 if (Posadr != NULL) *Posadr = m_Pos;

	 int x=m_Pos;
	 char c = ' ';
	 int v=1;

	 if (x<0) { c='-';
					v = -1;
				 }
if (Art == SPIN_HUND)
		 sprintf(buf,"% 2.2f ",(float)x/100);
if (Art == SPIN_ZEHNHUND)
		 sprintf(buf,"%1.2f",(float)x/100);
if (Art == SPIN_ZEHN)
		 {
		  sprintf(buf," % 2.1f",(float)x/10);
		  if (x == 100) strcpy(buf,"10.0");
		  if (x == 105) strcpy(buf,"20.0");
		  if (x == 110) strcpy(buf,"30.0");
		  if (x == 115) strcpy(buf,"40.0");
		  if (x == 120) strcpy(buf,"50.0");
		  if (x == 125) strcpy(buf,"Max.");
		 }
if (Art == SPIN_EINS)
		 wsprintf(buf,"%4d",x);
if (Art == SPIN_DIGIT)
		 wsprintf(buf,"%1d",x);
if (Art == SPIN_OKTAL)
		 sprintf(buf,"%5o",x);


	 if (HideText==FALSE) SetText(buf);
	 else SetText("   ");
}

///////////////////////////////////////////////////////////////////////////
// Behandelt Nachrichten des Scrollbars. Diese werden in die entsprechenden
// Positionsnderungen umgesetzt.
void Spinedit::EvVScroll(UINT scrollCode, UINT thumbPos, HWND /*hWndCtl*/)
{
	 switch (scrollCode)
	 {
		  case SB_LINEUP          : SetNewPos(m_Pos+LineMag);
											 break;
		  case SB_LINEDOWN        : SetNewPos(m_Pos-LineMag);
											 break;
		  case SB_PAGEUP          : SetNewPos(m_Pos+PageMag);
											 break;
		  case SB_PAGEDOWN        : SetNewPos(m_Pos-PageMag);
											 break;
		  case SB_TOP             : SetNewPos(m_Min);
											 break;
		  case SB_BOTTOM          : SetNewPos(m_Max);
											 break;
		  case SB_THUMBPOSITION   : SetNewPos(thumbPos);
											 break;
	 }

	 if (GetFocus() != HWindow) SetFocus();
}

void Spinedit::Hide()
{ HideText = TRUE;
  SetNewPos(0);
}

//void Spinedit::TextInput()
//{
//	 char buf[255];
//	 int x = 0;
//	 int e = 0;
//	 int i = 0;
//	 TStatic::GetText(buf,6);
	 // TStatic::Clear();

//	 while(buf[i] != '\0') {
//		if (buf[i] < '0' || buf[i] > '9') buf[i] = ' ';
//		i++;
//	 }
//	 i = 0;

//	 while(buf[i] != '\0') {
//		if (buf[i]!= ' ') {
//			x = buf[i] - '0';
//			e = e * 10 + x;
//		}
//		i++;
//	 }
//	 m_Pos = e;
 //	 if (Posadr != NULL) *Posadr = e;

	 // sprintf(buf,"%d",e);
	 //TStatic::SetText(buf);
	 // SetNewPos(e);

//}
///////////////////////////////////////////////////////////////////////////
// Behandelt eintreffende WM_KEYDOWN-Nachrichten und setzt sie in
// entsprechende Positionsnderungen um.
void Spinedit::EvKeyDown(UINT key, UINT repeatCount, UINT flags)
{
	 switch (key) {
		  case VK_UP              : SetNewPos(m_Pos+LineMag);
											 break;
		  case VK_DOWN            : SetNewPos(m_Pos-LineMag);
											 break;
		  case VK_PRIOR           : SetNewPos(m_Pos+PageMag);
											 break;
		  case VK_NEXT            : SetNewPos(m_Pos-PageMag);
											 break;
		  case VK_END             : SetNewPos(m_Min);
											 break;
		  case VK_HOME            : SetNewPos(m_Max);
											 break;
		  //case VK_RETURN          : TextInput();
			//								 break;
		  //default                : TStatic::EvKeyUp(key,repeatCount,flags);
		   default                 : TEdit::SetReadOnly(TRUE);
											  			   //TextInput();
											 break;
	 }
}
//void Spinedit::EvChar(UINT key, UINT repeatCount, UINT flags)
//{

//}











