#if !defined(__spinedit_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __spinedit_h

#if !defined(__OWL_EDIT_H)
  #include <owl\edit.h>
#endif

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        spinedit.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK    _OWLCLASS
    ==========
    Klassendefinition fuer Spinedit (TEdit).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\edit.h>

#include "pnapp.rh"            // Definition aller Ressourcen

#define SPIN_HUND 1
#define SPIN_EINS 2
#define SPIN_OKTAL 3
#define SPIN_DIGIT 4
#define SPIN_ZEHN 5
#define SPIN_ZEHNHUND 6
//{{TEdit = Spinedit}}
class Spinedit : public TEdit
{
// Ctors, Dtor
public:
    Spinedit(TWindow*        parent,
              int             id,
              const char far* text,
              int x, int y, int w, int h,
              UINT            textLen = 0,
              TModule*        module = 0);

    Spinedit(TWindow *parent,
				  int resourceId,
				  UINT textLen = 0,
				  TModule *module = 0);

virtual   ~Spinedit();

//{{SpineditVIRTUAL_BEGIN}}
public:
	 virtual void SetRange (int &Pos,int Min, int Max,int mag,int Art,int pos);
    virtual void GetRange (int &Min, int &Max);
    virtual void SetPosition(int Position);
    virtual int GetPosition();
    virtual void Hide();
//{{SpineditVIRTUAL_END}}

public:
    int LineMag;
    int PageMag;
	 int *Posadr;
    BOOL HideText;
//{{SpineditRSP_TBL_BEGIN}}
protected:
	 virtual void SetupWindow();
    void EvKeyDown(UINT key, UINT repeatCount, UINT flags);
    void EvChar(UINT key, UINT repeatCount, UINT flags);

    void SetNewPos(int NewPos = 0);
	 //void TextInput();
	 
    int     m_Min;
    int     m_Max;
    int     m_Pos;
    int     Art;

    void EvVScroll (UINT scrollCode, UINT thumbPos, HWND hWndCtl);
//{{SpineditRSP_TBL_END}}

  DECLARE_RESPONSE_TABLE(Spinedit);
};

//#########################################################################
// I n l i n e s
//#########################################################################
inline void Spinedit::SetRange (int &posadr,int Min, int Max,int mag,int art,int pos)
{
    Posadr=&posadr;
    HideText = FALSE;
	 m_Min = Min;
	 m_Max = Max;
	 LineMag = mag;
    if (mag == 51) { LineMag = 1; PageMag = 50; }
	 Art = art;
	 m_Pos = pos;
	 SetNewPos(m_Pos);
}


inline void Spinedit::GetRange (int &Min, int &Max)
{
	 Min = m_Min;
	 Max = m_Max;
    *Posadr = 5;
}


inline void Spinedit::SetPosition(int Position)
{
	 if (m_Pos == Position || 0 == Position) return;
    m_Pos = Position;
    SetNewPos(m_Pos);
}


inline int Spinedit::GetPosition()
{
    return m_Pos;
}


     //{{Spinedit}}

#endif                                      // __spinedit_h





