/*  Projekt CDMA
Copyright  1995
 
    SYSTEM:       CDMA.EXE  (Application)
    DATEI:        pnsgchld.cpp
	 AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
	 Quelltextdatei fuer die Implementation von WDFChild (TMDIChild).
*/


#include <owl\owlpch.h>
#pragma hdrstop

#include "pnapp.h"
#include "wdfchild.h"

#include <stdio.h>


//{{WDFChild Implementation}}


//
// Antworttabelle fuer alle von WDFChild behandelten Botschaften /
// Befehle generieren
//
DEFINE_RESPONSE_TABLE1(WDFChild, TMDIChild)
//{{WDFChildRSP_TBL_BEGIN}}
	 EV_WM_GETMINMAXINFO,
	 EV_WM_MOUSEMOVE,
    EV_WM_SIZE,
//{{WDFChildRSP_TBL_END}}
END_RESPONSE_TABLE;


//////////////////////////////////////////////////////////
// WDFChild
// ==========
// Konstruktor/Destruktor
WDFChild::WDFChild (TMDIClient &parent, const char far *title, TWindow *clientWnd, BOOL shrinkToClient, TModule *module)
	 : TMDIChild (parent, title, clientWnd == 0 ? new TWindow(0, "") : clientWnd, shrinkToClient, module)
{
	 // EINFUEGEN>> Ihren Konstruktor-Code fuegen Sie hier ein
		 Attr.Style |= WS_BORDER | WS_CAPTION | WS_CHILD | WS_CLIPCHILDREN  | WS_MAXIMIZEBOX | WS_MINIMIZEBOX | WS_SYSMENU | WS_THICKFRAME | WS_VISIBLE;
		 Attr.W = 400;
		 Attr.H = 300;
}


WDFChild::~WDFChild ()
{
	 Destroy();

	 // EINFUEGEN>> Ihren Destruktor-Code fuegen Sie hier ein

}


//
// Paint-Routine fuer Fenster, Drucker und Druckvorschau fuer ein TEdit-Client.
//
void WDFChild::Paint (TDC&, BOOL, TRect& rect)
{
	 pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
	 if (theApp) {
		  // Paint nur beim Ausdruck und wenn etwas Druckbares vorhanden ist
		  if (theApp->Printing && theApp->Printer && !rect.IsEmpty()) {
				// pageSize fuer die Groessenberechnung verwenden. Fuer Fenster: Client-Bereich
				// fuer Drucker: DC-Dimensionen, fuer Druckvorschau: Layout-Fenster
				TSize   pageSize(rect.right - rect.left, rect.bottom - rect.top);

		  }
	 }
}


void WDFChild::EvGetMinMaxInfo (MINMAXINFO far& minmaxinfo)
{
	 pnApp *theApp = TYPESAFE_DOWNCAST(GetApplication(), pnApp);
	 if (theApp) {
		  if (theApp->Printing) {
				minmaxinfo.ptMaxSize = TPoint(32000, 32000);
				minmaxinfo.ptMaxTrackSize = TPoint(32000, 32000);
				return;
		  }
	 }
	 TMDIChild::EvGetMinMaxInfo(minmaxinfo);
}

void WDFChild::EvMouseMove (UINT modKeys, TPoint& point)
{
	 TMDIChild::EvMouseMove(modKeys, point);

	 // EINFUEGEN>> Ihren Code fuegen Sie hier ein
}


UINT WDFChild::Transfer (void* buffer, TTransferDirection direction)
{
    UINT result;
	char s[255];
	strcpy(s,"   ");
		if (direction <=2) result = TMDIChild::Transfer(buffer, direction);
	else
	  {
		  if (direction == 3)  {
										  TWindow* sigwin = GetClientWindow();
										  sigwin->Transfer(s,3);
									  }
		  if (direction == 4)  {
										  TWindow* sigwin = GetClientWindow();
										  sigwin->Transfer(s,4);
									  }

		  if (direction == 11)  {
										  TWindow* sigwin = GetClientWindow();
										  sigwin->Transfer(s,11);
									  }
		  if (direction == 12)  {
										  TWindow* sigwin = GetClientWindow();
										  sigwin->Transfer(s,12);
									  }

	  }



    return result;
}


void WDFChild::clientmessage1 ()
{
}


void WDFChild::EvSize (UINT sizeType, TSize& size)
{
	 TMDIChild::EvSize(sizeType, size);

}


void WDFChild::SetupWindow ()
{
    TMDIChild::SetupWindow();

    // EINFUEGEN>> Ihren Code fuegen Sie hier ein
}

