/*  Projekt CDMA
Copyright  1995
 
	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        wdfdial1.cpp
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
	 ==========
    Quelltextdatei fuer die Implementation von WDFDialog (TDialog).
*/

#define W(x) (x)/16000][(x)%16000
#include <owl\owlpch.h>
#pragma hdrstop

#include "wdfdial1.h"


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(WDFDialog, TDialog)
//{{WDFDialogRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDC_CHECKPAR1, checkpar1BNClicked),
	 EV_BN_CLICKED(IDC_CHECKPAR2, checkpar2BNClicked),
	 EV_BN_CLICKED(IDC_PUSHBUTTONSTART5, buttonstartBNClicked),
//{{WDFDialogRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{WDFDialog Implementation}}


static WDFDialogXfer WDFDialogData;

WDFDialog::WDFDialog (TWindow* parent, TResId resId, TModule* module):
    TDialog(parent, resId, module)
{
	 Initialisierung = INIT_START;

//{{WDFDialogXFER_USE}}
	 editdurchlauf = new Spinedit(this, IDC_EDITDURCHLAUF, 255);
	 staticbitsprolauf = new TStatic(this, IDT_BITSPROLAUF, 255);
	 staticfehler = new TStatic(this, IDT_FEHLER, 255);
	 staticwdfwert = new TStatic(this, IDT_WDFWERT, 255);
    checkpar1 = new TCheckBox(this, IDC_CHECKPAR1, 0);
	 checkpar2 = new TCheckBox(this, IDC_CHECKPAR2, 0);
    staticstreuung = new TStatic(this, IDT_STREUUNG, 255);
    staticmittel = new TStatic(this, IDT_WDF_MITTEL, 255);

	 SetTransferBuffer(&WDFDialogData);
//{{WDFDialogXFER_USE_END}}
durchlaeufe = 20;
wahrlistealt = new int[32000];
nlistealt = new int[32000];
e2listealt = new int[32000];


}


WDFDialog::~WDFDialog ()
{
  if (e2listealt) delete e2listealt;
  if (nlistealt) delete nlistealt;
  if (wahrlistealt) delete wahrlistealt;

	 Destroy();


}


void WDFDialog::checkpar1BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

if (checkpar1->GetCheck() == BF_CHECKED) {
														  Parametersatz = 1;
														  checkpar2->Uncheck();
													  }
												else {  Parametersatz = 2;
														  checkpar2->Check();
														  checkpar1->Uncheck();
													  }

eindurchlauf=TRUE;
wdfgueltig=FALSE;
Parent->Invalidate();
UpdateWindow();

//xxbuttonstartBNClicked();

}


void WDFDialog::checkpar2BNClicked ()
{
  if (Initialisierung != INIT_OK) return;

if (checkpar2->GetCheck() == BF_CHECKED) {
														  Parametersatz = 2;
														  checkpar1->Uncheck();
													  }
												else {  Parametersatz = 1;
														  checkpar1->Check();
														  checkpar2->Uncheck();
													  }

eindurchlauf=TRUE;
wdfgueltig=FALSE;
Parent->Invalidate();

UpdateWindow();

buttonstartBNClicked();

}


void WDFDialog::buttonstartBNClicked ()
{
  if (Initialisierung != INIT_OK) return;

HCURSOR WaitCursor;
WaitCursor = ::LoadCursor(GetApplication()->GetMainWindow()->GetModule()->GetInstance(), MAKEINTRESOURCE(CURSOR_1));
::SetCursor(WaitCursor);

int i;
if (Parametersatz == 1) par = par1; else par = par2;
if (par->laenge1 == 0) return;

for (i=0;i<30000;i++) {
								 wahrlistealt[i] = par->Signal[SIG_Q].folge[i];
								 nlistealt[i] = par->Signal[SIG_N].folge[i];
								 e2listealt[i] = par->Signal[SIG_E2].folge[i];
							 }


double sigmam1=0;
double sigmam2=0;
bitsprodurchlauf = 32000/par->laenge1;
if (bitsprodurchlauf > 1000) bitsprodurchlauf -= bitsprodurchlauf % 1000;
if (bitsprodurchlauf > 500) bitsprodurchlauf -= bitsprodurchlauf % 100;
int durchlaufges = durchlaeufe;
editdurchlauf->SetPosition(1);

par->wdfbits=bitsprodurchlauf;
par->ParameterUpdate();
int look[1000];

LONG x;
char s[255];
	 sprintf(s,"%d",bitsprodurchlauf);
	 staticbitsprolauf->SetText(s);
	 UpdateWindow();

fehlerbits=0;
//for (i=0;i<1000;i++)look[i]=par->Signal[SIG_WDF].folge[i];
double m1,m2;
LONG k;
int d;
int dakt;
LONG all;
dakt = durchlaufges;
if (eindurchlauf==TRUE) dakt = 1;
wdfmin=par->SignalWDFmin;
wdfmax=par->SignalWDFmax;

if (wdfmax == wdfmin) {wdfmax += 1; wdfmin -= 1; }
wdfmin=wdfmin-abs(wdfmin)*0.1;
wdfmax=wdfmax+abs(wdfmax)*0.1;
	 staticwdfwert->SetText("  ");
	 UpdateWindow();

if (wdfmax-wdfmin==0) return;
wdflaenge = (LONG)dakt * par->Signal[SIG_WDF].laenge;
wdfnull = (LONG)(-wdfmin)  * (memwidth-1) / (wdfmax-wdfmin);
for (i=0;i<memwidth;i++)wdfx[i]=0;
double kf;


for (d=1;d<=dakt;d++)
  {
//     if (par->Signal[SIG_WDF].laenge != bitsprodurchlauf) MessageBox("Fehler","bitsprodurchlauf",MB_OK);
	 for (i=0;i<par->Signal[SIG_WDF].laenge;i++)
	 {
		 x= par->SignalWDF[W(i)];

		 kf = (double)(x-wdfmin)/(wdfmax-wdfmin);
       k = floor(kf * (memwidth-1));
		 if ((k>=0) && (k<memwidth)) wdfx[k]++;

		 if (par->Signal[SIG_Q].folge[i+20] != par->Signal[SIG_V].folge[i+20]) fehlerbits++;
	 }
    sigmam1 += par->sigmam1;
	 sigmam2 += par->sigmam2;
    all = (LONG)d*par->Signal[SIG_WDF].laenge;
    if (all == 0) return;
	 sprintf(s,"%1.6f ",(float)fehlerbits / ((LONG)d*par->Signal[SIG_WDF].laenge));
	 staticfehler->SetText(s);
    m2 = sigmam2/all;
	 m1 = sigmam1/all;
	 sprintf(s,"%1.3f ",m1);
	 staticmittel->SetText(s);

	 m1=m2-m1*m1;

	 if (m1<0) m1=0;
	 sprintf(s,"%1.6f ",sqrt(m1));
	 staticstreuung->SetText(s);
	 editdurchlauf->SetPosition(d);
	 wdfgueltig = FALSE;
	 strcpy(s," ");
	 Parent->Transfer(s,50);

  if (dakt > d) {
								  par->wdfbits=bitsprodurchlauf;
								  par->ParameterUpdate();
							  }

  }



durchlaeufe=durchlaufges;
editdurchlauf->SetPosition(durchlaeufe);


for (i=0;i<30000;i++) {
								 par->Signal[SIG_Q].folge[i] = wahrlistealt[i];
								 par->Signal[SIG_N].folge[i] = nlistealt[i];
								 par->Signal[SIG_E2].folge[i] = e2listealt[i];
							 }

par->altuebernehmen = TRUE;
par->ParameterUpdate();

wdfgueltig = FALSE;
Parent->Invalidate();
eindurchlauf = FALSE;
}


void WDFDialog::SetupWindow ()
{
	 TDialog::SetupWindow();
 	 Initialisierung = INIT_OK;

	 editdurchlauf->SetRange(durchlaeufe,1,100,1,SPIN_EINS,20);
	 checkpar1->Check();
    staticfehler->SetText("  ");
    staticstreuung->SetText("  ");
	 staticwdfwert->SetText("  ");
	 staticmittel->SetText("  ");
}


double WDFDialog::gauss()
{
  double y,z;

  y = prng01();
  z = prng01();
  if (z == 0) z = prng01();

  return(cos(2*M_PI*y) * sqrt(2*log(1/z)));


}






double WDFDialog::prng01(void)
{
  long static k=1234;
  long s, m=0x7FFFFFFF,
  a=16807, q=127773, r=2836;
  s=k/q;
  k=a*(k-q*s)-r*s;
  if (k<=0)
	k+=m;
  return ((double)k/m);
}


