#if !defined(__wdfdial1_h)              // Datei nur benutzen, wenn Sie nicht bereits aufgenommen wurde
#define __wdfdial1_h

/*  Projekt CDMA

    SUBSYSTEM:    CDMA.EXE  (Application)
    DATEI:        wdfdial1.h
    AUTOR:        Wolfgang Knallinger


    UEBERBLICK
    ==========
    Klassendefinition fuer WDFDialog (TDialog).
*/

#include <owl\checkbox.h>
#include <owl\static.h>
#include <owl\edit.h>
#include <owl\owlpch.h>
#pragma hdrstop

#include <owl\dialog.h>

#include "pnapp.rh"            // Definition aller Ressourcen
#include "prmtrdlg.h"


//{{TDialog = WDFDialog}}
struct WDFDialogXfer {
//{{WDFDialogXFER_DATA}}
    char    editdurchlauf[ 255 ];
    char    staticbitsprolauf[ 255 ];
    char    staticfehler[ 255 ];
    char    staticwdfwert[ 255 ];
    BOOL    checkpar1;
    BOOL    checkpar2;
    char    staticstreuung[ 255 ];
    char    staticmittel[ 255 ];
//{{WDFDialogXFER_DATA_END}}
};



class WDFDialog : public TDialog {
public:
    WDFDialog (TWindow* parent, TResId resId = IDD_WDF_DIALG, TModule* module = 0);
    virtual ~WDFDialog ();

    ParameterDialog* par1;
    ParameterDialog* par2;
    ParameterDialog* par;
    int Parametersatz;
    int Initialisierung;
    int durchlaeufe;
    int bitsprodurchlauf;
    LONG wdfx[1300];
    LONG* wdfgross;
    int memwidth;
    LONG wdfmin;
    LONG wdfmax;
    LONG wdflaenge;
    BOOL wdfgueltig;
    int wdfnull;
    BOOL eindurchlauf;
    LONG fehlerbits;
    double prng01();
    double gauss();

    int *wahrlistealt;
    int *nlistealt;
    int *e2listealt;


//{{WDFDialogVIRTUAL_BEGIN}}
public:
    virtual void SetupWindow ();
//{{WDFDialogVIRTUAL_END}}

//{{WDFDialogRSP_TBL_BEGIN}}
public:
    void checkpar1BNClicked ();
    void checkpar2BNClicked ();
    void buttonstartBNClicked ();
//{{WDFDialogRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(WDFDialog);

//{{WDFDialogXFER_DEF}}
public:
    Spinedit *editdurchlauf;
    TStatic *staticbitsprolauf;
    TStatic *staticfehler;
    TStatic *staticwdfwert;
    TCheckBox *checkpar1;
    TCheckBox *checkpar2;
    TStatic *staticstreuung;
    TStatic *staticmittel;

//{{WDFDialogXFER_DEF_END}}
};    //{{WDFDialog}}


#endif                                      // __wdfdial1_h

