/*  Projekt CDMA
	 Copyright  1995
 
	 SYSTEM:       CDMA.EXE  (Application)
	 DATEI:        sigwin.cpp
	 AUTOR:        Wolfgang Knallinger


	 UEBERBLICK
	 ==========
	 Quelltextdatei fuer die Implementation von WDFWin (TWindow).
*/

#include <owl\owlpch.h>
#pragma hdrstop

#include "wdfwin.h"
#include <owl\scroller.h>


//
// Antworttabelle fuer alle von der Anwendung behandelten Botschaften &
// Befehle erzeugen
//
DEFINE_RESPONSE_TABLE1(WDFWin, TWindow)
//{{WDFWinRSP_TBL_BEGIN}}
	 EV_WM_LBUTTONDOWN,
	 EV_WM_SIZE,
	 EV_COMMAND(CM_SIGNALFENSTER, Fenster),
	 EV_WM_LBUTTONDBLCLK,
	 EV_WM_MOUSEMOVE,
	 EV_WM_HSCROLL,
//{{WDFWinRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{WDFWin Implementation}}


WDFWin::WDFWin (TWindow* parent, const char far* title, TModule* module):
	 TWindow(parent, title, module)
{
	 Initialisierung = INIT_START;

	 // Hintergrundfarbe des Fensters aendern
	 SetBkgndColor(RGB(0xc0, 0xc0, 0xc0));
		 Attr.Style |=WS_VISIBLE;
setupzaehler = 0;
fensterzaehler = 0;
	 TClientDC dc(*this);
	 bitmap =  new TBitmap(dc,100,28,TRUE);
	 wdfdia = new WDFDialog(this);
	 bitexist = FALSE;
	 wdfdia->par1=par1;
	 wdfdia->par2=par2;
	 wdfdia->Parametersatz = Parametersatz;
	 wdfdia->wdfgueltig = TRUE;

}


WDFWin::~WDFWin ()
{
	 if (bitmap) delete bitmap;
	 Destroy();


}


void WDFWin::EvLButtonDown (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDown(modKeys, point);


}


void WDFWin::SetupWindow ()
{
	 TWindow::SetupWindow();
	 	 Initialisierung = INIT_OK;

		  char st[255];
		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();
setupzaehler++;


	 string s;
	 bitexist = FALSE;

	 TClientDC dc(*this);
	 TRect rcc = GetClientRect();

	 if (Parametersatz == 1) par = par1;
	 if (Parametersatz == 2) par = par2;
	 wdfdia->par1=par1;
	 wdfdia->par2=par2;
	 wdfdia->Parametersatz = Parametersatz;
	 wdfdia->wdfgueltig = TRUE;
	 wdfdia->Create();
	 TRect rc = GetClientRect();

	 Titelsetzen();
	 rc = GetWindowRect();
	 Parent->MoveWindow(rc.left,rc.top,600,400);
}




void WDFWin::Paint (TDC& dc, BOOL erase, TRect& rc)
{

	 TWindow::Paint(dc, erase, rc);

  if (Initialisierung != INIT_OK) return;


		  TMemoryDC memdc(dc);
		  memdc.SelectObject(*bitmap);

		  dc.BitBlt(0,90,rcc.Width(),rcc.Height(),
						memdc,0,0,SRCCOPY);
		  memdc.RestoreBitmap();
wdfdia->MoveWindow(0,0,rc.right+pixel,90,TRUE);
if (wdfdia->wdfgueltig == FALSE) Fenster();

char s[255];
char s1[255];
int t;// = Scroller->XPos;
sprintf(s,"%d) = %2.2f  ",t,(float)par->Signal[signal].folge[t+20]/100);
if ((signal==SIG_X1)||(signal==SIG_X2)) sprintf(s,"%d) = %d  ",t,(float)par->Signal[signal].folge[t+20]);
strcpy(s1,sst);
strcat(s1,s);


}


void WDFWin::EvSize (UINT sizeType, TSize& size)
{
	 TWindow::EvSize(sizeType, size);
  if (Initialisierung != INIT_OK) return;

	 TRect rc;
	 GetWindowRect(rc);


	 rc = GetWindowRect();

	 wdfdia->eindurchlauf=TRUE;
	 Fenster();
}


void WDFWin::Fenster ()
{
  if (Initialisierung != INIT_OK) return;

	signal=SIG_WDF;
	char ssigtext[255];
	fensterzaehler++;
	if (fensterzaehler<=2)return;
	 rcc = GetClientRect();

	 wdfdia->memwidth = rcc.Width();

if (wdfdia->Parametersatz !=Parametersatz) Parametersatz=wdfdia->Parametersatz;
if (Parametersatz == 1) par = par1; else par = par2;

if (wdfdia->wdfgueltig == TRUE)	 wdfdia->buttonstartBNClicked();


	int scr = par->Signal[signal].laenge - rcc.Width()/par->pixel;
	if (scr < 0) scr = 0;

	 switch(signal)
	 {
		case SIG_Q  : strcpy(ssigtext,"Quellensignal"); strcpy(sst,"q("); break;
		case SIG_X1 : strcpy(ssigtext,"Spreizfolge 1"); strcpy(sst,"x1(");  break;
		case SIG_X2 : strcpy(ssigtext,"Spreizfolge 2"); strcpy(sst,"x2(");  break;
		case SIG_S  : strcpy(ssigtext,"Sendesignal"); strcpy(sst,"s(");  break;
		case SIG_N : strcpy(ssigtext,"Rauschen"); strcpy(sst,"n(");  break;
		case SIG_E1 : strcpy(ssigtext,"Empfang Teilnehmer 1"); strcpy(sst,"e1(");  break;
		case SIG_E2 : strcpy(ssigtext,"Empfang andere Teilnehmer"); strcpy(sst,"e2(");  break;
		case SIG_E  : strcpy(ssigtext,"Empfangssignal"); strcpy(sst,"e(");  break;
		case SIG_R : strcpy(ssigtext,"Ausgang vom RAKE"); strcpy(sst,"r(");  break;
		case SIG_XTKR : strcpy(ssigtext,"x(t-Tkr)"); strcpy(sst,"x(");  break;
		case SIG_B : strcpy(ssigtext,"b(t)"); strcpy(sst,"b(");  break;
		case SIG_D : strcpy(ssigtext,"d(t)"); strcpy(sst,"d(");  break;
		case SIG_V : strcpy(ssigtext,"v(t)"); strcpy(sst,"v(");  break;
		default: strcpy(sst,"X(t)");
	 }

	pixel=par->Signal[signal].pixel;
	int laenge = par->Signal[signal].laenge;
	laenge = 50;
	pixel=5;
	int folglen1=par->laenge1;
	int datenbits = par->Signal[signal].datenbits;

	memwidth = rcc.Width();




	 TClientDC dc(*this);
	 if (bitmap) delete bitmap;
	 bitmap =  new TBitmap(dc,rcc.Width(),rcc.Height()-90,FALSE);
	 bitexist = TRUE;
	 TMemoryDC memdc(dc);
	 memdc.SelectObject(*bitmap);

	 TSize Grid(pixel,pixel);
	 memdc.FillRect(rcc,TBrush(TColor::White));


	 struct sigstruct { int l,r,l0,r0;
							  float min,max;
							} sigpar;

	 sigpar.l=0;
	 sigpar.r=10;
	 sigpar.l0=0;
	 sigpar.r0=laenge;
	 int min=par->Signal[signal].min;
	 int max=par->Signal[signal].max;

	 sigpar.min = min - (max-min)*0.2;
	 sigpar.max = max + (max-min)*0.25;

	 int i;
	 LONG y,xf;
	 float yp;
	 LONG ymax = rcc.Height()-90;
	 LONG xmax = memwidth;

LONG yp0,yp1;
LONG x;
int x1,x2,y1,y2;
x1=par->laenge1*pixel;
if ((signal == SIG_S) || (signal == SIG_E1))
  {
	 TBrush br(RGB(164,200,240));

	 yp0=ymax+sigpar.min*ymax/(sigpar.max-sigpar.min);
	 for( i=0;i<par->Signal[SIG_Q].laenge;i++)
		{

		  yp1=rcc.top;
		  if (par->Signal[SIG_Q].folge[i+20]<0)yp1=rcc.bottom;

		  memdc.FillRect(x1*i+1,yp0,x1*(i+1),yp1,br);

		}


  }

	 for (i = 0; i < rcc.bottom; i += Grid.cy)
		  for (int j = 0; j < rcc.right; j += Grid.cx);


LONG wdfbig = 1;
for (i=0;i<memwidth;i++) { if (wdfdia->wdfx[i]>wdfbig) wdfbig=wdfdia->wdfx[i]; }
	 TPen pn5(RGB(0,180,0),1,PS_SOLID);
 memdc.SelectObject(pn5);
if (wdfbig == 0) wdfbig = 1;
for (i=0;i<memwidth;i++)
  {
	 yp = ymax - ( wdfdia->wdfx[i] * ymax / wdfbig);
	 memdc.MoveTo(i,rcc.bottom);
	 memdc.LineTo(i,yp);
  }
 TPen pn6(RGB(0,0,200),1,PS_SOLID);
 memdc.SelectObject(pn6);
 for (i=0;i<=rcc.bottom;i++)
  if (i%15<7) memdc.SetPixel(wdfdia->wdfnull,i,RGB(0,0,255));

	 memdc.RestoreBitmap();
wdfdia->wdfgueltig = TRUE;

Invalidate(FALSE);
UpdateWindow();
return;







if ((signal>=SIG_R)&&(signal<=SIG_D))
  {
			 TPen pn0(RGB(0,128,0),1,PS_DASH);
			 memdc.SelectObject(pn0);
			 for (int j = 0; j < rcc.right; j += pixel*par->laenge1)
				{
				  memdc.MoveTo(j+par->rakelen*pixel,0);
				  memdc.LineTo(j+par->rakelen*pixel,rcc.bottom);
				}

  }



	 for (i=0;i<500;i++) look[i]=par->Signal[signal].folge[i+20];


  yp = ymax - ((0-sigpar.min) * ymax / (sigpar.max-sigpar.min));
			 TPen pn4(RGB(0,0,200),1,PS_DOT);
			 memdc.SelectObject(pn4);
			 memdc.MoveTo(0,yp);
			 memdc.LineTo(rcc.right,yp);

	 TPen pn1(RGB(0,0,0),1,PS_SOLID);
	 TPen pn2(RGB(255,0,0),1,PS_SOLID);
 if (par->Parametersatz == 1) memdc.SelectObject(pn1);
	else  memdc.SelectObject(pn2);


  yp = ymax - ((par->Signal[signal].folge[20]-sigpar.min) * ymax / (sigpar.max-sigpar.min));

  memdc.MoveTo(0,yp);

	 for(x=0;x<xmax;x++)
		{
		  xf = x * laenge / xmax;
		  yp = ymax - ((par->Signal[signal].folge[xf+20]-sigpar.min) * ymax / (sigpar.max-sigpar.min));

		  memdc.LineTo(x,yp);
		  memdc.LineTo(x+1,yp);

		}


	 memdc.RestoreBitmap();
	 Invalidate();

}




void WDFWin::EvLButtonDblClk (UINT modKeys, TPoint& point)
{
	 TWindow::EvLButtonDblClk(modKeys, point);

}

void WDFWin::Titelsetzen()
{
  if (Initialisierung != INIT_OK) return;

	 strcpy(title,"WDF");
	 Parent->SetWindowText(title);

}


void WDFWin::EvMouseMove (UINT modKeys, TPoint& point)
{
 char s[255];
 strcpy(s,"  ");
	 TWindow::EvMouseMove(modKeys, point);
  if (Initialisierung != INIT_OK) return;

char s1[255];

LONG x = point.x;
double k = ((double)x * (wdfdia->wdfmax-wdfdia->wdfmin) / memwidth ) + wdfdia->wdfmin;
float w = (float)wdfdia->wdfx[x] / wdfdia->wdflaenge;

sprintf(s,"WDF(%3.2f) = %1.3f  ",k/1000/wdfdia->par->Signal[SIG_X1].laenge,w);

wdfdia->staticwdfwert->SetText(s);


		  TApplication* app=GetApplication();
		  TFrameWindow* frame =app->GetMainWindow();
		  TWindow* client = frame->GetClientWindow();

		  if (par1->folgegueltig == FALSE) client->Transfer(s,5);
		  if (par2->folgegueltig == FALSE) client->Transfer(s,6);

}





UINT WDFWin::Transfer (void* buffer, TTransferDirection direction)
{
	 UINT result;
  if (Initialisierung != INIT_OK) return 0;


	 if (direction <= 2 ) result = TWindow::Transfer(buffer, direction);
	 else
		{
			if (direction == 50) Fenster();
			if (direction == 3)
									 {
										if (Parametersatz == 1)
																		{
																		  wdfdia->eindurchlauf = TRUE;
																		  Fenster();
																		}
									 }

			if (direction == 4)
									 {
										if (Parametersatz == 2)
																		{
																		  wdfdia->eindurchlauf = TRUE;;
																		  Fenster();
																		}
									 }

int t;
int p = par->ScrollPos;
if ((signal==SIG_Q) || (signal == SIG_V)) p=p/par->laenge1;
			if (direction == 11)
									 {
										if (Parametersatz == 1)
																		{
																		  if (t != p)
																		if (0 == TRUE) ;
																		}
									 }

			if (direction == 12)
									 {
										if (Parametersatz == 2)
																		{
																		  if (t != p)
                                                         if (0 == TRUE) ;
																		}
									 }

		}
	 return result;
}



void WDFWin::EvHScroll (UINT scrollCode, UINT thumbPos, HWND hWndCtl)
{
	 TWindow::EvHScroll(scrollCode, thumbPos, hWndCtl);
/*
int t;
if ((signal==SIG_Q) || (signal == SIG_V)) t=t*par->laenge1;
int p = par->ScrollPos;
  if (t!=p) {
				 par->ScrollPos = t;
				  TApplication* app=GetApplication();
				  TFrameWindow* frame =app->GetMainWindow();
				  TWindow* client = frame->GetClientWindow();
				  char s[255];
				  strcpy(s,"  ");

				 if (Parametersatz == 1) client->Transfer(s,21);
				 if (Parametersatz == 2) client->Transfer(s,22);
				 }

*/
}



